<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Home extends MY_Front_Controller{
    public function __construct(){
        parent::__construct();
        $this->load->model('HomeModel', 'homeModel', true);
    }
    public function index(){
        $data         = array(
            'view'         => 'home',
//            'blogHomePage' => $this->homeModel->getBlogHomePage(),
            'sliders'      => $this->homeModel->getAllSliders(),
            'aboutUs'      => $this->aboutUs,
            'events'       => $this->events,
            'causes'       => $this->causes,
            'menu'         => $this->menu,
            'widgets'      => $this->widgets
        );
        $this->load->view('template', $data);
    }
    public function page(){
        $pageId   = get('token');
        $pageData = $this->homeModel->getPages($pageId);
        if(empty($pageData)){
            redirect(SITE_URL . "home");
        }
        $data = array(
            'view'         => 'page',
            'pageData'     => $pageData[0],
            'menu'         => $this->menu,
            'testimonials' => $this->homeModel->getAlltestimonials()
        );
        $this->load->view('template', $data);
    }
    public function viewAllPosts(){
        $data = array(
            'view'       => 'allEvents',
            'allEvents'  => $this->allEvents,
            'rightPanel' => $this->rightPanel,
            'menu'       => $this->menu,
            'allPages'   => $this->allPages
        );
        $this->load->view('template', $data);
    }
    public function viewEvent(){
        $eId      = get('token');
        $getEvent = $this->homeModel->getEventbyId($eId);
        $data     = array(
            'view'       => 'viewEvent',
            'event'      => $getEvent,
            'allEvents'  => $this->allEvents,
            'rightPanel' => $this->rightPanel,
            'menu'       => $this->menu,
            'allPages'   => $this->allPages
        );
        $this->load->view('template', $data);
    }
    public function viewGallery(){
        $data = array(
            'view'    => 'gallery',
            'gallery' => $this->homeModel->getAlbumsForGallery(),
            'menu'    => $this->menu
        );
        $this->load->view('template', $data);
    }
}
?>