<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
class Questions extends MY_Front_Controller{
    public function __construct(){
        parent::__construct();
        $this->load->model('QuestionsModel', 'questionsModel', true);
        $this->load->library('pagination');
    }
    public function index(){
        $config['base_url']    = base_url() . 'questions/index';
        $config['total_rows']  = $this->questionsModel->getQuestionsCount();
        $config['per_page']    = 3;
        $config['uri_segment'] = 3;
        $config['next_link']   = 'Next';
        $config['prev_link']   = 'Previous';
        $this->pagination->initialize($config);
        $page                  = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
//        pre($allQuestions); die;
        $data                  = array(
            'view'      => 'questions',
            'menu'      => $this->menu,
            'questions' => $this->questionsModel->getAllQuestions($config['per_page'], $page),
            'links'     => $this->pagination->create_links()
        );
        $this->load->view('template', $data);
    }
    public function askQuestion(){
        $data       = array(
            'view' => 'askQuestion',
            'menu' => $this->menu,
        );
        $this->load->view('template', $data);
    }
    public function saveQuestion(){
        $user_sess_id = $this->session->userdata('user_id');
        if(empty($user_sess_id)){
            $message = array('type' => 'login');
            echo json_encode($message);
            return false;
        }
        $approved = 'y';
        if($this->approval_flag_home[13] == 'y'){
            $approved = 'n';
        }
        $anonymousCheck = $this->input->post('anonymous');
        $anonymous      = ($anonymousCheck == 'on') ? 1 : 0;
        $insData        = array(
            'question_id'   => decrypt($this->input->post('questionId')),
            'user_id'       => $this->session->userdata('user_id'),
            'question'      => $this->input->post('question'),
            'description'   => $this->input->post('description'),
            'approved'      => $approved,
            'creation_date' => date("Y-m-d H:i:s"),
            'updation_date' => date("Y-m-d H:i:s"),
            'updation_date' => $this->session->userdata('user_id'),
            'is_anonymous'  => $anonymous
        );
        $message        = $this->questionsModel->addUpdateQuestion($insData);
        if($message['type'] == 'success'){
            echo json_encode($message);
            exit();
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function myQuestions(){
        $user_id     = $this->session->userdata('user_id');
        $myQuestions = $this->questionsModel->getQuestionByUserId($user_id);
        $data        = array(
            'view'       => 'questions',
            'menu'       => $this->menu,
            'questions'  => $myQuestions
        );
        $this->load->view('template', $data);
    }
}
?>