<?php
class Testimonials extends MY_Front_Controller{
    public function __construct(){
        parent::__construct();
        $this->load->model('TestimonialModel', 'testimonialModel', true);
    }
    public function index(){
        $allTestimonials = $this->testimonialModel->getAllTestimonials();
        $data            = array(
            'view'            => 'testimonials',
            'allTestimonials' => $allTestimonials,
            'allEvents'       => $this->allEvents,
            'allPages'        => $this->allPages,
            'menu'            => $this->menu,
            'rightPanel'      => $this->rightPanel
        );
        $this->load->view('template', $data);
    }
    public function addTestimonial(){
        $user_id = $this->session->userdata('user_id');
        if(empty($user_id)){
            echo json_encode(array('type' => 'login'));
            exit();
        }
        $approval = ($this->approval_flag_home[10] == 'y') ? 'n' : 'y';
        $insData  = array(
            'first_name'    => post('firstName'),
            'last_name'     => post('lastName'),
            'email'         => post('email'),
            'testimonial'   => post('testimonial'),
            'approved'      => $approval,
            'creation_date' => date("Y-m-d")
        );
        $insId    = $this->testimonialModel->insertTestimonial($insData);
        $this->uploadUserPhoto($insId);
        if($insId){
            $message = array('type' => 'success', 'message' => 'Testimonial updated successfully. Once approved by the admin, it will be visible on this website.');
        }
        if($message['type'] == 'error'){
            echo json_encode($message);
            exit;
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function uploadUserPhoto($testimonial_id){
        if(!empty($_FILES['photo']['name'])){
            $tmpFilePath = $_FILES['photo']['tmp_name'];
            if($tmpFilePath != ""){
                $path = SITE_ROOT . "skin/images/testimonialImages/";
                if(!is_dir($path)){
                    mkdir($path);
                }
                $name = $_FILES['photo']['name'];

                list($tempFileName, $ext) = explode(".", $name);
                $fileName = uniqid() . "." . $ext;
            }
            move_uploaded_file($_FILES['photo']['tmp_name'], $path . $fileName);
            $insImageData = array(
                'photo' => $fileName
            );
            $insImage     = $this->testimonialModel->insertUserPhoto($testimonial_id, $insImageData);
        }
    }
}
?>