<?php
if(!defined('BASEPATH'))
    exit('No direct script access allowed');
class User extends CI_Controller{
    public function __construct(){
        parent::__construct();
        $this->load->model('UserModel', 'userModel', TRUE);
    }
    public function index(){
        $this->load->view('login');
    }
    public function loginUser(){
        $message  = array(
            'type'    => 'error',
            'message' => 'Invalid username or password'
        );
        $email    = $this->input->post('email');
        $password = $this->input->post('password');
        if($email == '' || $password == ''){
            echo json_encode($message);
            exit();
        }
        $password = md5($password);
        $data     = $this->userModel->validateLogin($email, $password);
        if(empty($data)){
            echo json_encode($message);
            exit();
        }
        $this->session->set_userdata('user_id', $data->user_id);
        $this->session->set_userdata('first_name', $data->first_name);
        $this->session->set_userdata('last_name', $data->last_name);
        $message = array(
            'type'    => 'success',
            'message' => 'Logging you in.',
        );
        if($message['type'] == 'success'){
            setSessionMsg($message['type'], $message['message']);
        }
        echo json_encode($message);
        exit();
    }
    public function logout(){
        $this->session->sess_destroy();
        redirect(SITE_URL);
    }
    public function registerUser(){
        $this->load->view('register');
    }
    public function saveUserData(){
        $insUserData  = array(
            'first_name'    => $this->input->post('firstName'),
            'last_name'     => $this->input->post('lastName'),
            'email_id'      => $this->input->post('email'),
            'user_name'     => $this->input->post('username'),
            'password'      => $this->input->post('password'),
            'user_type'     => 'user',
            'creation_date' => date("Y-m-d H:i:s")
        );
        $confPassword = $this->input->post('confirmPassword');
        if(empty($insUserData['password']) || empty($confPassword)){
            $dispMsg = array('type' => 'error', 'message' => 'Please provide password and confirm password.');
            echo json_encode($dispMsg);
            return false;
        }
        if($insUserData['password'] != $confPassword){
            $dispMsg = array('type' => 'error', 'message' => 'The password and confirm passwords are not the same.');
            echo json_encode($dispMsg);
            return false;
        }
        if(!empty($insUserData['password']) && !empty($confPassword)){
            if(!valid_pass($insUserData['password'])){
                $dispMsg = array('type' => 'error', 'message' => 'Please provide complex password.');
                echo json_encode($dispMsg);
                return false;
            }
        }
        $message = $this->userModel->addNewUser($insUserData);
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
        exit();
    }
    public function saveContactDetails(){
        $insData = array(
            'name'       => $this->input->post('name'),
            'email'      => $this->input->post('email'),
            'message'    => $this->input->post('message'),
            'created_on' => date("Y-m-d H:i:s")
        );
        $message = $this->userModel->saveContactData($insData);
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
}
?>