<?php
class Blogs extends MY_Controller{
    public function __construct(){
        parent::__construct(11);
        $this->load->model('admin/BlogsModel', 'blogModel', true);
    }
    public function index(){
        $blogData     = array();
        $listComments = '';
        $blogId       = decrypt(get('token'));
        $edit         = false;
        if(!empty($blogId)){
            $blogData     = $this->blogModel->getBlogDataById($blogId);
            $comments     = $this->blogModel->getAllComments($blogId);
            $listComments = $this->listComments(0, $comments);
            if(empty($blogData)){
                $this->session->set_flashdata('Invalid ID');
                redirect(SITE_URL . "admin/dashboard");
            }
            $edit = true;
        }
        $data = array(
            'blogData' => $blogData,
            'comments' => $listComments,
            'allBlogs' => $this->blogModel->getBlogs(),
            'edit'     => $edit
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/blogs', $data);
        $this->load->view('admin/common/footer');
    }
    public function addBlog(){
        $publishCheck = post('publish');
        if($this->approval_flag[11] == 'y'){
            if($publishCheck == 'on'){
                $publish = 'y';
            }else{
                $publish = 'n';
            }
        }else{
            $publish = 'y';
        }
        $blogTitle = strtolower(post('blogTitle'));
        $blogKey   = preg_replace('#[ -]+#', '-', trim($blogTitle));
        $insData   = array(
            'blog_id'       => post('blogId'),
            'blog_key'      => $blogKey,
            'title'         => post('blogTitle'),
            'content'       => post('blogContent'),
            'seo_title'     => post('seoTitle'),
            'seo_desc'      => post('seoDesc'),
            'seo_keywords'  => post('seoKeywords'),
            'publish'       => $publish,
            'creation_date' => date("Y-m-d"),
            'created_by'    => $this->session->userdata('user_id'),
            'updation_date' => date("Y-m-d"),
            'updated_by'    => $this->session->userdata('user_id')
        );
        $message   = $this->blogModel->insertUpdateBlog($insData);
        if($message['type'] == 'error'){
            echo json_encode($message);
            exit;
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function delBlog(){
        $delBid  = decrypt(post('delBid'));
        $this->blogModel->deleteBlog($delBid);
        $message = array('type' => 'success', 'message' => 'Blog deleted successfully');
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function uploadBlogImage(){
        $url         = $_SERVER['REQUEST_URI']; //returns the current URL
        $parts       = explode('/', $url);
        $actual_link = $_SERVER['SERVER_NAME'];
        for($i = 0; $i < count($parts) - 1; $i++){
            $actual_link .= $parts[$i] . "/";
        }
        $target_dir  = SITE_ROOT . "skin/images/blogImages/";
        $imgName     = uniqid() . basename($_FILES["file"]["name"]);
        $target_file = $target_dir . $imgName;

        if(move_uploaded_file($_FILES["file"]["tmp_name"], $target_file)){
            $rs  = SITE_URL . "skin/images/blogImages/" . $imgName;
            $arr = array(
                'url' => $rs
            );
        }else{
            $arr = array(
                'url' => null
            );
        }
        echo json_encode($arr);
    }
    public function listComments($parent, $comments){
        $cmntBy       = "";
        $cmntDeleted  = "";
        $commentsView = "";
        $approveLabel = "<span class='label label-danger'>Not Approved</span>";
        if(!empty($comments['parents'][$parent])){
            $commentsView .= "<ul>";
            foreach($comments['parents'][$parent] as $itemId){
                $cmntBy = "(by: " . $comments['items'][$itemId]->name . " | " . find_diff_comment($comments['items'][$itemId]->comment_date, date("Y-m-d H:i:s")) . ")";
                if($comments['items'][$itemId]->approved == 'y'){
                    $approveLabel = "<span class='label label-success'>Approved</span>";
                }
                if($comments['items'][$itemId]->deleted == 'y'){
                    $cmntDeleted = "<b>(deleted)</b>";
                }
                if(empty($comments['parents'][$itemId])){
                    $commentsView .= "<li>" . $comments['items'][$itemId]->comment . $cmntDeleted . "&nbsp;&nbsp;" . $cmntBy;
                    $commentsView .= $approveLabel . "</li>";
                }
                if(!empty($comments['parents'][$itemId])){
                    $commentsView .= "<li>" . $comments['items'][$itemId]->comment . $cmntDeleted . "&nbsp;&nbsp;" . $cmntBy;
                    $commentsView .= $approveLabel;
                    $commentsView .= $this->listComments($itemId, $comments);
                    $commentsView .= "</li>";
                }
            }
            $commentsView .= "</ul>";
        }
        return $commentsView;
    }
    public function updHomepageStatus(){
        $blog_id = decrypt($this->input->post('blog_id'));
        $message = $this->blogModel->changeHomepageStatus($blog_id);
        if($message['type'] == 'success') {
            setSessionMsg($message['type'], $message['message']);
        }
        echo json_encode($message);
    }
    public function publishBlog() {
        $blog_id = $this->input->post('blog_id');
        $message = $this->blogModel->publishBlog($blog_id);
        if($message['type'] == 'success') {
            setSessionMsg($message['type'], $message['message']);
        }
        echo json_encode($message);
    }
}
?>