<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
class Categories extends MY_Controller{
    public function __construct(){
        parent::__construct(13);
        $this->load->model('admin/CategoriesModel', 'categoriesModel', true);
    }
    public function index(){
        $categories = $this->categoriesModel->getCategoriesForView();
        $categoryId = decrypt(get('token'));
        $form       = (object) array(
                'category_id'   => '',
                'category_name' => '',
                'parent'        => '',
                'hierarchy'     => '',
                'submit'        => 'Add'
        );
        $edit       = false;
        if(!empty($categoryId)){
            $form         = $this->categoriesModel->getCategoryById($categoryId);
            $form->submit = 'Update';
            $edit         = true;
        }
        $getCatStructure = $this->createCategoryTree(0, $categories);
        $data            = array(
            'form'         => $form,
            'categories'   => $this->categoriesModel->getAllCategories(),
            'catStructure' => $getCatStructure,
            'edit'         => $edit
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/categories', $data);
        $this->load->view('admin/common/footer');
    }
    public function saveCategory(){
        $catApproveCheck = $this->input->post('approval');
        $approve         = 'n';
        if($catApproveCheck == 'on'){
            $approve = 'y';
        }
        $postData = array(
            'category_id'   => decrypt(post('categoryId')),
            'category_name' => strtolower(post('categoryName')),
            'parent'        => post('categoryParent'),
            'creation_date' => date("Y-m-d"),
            'approved'      => $approve,
            'created_by'    => $this->session->userdata('user_id'),
            'updation_date' => date("Y-m-d"),
            'updated_by'    => $this->session->userdata('user_id')
        );
        $message  = $this->categoriesModel->addUpdateCategory($postData);
        if($message['type'] == 'error'){
            echo json_encode($message);
            exit();
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function createCategoryTree($parent, $categories){
        $catArray = "";
        if(!empty($categories['parents'][$parent])){
            $catArray .= "<ul>";
            foreach($categories['parents'][$parent] as $itemId){
                if(empty($categories['parents'][$itemId])){
                    $catArray .= "<li>" . ucwords($categories['items'][$itemId]->category_name) . "</li>";
                }
                if(!empty($categories['parents'][$itemId])){
                    $catArray .= "<li>" . ucwords($categories['items'][$itemId]->category_name);
                    $catArray .= $this->createCategoryTree($itemId, $categories);
                    $catArray .= "</li>";
                }
            }
            $catArray .= "</ul>";
        }
        return $catArray;
    }
    public function delCategory(){
        $catId             = decrypt(post('token'));
        $checkCatHierarchy = $this->categoriesModel->checkCategoryForChild($catId);
        if($checkCatHierarchy){
            $message = array('type' => 'error', 'message' => 'A child category is still associated with this category.');
        }else{
            $this->categoriesModel->deleteCategory($catId);
            $message = array('type' => 'success', 'message' => 'Category deleted successfully');
            setSessionMsg($message['type'], $message['message']);
        }
        echo json_encode($message);
    }
    public function approveCategory(){
        $category_id = $this->input->post('category_id');
        $this->categoriesModel->approveCategory($category_id);
        $message     = array('type' => 'success');
        echo json_encode($message);
    }
}
?>