<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
class Causes extends MY_Controller{
    public function __construct(){
        parent::__construct(14);
        $this->load->model('admin/CausesModel', 'causesModel', true);
    }
    public function index(){
        $causeData  = (object) array(
                'cause_id'    => '',
                'title'       => '',
                'description' => '',
                'image'       => '',
                'publish'     => '',
                'submit'      => 'Add'
        );
        $cause_text = 'Add A Cause';
        $edit       = false;
        $causeId    = decrypt(get('token'));
        if(!empty($causeId)){
            $causeData = $this->causesModel->getCauseById($causeId);
            if(empty($causeData)){
                $this->session->set_flashdata('Invalid ID');
                redirect(SITE_URL . "admin/dashboard");
            }
            $causeData->submit = 'Update';
            $cause_text        = 'Edit Cause';
            $edit              = true;
        }
        $data = array(
            'causeData'  => $causeData,
            'allCauses'  => $this->causesModel->getAllCauses(),
            'cause_text' => $cause_text,
            'edit'       => $edit,
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/causes', $data);
        $this->load->view('admin/common/footer');
    }
    public function addUpdateCause(){
        $publishCheck = post('publish');
        if($publishCheck == 'on'){
            $publish = 'y';
        }else{
            $publish = 'n';
        }
        $insCauseData = array(
            'cause_id'      => decrypt($this->input->post('causeId')),
            'title'         => $this->input->post('causeTitle'),
            'description'   => $this->input->post('causeDesc'),
            'publish'       => $publish,
            'creation_date' => date("Y-m-d H:i:s"),
            'created_by'    => $this->session->userdata('user_id'),
            'updation_date' => date("Y-m-d H:i:s"),
            'updated_by'    => $this->session->userdata('user_id'),
        );
        $causeId      = decrypt($this->input->post('causeId'));
        if(!empty($causeId)){
            $updateCause = $this->causesModel->insertUpdateCause($insCauseData);
            if(!$updateCause){
                $message = array('type' => 'error', 'message' => 'Cause already exists.');
            }else{
                $message = $this->saveCauseImage($causeId, 'update');
            }
        }else{
            $insertCause = $this->causesModel->insertUpdateCause($insCauseData);
            if(!$insertCause){
                $message = array('type' => 'error', 'message' => 'Cause already exists.');
            }else{
                $message = $this->saveCauseImage($insertCause, 'insert');
            }
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function saveCauseImage($causeId, $qryType){
        if(!empty($_FILES['causeImage']['name'][0])){
            // Remove the old cause Image.
            $getCauseData = $this->causesModel->getCauseById($causeId);
            $causeImage   = $getCauseData->image;
            $oldImgPath   = SITE_ROOT . "skin/images/causes/" . $causeImage;
            if(is_file($oldImgPath)){
                unlink($oldImgPath);
            }
            // Save the new Image for the cause
            $tmpFilePath = $_FILES['causeImage']['tmp_name'];
            if($tmpFilePath != ""){
                $path = SITE_ROOT . "skin/images/causes/";
                if(!is_dir($path)){
                    mkdir($path);
                }
                $name = $_FILES['causeImage']['name'];

                list($tempFileName, $ext) = explode(".", $name);
                $fileName = uniqid() . "." . $ext;
            }
            move_uploaded_file($_FILES['causeImage']['tmp_name'], $path . $fileName);
            $insImageData = array(
                'image' => $fileName
            );
            $insImage     = $this->causesModel->insertCauseImage($causeId, $insImageData);
        }
        if($qryType == 'insert'){
            return array('type' => 'success', 'message' => 'Cause Added successfully.');
        }else{
            return array('type' => 'success', 'message' => 'Cause Updated successfully.');
        }
    }
    public function delCause(){
        $cId     = decrypt(post('cId'));
        $this->deleteCauseImage($cId);
        $this->causesModel->deleteCause($cId);
        $message = array('type' => 'success', 'message' => 'Cause deleted successfully');

        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function deleteCauseImage($cId){
        $causeData  = $this->causesModel->getCauseById($cId);
        $causeImage = $causeData->image;
        $imagePath  = SITE_ROOT . "skin/images/causes/" . $causeImage;
        if(is_file($imagePath)){
            unlink($imagePath);
        }
    }
    // Function to publish Cause
    public function publishCause(){
        $cId     = decrypt($this->input->post('cId'));
        $message = $this->causesModel->publishCause($cId);
        if($message['type'] == 'success'){
            setSessionMsg($message['type'], $message['message']);
        }
        echo json_encode($message);
    }
}
?>