<?php
class Comments extends MY_Controller{
    public function __construct(){
        parent::__construct(12);
        $this->load->model('admin/CommentsModel', 'commentsModel', true);
    }
    public function index(){
        $blogData = $this->commentsModel->getAllBlogs();
        $data     = array(
            'blogs' => $blogData
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/comments', $data);
        $this->load->view('admin/common/footer');
    }
    public function getComments(){
        $blog_id                    = $this->input->post('blog_id');
        $comments                   = $this->commentsModel->getComments($blog_id);
        $blogData                   = $this->commentsModel->getBlogById($blog_id);
        $commentsView['blog_title'] = "<b>" . $blogData->title . "</b>";
        $commentsView['comments']   = $this->listComments(0, $comments);
        if($commentsView['comments'] == ''){
            $commentsView['comments'] = "No Comment(s) found.";
            echo json_encode($commentsView);
            exit();
        }
        echo json_encode($commentsView);
    }
    public function listComments($parent, $comments){
        $subGrp       = $this->a_sub_group_id[0];
        $access       = $this->a_access[$subGrp];
        $cmntBy       = "";
        $commentsView = "";
        $comment_id   = "";
        if(!empty($comments['parents'][$parent])){
            $commentsView .= "<ul>";
            foreach($comments['parents'][$parent] as $itemId){
                if($access->edit_rights == 'y'){
                    $comment_id = encrypt($comments['items'][$itemId]->comment_id);
                }
                $cmntBy = "(by: " . $comments['items'][$itemId]->name . " | " . find_diff_comment($comments['items'][$itemId]->comment_date, date("Y-m-d H:i:s")) . ")";
                if($comments['items'][$itemId]->approved == 'y'){
                    $approveLabel = "<span class='label label-success'>Approved</span>";
                }else{
                    $approveLabel = "<span class='label label-danger'>Not Approved</span>";
                }
                if($comments['items'][$itemId]->deleted == 'y'){
                    $cmntDeleted = "<b>(deleted)</b>";
                }else{
                    $cmntDeleted = "";
                }
                if(empty($comments['parents'][$itemId])){
                    $commentsView .= "<li>" . $comments['items'][$itemId]->comment . $cmntDeleted . "&nbsp;&nbsp;" . $cmntBy;
                    $commentsView .= "<a href='javascript:void(0)' b_id='" . $comments['items'][$itemId]->blog_id . "' c_data='" . $comment_id . "' class='approveCmnt'> " . $approveLabel . " </a>&nbsp;";
                    $commentsView .= "<a href='javascript:void(0)' b_id='" . $comments['items'][$itemId]->blog_id . "' c_data='" . $comment_id . "' class='deleteCmnt'><span class='fa fa-remove'>Delete</span></a>"
                        . "</li>";
                }
                if(!empty($comments['parents'][$itemId])){
                    $commentsView .= "<li>" . $comments['items'][$itemId]->comment . $cmntDeleted . "&nbsp;&nbsp;" . $cmntBy;
                    $commentsView .= "<a href='javascript:void(0)' b_id='" . $comments['items'][$itemId]->blog_id . "' c_data='" . $comment_id . "' class='approveCmnt'> " . $approveLabel . " </a>&nbsp;";
                    $commentsView .= "<a href='javascript:void(0)' b_id='" . $comments['items'][$itemId]->blog_id . "' c_data='" . $comment_id . "' class='deleteCmnt'><span class='fa fa-remove'>Delete</span></a>";
                    $commentsView .= $this->listComments($itemId, $comments);
                    $commentsView .= "</li>";
                }
            }
            $commentsView .= "</ul>";
        }
        return $commentsView;
    }
    public function approveCmnt(){
        $comment_id = $this->input->post('comment_id');
        $message    = $this->commentsModel->approveComment($comment_id);
        if($message['type'] == 'success'){
            setSession($message['type'], $message['message']);
        }
        echo json_encode($message);
    }
    public function deleteCmnt(){
        $comment_id = $this->input->post('comment_id');
        $message    = $this->commentsModel->deleteComment($comment_id);
        if($message['type'] == 'success'){
            setSession($message['type'], $message['message']);
        }
        echo json_encode($message);
    }
}
?>