<?php
class Events extends MY_Controller{
    public function __construct(){
        parent::__construct(8);
        $this->load->model('admin/EventsModel', 'eventsModel', true);
    }
    public function index(){
        $eventData = array();
        $eventId   = decrypt(get('token'));
        $edit      = false;
        if(!empty($eventId)){
            $eventData = $this->eventsModel->getEventDataById($eventId);
            if(empty($eventData)){
                $this->session->set_flashdata('Invalid ID');
                redirect(SITE_URL . "admin/dashboard");
            }
            $edit = true;
        }
        $allEvents = $this->eventsModel->getEvents();
        $data      = array(
            'eventData' => $eventData,
            'allEvents' => $allEvents,
            'edit'      => $edit
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/addEvents', $data);
        $this->load->view('admin/common/footer');
    }
    public function addEvent(){
        // Upload Event Image
        if(!empty($_FILES['eventImage']['name'])){
            $tmpFilePath = $_FILES['eventImage']['tmp_name'];
            if($tmpFilePath != ""){
                $path = SITE_ROOT . "skin/images/eventImages/";
                if(!is_dir($path)){
                    mkdir($path);
                }
                $name = $_FILES['eventImage']['name'];

                list($tempFileName, $ext) = explode(".", $name);
                $fileName = uniqid() . "." . $ext;
            }
            move_uploaded_file($_FILES['eventImage']['tmp_name'], $path . $fileName);
        }
        $publishCheck = $this->input->post('publish');
        if($publishCheck == 'on'){
            $publish = 'y';
        }else{
            $publish = 'n';
        }
        if(!empty(decrypt(post('eventId')))){
            $getImg   = $this->eventsModel->getEventById(decrypt(post('eventId')));
            $fileName = $getImg->event_image;
        }
        $insData = array(
            'event_id'      => decrypt($this->input->post('eventId')),
            'title'         => $this->input->post('eventTitle'),
            'description'   => $this->input->post('eventDescription'),
            'content'       => $this->input->post('eventContent'),
            'venue'         => $this->input->post('eventVenue'),
            'event_image'   => $fileName,
            'seo_title'     => $this->input->post('seoTitle'),
            'seo_desc'      => $this->input->post('seoDesc'),
            'seo_keywords'  => $this->input->post('seoKeywords'),
            'publish'       => $publish,
            'creation_date' => date("Y-m-d"),
            'created_by'    => $this->session->userdata('user_id'),
            'updation_date' => date("Y-m-d"),
            'updated_by'    => $this->session->userdata('user_id')
        );
        $eventId = $insData['event_id'];
        if(!empty($eventId) && !empty($_FILES['eventImage']['name'])){
            // Remove Old Image For The Event
            $getImage  = $this->eventsModel->getEventById($eventId);
            $image     = $getImage->event_image;
            $imagePath = SITE_ROOT . "skin/images/eventImages/" . $image;
            if(file_exists($imagePath)){
                unlink($imagePath);
            }
            $updateEvent = $this->eventsModel->insertUpdateEvent($insData);
            if(!$updateEvent){
                $message = array('type' => 'error', 'message' => 'Event already exists.');
            }else{
                $message = $this->insertEventDates($eventId);
            }
        }else{
            $insertEvent = $this->eventsModel->insertUpdateEvent($insData);
            if(!$insertEvent){
                $message = array('type' => 'error', 'message' => 'Event already exists.');
            }else{
                $message = $this->insertEventDates($insertEvent);
            }
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
//        $this->session->set_flashdata('message', $message['message']);
    }
    public function insertEventDates($eventId){
        // Update Old Dates
        $eventUpdDate     = post_array('eventUpdDate');
        $eventUpdFromTime = post_array('eventUpdFromTime');
        $eventUpdToTime   = post_array('eventUpdToTime');
        $dateIds          = post_array('eventDateHD');
        if(!empty($dateIds)){
            foreach($dateIds as $k => $v){
                $date     = strtotime(dateToDbFromUsDate($eventUpdDate[$k]) . " " . timeFormat($eventUpdFromTime[$k]));
                $currDate = strtotime(date("Y-m-d h:i"));
                if($date > $currDate){
                    $updDateData = array(
                        'event_date'      => dateToDbFromUsDate($eventUpdDate[$k]),
                        'event_from_time' => timeFormat($eventUpdFromTime[$k]),
                        'event_to_time'   => timeFormat($eventUpdToTime[$k]),
                        'updation_date'   => date("Y-m-d"),
                        'updated_by'      => $this->session->userdata('user_id')
                    );
                    $affRows     = $this->eventsModel->updateDates($updDateData, decrypt($v));
                }
            }
            $message = array('type' => 'success', 'message' => 'Event Data updated successfully.');
        }
        //Insert New Dates
        $eventDate     = post_array('eventDate');
        $eventFromTime = post_array('eventFromTime');
        $eventToTime   = post_array('eventToTime');
        if(!empty($eventDate)){
            foreach($eventDate as $k => $value){
                $fromTime = timeFormat($eventFromTime[$k]);
                $toTime   = timeFormat($eventToTime[$k]);
                $date     = dateToDbFromUsDate($eventDate[$k]);
                $insData  = array(
                    'event_id'        => $eventId,
                    'event_date'      => $date,
                    'event_from_time' => $fromTime,
                    'event_to_time'   => $toTime,
                    'creation_date'   => date("Y-m-d"),
                    'created_by'      => $this->session->userdata('user_id')
                );
                $insRes   = $this->eventsModel->insertDates($insData);
                if($insRes){
                    $message = array('type' => 'success', 'message' => 'Event data added successfully.');
                }else{
                    $message = array('type' => 'error', 'message' => 'Could not add Event data.');
                }
            }
        }
        return $message;
    }
    public function delEvent(){
        $eventId = post('eventId');
        $this->eventsModel->deleteEvent(decrypt($eventId));
        $array   = array(
            'type'    => 'success',
            'message' => 'Event deleted successfully'
        );
//        $this->session->set_flashdata('message', 'Event deleted successfully');
        setSessionMsg($array['type'], $array['message']);
        echo json_encode($array);
    }
    public function uploadEventImage(){
        $url         = $_SERVER['REQUEST_URI']; //returns the current URL
        $parts       = explode('/', $url);
        $actual_link = $_SERVER['SERVER_NAME'];
        for($i = 0; $i < count($parts) - 1; $i++){
            $actual_link .= $parts[$i] . "/";
        }
        $target_dir  = SITE_ROOT . "skin/images/eventImages/";
        $imgName     = uniqid() . basename($_FILES["file"]["name"]);
        $target_file = $target_dir . $imgName;

        if(move_uploaded_file($_FILES["file"]["tmp_name"], $target_file)){
            $rs  = SITE_URL . "skin/images/eventImages/" . $imgName;
            $arr = array(
                'url' => $rs
            );
        }else{
            $arr = array(
                'url' => null
            );
        }
        echo json_encode($arr);
    }
    public function delDate(){
        $dateId  = post('dateId');
        $this->eventsModel->deleteDate($dateId);
        $dispMsg = array('type' => 'success');
        echo json_encode($dispMsg);
    }
}