<?php
class Gallery extends MY_Controller{
    public function __construct(){
        parent::__construct(7);
        $this->load->model('admin/GalleryModel', 'galleryModel', true);
    }
    public function index(){
        $imageData = array();
        $albumData = (object) array(
                'album_id'   => '',
                'album_name' => '',
                'album_desc' => '',
                'publish'    => '',
                'submit'     => 'Add'
        );
        $gallery_text = 'Add Gallery';
        $edit = false;
        $albumId = decrypt(get('token'));
        if(!empty($albumId)){
            $result = $this->galleryModel->getAlbums($albumId);
            $albumData = $result[0];
            $imageData = $this->galleryModel->getAlbumImages($albumId);
            if(empty($albumData)){
                $this->session->set_flashdata('Invalid ID');
                redirect(SITE_URL . "admin/dashboard");
            }
            $albumData->submit = 'Update';
            $gallery_text = 'Edit Album';
            $edit = true;
        }
        $data = array(
            'albumData'   => $albumData,
            'allAlbums'   => $this->galleryModel->getAlbums(),
            'albumImages' => $imageData,
            'galleryText' => $gallery_text,
            'edit'        => $edit,
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/gallery', $data);
        $this->load->view('admin/common/footer');
    }
    public function addAlbum(){
        $publishCheck = post('publish'); 
        if($publishCheck == 'on' ) {
            $publish = 'y';
        } else {
            $publish = 'n';
        }
        $insAlbumData = array(
            'album_id'      => post('albumId'),
            'album_name'    => post('albumName'),
            'album_desc'    => post('albumDesc'),
            'creation_date' => date("Y-m-d"),
            'publish'       => $publish,
            'created_by'    => $this->session->userdata('user_id'),
            'updation_date' => date("Y-m-d"),
            'updated_by'    => $this->session->userdata('user_id')
        );
        $albumId = decrypt($insAlbumData['album_id']);
        if(!empty($albumId)){
            $updateAlbum = $this->galleryModel->insertUpdateAlbum($insAlbumData);
            if(!$updateAlbum){
                $message = array('type' => 'error', 'message' => 'Album already exists.');
            }else{
                $message = $this->insertImages($albumId);
            }
        }else{
            $insertAlbum = $this->galleryModel->insertUpdateAlbum($insAlbumData);
            if(!$insertAlbum){
                $message = array('type' => 'error', 'message' => 'Album already exists.');
            }else{
                $message = $this->insertImages($insertAlbum);
            }
        }
        setSessionMsg($message['type'],$message['message']);
        echo json_encode($message);
//        $this->session->set_flashdata('message', $message['message']);
    }
    public function insertImages($albumId){
        if(!empty($_FILES['files']['name'][0])){
            for($i = 0; $i < count($_FILES['files']['name']); $i++){
                $tmpFilePath = $_FILES['files']['tmp_name'][$i];
                if($tmpFilePath != ""){
                    $path = SITE_ROOT . "skin/images/gallery/" . $albumId . "/";
                    if(!is_dir($path)){
                        mkdir($path);
                    }
                    $name = $_FILES['files']['name'][$i];

                    list($tempFileName, $ext) = explode(".", $name);
                    $fileName = uniqid() . "." . $ext;
                }
                move_uploaded_file($_FILES['files']['tmp_name'][$i], $path . $fileName);

                $insImageData = array(
                    'album_id'      => $albumId,
                    'image_name'    => $fileName,
                    'creation_date' => date("Y-m-d"),
                    'created_by'    => $this->session->userdata('user_id')
                );
                $insImageId = $this->galleryModel->insertImage($insImageData);
            }
        }
        return array('type' => 'success', 'message' => 'Album Saved successfully.');
    }
    public function delImage(){
        $imageId = post('imageId');
        $getImageData = $this->galleryModel->getImageById($imageId);
        $path = SITE_ROOT . "skin/images/gallery/" . $getImageData->album_id . "/" . $getImageData->image_name;
        unlink($path);
        $this->galleryModel->deleteImage($imageId);
        $message = array('type' => 'success', 'message' => 'Image deleted successfully');
        setSessionMsg($message['type'],$message['message']);
        echo json_encode($message);
    }
    public function deleteAlbum(){
        $albumId = decrypt(post('album_id'));
        $folderPath = SITE_ROOT . "skin/images/gallery/" . $albumId;
        if(is_dir($folderPath)){
            $files = array_diff(scandir($folderPath), array('.', '..'));
            foreach($files as $file){
                (is_dir($folderPath . "/" . $file)) ? delTree($folderPath . "/" . $file) : unlink($folderPath . "/" . $file);
            }
            rmdir($folderPath);
        }
        $remAlbumRes = $this->galleryModel->removeAlbumById($albumId);
        $remImagesRes = $this->galleryModel->removeImagesByAlbumId($albumId);
        $message = array('type' => 'success', 'message' => 'Album deleted Successfully');
        setSessionMsg($message['type'],$message['message']);
        echo json_encode($message);
    }
}
?>