<?php
class Groups extends MY_Controller{
    public function __construct(){
        parent::__construct(3);
        $this->load->model('admin/GroupModel', 'groupModel', true);
    }
    public function index(){
        $groupData = (object) array(
                'group_id'   => '',
                'group_name' => '',
                'active'     => '',
                'submit'     => 'Add',
        );
        $edit      = false;
        $group_id  = decrypt(get('gId'));
        if(!empty($group_id)){
            $group = $this->groupModel->getGroupById($group_id);
            if(empty($group)){
                $this->session->set_flashdata('Invalid ID');
                redirect(SITE_URL . "admin/dashboard");
            }
            $groupData->group_id   = $group->group_id;
            $groupData->group_name = $group->group_name;
            $groupData->active     = $group->active;
            $groupData->submit     = 'Update';
            $edit                  = true;
        }
        $allGroups = $this->groupModel->getGroups();
        $data      = array(
            'groupData' => $groupData,
            'allGroups' => $allGroups,
            'edit'      => $edit,
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/addGroups', $data);
        $this->load->view('admin/common/footer');
    }
    public function addGroup(){
        $insGroupData = array(
            'group_id'          => post('group_id'),
            'group_name'        => post('groupName'),
            'active'            => post('isActive'),
            'creation_date'     => date("Y-m-d"),
            'modification_date' => date("Y-m-d"),
            'created_by'        => $this->session->userdata('user_id'),
            'updated_by'        => $this->session->userdata('user_id'),
        );
        $message      = $this->groupModel->insertGroup($insGroupData);
        setSessionMsg($message['type'],$message['message']);
        echo json_encode($message);
//        $this->session->set_flashdata('message', $message['message']);
    }
    public function delGroup(){
        $delGid    = decrypt(post('delGid'));
        $checkUser = $this->groupModel->checkForGroup($delGid);
        if($checkUser){
            $message = array('type' => 'error', 'message' => 'Please remove the Users associated with this Group');
            echo json_encode($message);
            return false;
        }
        $this->groupModel->deleteGroup($delGid);
        $message = array('type' => 'success', 'message' => 'Group deleted successfully');
        setSessionMsg($message['type'],$message['message']);
        echo json_encode($message);
    }
}
?>