<?php
class Menu extends MY_Controller{
    public function __construct(){
        parent::__construct(9);
        $this->load->model('admin/MenuModel', 'menuModel', true);
    }
    public function index(){
        $mainMenuList = $this->menuModel->getAllMenus();
        $menuId       = decrypt(get('token'));
        if(empty($menuId)){
            $form = (object) array(
                    'menu_id'     => '',
                    'menu_name'   => '',
                    'menu_region' => '',
                    'menu_order'  => '',
                    'page_id'     => '',
                    'parent'      => '',
                    'hierarchy'   => '',
                    'm_detail_id' => '',
                    'menu_type'   => '',
                    'menu_url'    => '',
                    'submit'      => 'Add'
            );
            $edit = false;
        }else{
            $form         = $this->menuModel->getAllMenu($menuId)[0];
            $form->submit = 'Update';
            $edit         = true;
        }
        $getMenu = $this->createMenu(0, $mainMenuList);
        $data    = array(
            'pages'      => $this->menuModel->getAllPages(),
            'form'       => $form,
            'menus'      => $this->menuModel->getAllMenu(),
            'parentMenu' => $this->menuModel->getParentMenu(),
            'viewMenu'   => $getMenu,
            'edit'       => $edit
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/menu', $data);
        $this->load->view('admin/common/footer');
    }
    public function saveMenu(){
        $postData = array(
            'menu_id'       => decrypt(post('menuId')),
            'menu_region'   => post('menuRegion'),
            'menu_type'     => post('menuType'),
            'menu_name'     => post('menuName'),
            'page_id'       => post('menuPage'),
            'menu_url'      => post('menuLink'),
            'parent'        => post('menuParent'),
            'menu_order'    => post('menuOrder'),
            'creation_date' => date("Y-m-d"),
            'created_by'    => $this->session->userdata('user_id'),
            'updation_date' => date("Y-m-d"),
            'updated_by'    => $this->session->userdata('user_id')
        );
        $message  = $this->menuModel->addUpdateMenu($postData);
        if($message['type'] == 'error'){
            echo json_encode($message);
            exit;
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function createMenu($parent, $menu){
        $menuArray['headerMenu'] = "";
        $menuArray['footerMenu'] = "";
        if(!empty($menu['header']['parents'][$parent])){
            $menuArray['headerMenu'] .= "<ul>";
            foreach($menu['header']['parents'][$parent] as $itemId){
                if(empty($menu['header']['parents'][$itemId])){
                    $menuArray['headerMenu'] .= "<li>" . ucwords($menu['header']['items'][$itemId]->menu_name) . "</li>";
                }
                if(!empty($menu['header']['parents'][$itemId])){
                    $menuArray['headerMenu'] .= "<li>" . ucwords($menu['header']['items'][$itemId]->menu_name);
                    $menuArray['headerMenu'] .= $this->createMenu($itemId, $menu)['headerMenu'];
                    $menuArray['headerMenu'] .= "</li>";
                }
            }
            $menuArray['headerMenu'] .= "</ul>";
        }
        if(!empty($menu['footer']['items'])){
            $menuArray['footerMenu'] .= "<ul>";
            foreach($menu['footer']['items'] as $item){
                $menuArray['footerMenu'] .= "<li>" . ucwords($item->menu_name) . "</li>";
            }
            $menuArray['footerMenu'] .= "</ul>";
        }
        return $menuArray;
    }
    public function delMenu(){
        $menuId             = decrypt(post('token'));
        $checkMenuHierarchy = $this->menuModel->checkMenuForChild($menuId);
        if($checkMenuHierarchy){
            $message = array('type' => 'error', 'message' => 'A child menu is still associated with this menu.');
        }else{
            $this->menuModel->deleteMenu($menuId);
            $message = array('type' => 'success', 'message' => 'Menu deleted successfully');
            setSessionMsg($message['type'], $message['message']);
        }
        echo json_encode($message);
    }
}
?>