<?php
class Pages extends MY_Controller{
    public function __construct(){
        parent::__construct(1);
        $this->load->model('admin/PageModel', 'pageModel', true);
    }
    public function index(){
        $pageData = array();
        $edit     = false;
        $pageId   = decrypt(get('token'));
        if(!empty($pageId)){
            $pageData = $this->pageModel->getPageDataById($pageId);
            if(empty($pageData)){
                $this->session->set_flashdata('Invalid ID');
                redirect(SITE_URL . "admin/dashboard");
            }
            $edit = true;
        }
        $allPages = $this->pageModel->getPages();
        $data     = array(
            'pageData' => $pageData,
            'allPages' => $allPages,
            'edit'     => $edit
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/addPage', $data);
        $this->load->view('admin/common/footer');
    }
    public function addPage(){
        $publishCheck = post('publish');
        if($publishCheck == 'on'){
            $publish = 'y';
        }else{
            $publish = 'n';
        }
        $pageTitle = strtolower(post('pageTitle'));
        $pageKey   = $final     = preg_replace('#[ -]+#', '-', trim($pageTitle));
        $insData   = array(
            'page_id'       => post('pageId'),
            'page_key'      => $pageKey,
            'title'         => post('pageTitle'),
            'content'       => post('pageContent'),
            'seo_title'     => post('seoTitle'),
            'seo_desc'      => post('seoDesc'),
            'seo_keywords'  => post('seoKeywords'),
            'publish'       => $publish,
            'creation_date' => date("Y-m-d"),
            'created_by'    => $this->session->userdata('user_id'),
            'updation_date' => date("Y-m-d"),
            'updated_by'    => $this->session->userdata('user_id')
        );
        $message   = $this->pageModel->insertUpdatePage($insData);
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
//        $this->session->set_flashdata('message', $message['message']);
    }
    public function delPage(){
        $delPid  = post('delPid');
        $this->pageModel->deletePage($delPid);
        $message = array('type' => 'success', 'message' => 'Page deleted successfully');
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function uploadPageImage(){
        $url         = $_SERVER['REQUEST_URI']; //returns the current URL
        $parts       = explode('/', $url);
        $actual_link = $_SERVER['SERVER_NAME'];
        for($i = 0; $i < count($parts) - 1; $i++){
            $actual_link .= $parts[$i] . "/";
        }
        $target_dir  = SITE_ROOT . "skin/images/pageImages/";
        $imgName     = uniqid() . basename($_FILES["file"]["name"]);
        $target_file = $target_dir . $imgName;

        if(move_uploaded_file($_FILES["file"]["tmp_name"], $target_file)){
            $rs  = SITE_URL . "skin/images/pageImages/" . $imgName;
            $arr = array(
                'url' => $rs
            );
        }else{
            $arr = array(
                'url' => null
            );
        }
        echo json_encode($arr);
    }
}
?>