<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
class Questions extends MY_Controller{
    public function __construct(){
        parent::__construct(13);
        $this->load->model('admin/QuestionsModel', 'questionsModel', true);
    }
    public function index(){
        $parent        = '';
        $otherCategory = '';
        $questionId    = decrypt(get('token'));
        $categories    = $this->questionsModel->getParentCategories();
        $form          = (object) array(
                'question_id'  => '',
                'question'     => '',
                'description'  => '',
                'is_anonymous' => '',
                'approved'     => '',
                'keywords'     => '',
                'submit'       => 'Add'
        );
        $edit          = false;
        if(!empty($questionId)){
            $form         = $this->questionsModel->getQuestionById($questionId);
            $form->submit = 'Update';
            $edit         = true;
        }
        $data = array(
            'form' => $form,
            'edit' => $edit
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/questions', $data);
        $this->load->view('admin/common/footer');
    }
    public function delQuestion(){
        $question_id = decrypt($this->input->post('question_id'));
        $this->questionsModel->deleteQuestion($question_id);
        $message     = array('type' => 'success', 'message' => 'Question deleted successfully');
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function apprQuestion(){
        $question_id  = decrypt($this->input->post('question_id'));
        $questionData = $this->questionsModel->getQuestionById($question_id);
        if($questionData->approved == 'n'){
            $this->questionsModel->changeQuesAppr($question_id, 'y');
        }else{
            $this->questionsModel->changeQuesAppr($question_id, 'n');
        }
        $message = array('type' => 'success', 'message' => 'Status updated successfully.');
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function getSubCategories(){
        $parent      = $this->input->post('parent_id');
        $getChildCat = $this->questionsModel->getChildCatByParentId($parent);
        if(!empty($getChildCat)){
            $message = array('type' => 'success', 'subCategories' => $getChildCat);
            echo json_encode($message);
            exit();
        }
        $message = array('type' => 'no_sub_category', 'message' => 'No sub category found.');
        echo json_encode($message);
    }
    public function saveQuestion(){
        $anonymous = ($this->input->post('anonymous') == 'on') ? 1 : 0;
        $approved  = ($this->input->post('approval') == 'on') ? 'y' : 'n';
        $insData   = array(
            'question_id'   => decrypt($this->input->post('questionId')),
            'user_id'       => $this->session->userdata('user_id'),
            'question'      => $this->input->post('question'),
            'description'   => $this->input->post('description'),
            'approved'      => $approved,
            'creation_date' => date("Y-m-d H:i:s"),
            'updation_date' => date("Y-m-d H:i:s"),
            'updated_by'    => $this->session->userdata('user_id'),
            'is_anonymous'  => $anonymous
        );
        $message   = $this->questionsModel->addUpdateQuestion($insData);
        if($message['type'] == 'error'){
            echo json_encode($message);
            exit();
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function getAllAnswers(){
        $response             = array(
            'answerData' => array(
                'answer' => 'No answer(s) found.'
            )
        );
        $question_id          = decrypt($this->input->post('question_id'));
        $question             = $this->questionsModel->getQuestionById($question_id);
        $response['question'] = $question->question;
        $answers              = $this->questionsModel->getAnswersByQuestionId($question_id);
        $subGrp               = $this->a_sub_group_id[0];
        $access               = $this->a_access[$subGrp];
        $response['type']     = 'success';
        if(!empty($answers)){
            $response['answerData'] = $answers;
        }
//        pre($response);
        echo json_encode($response);
    }
    public function apprAnswer(){
        $answer_id = decrypt($this->input->post('answer_id'));
        $this->questionsModel->approveAnswer($answer_id);
        echo json_encode(array('type' => 'success'));
    }
}
?>

