<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 * Description of settings
 *
 * @author Abhishek Verma
 */
class Settings extends MY_Controller{
    public function __construct(){
        parent::__construct(5);
        $this->load->model('admin/SettingModel', 'settingModel', true);
    }
    public function index(){
        $id          = decrypt(get('token'));
        $data        = array();
        $settingData = array();
        $settingData = $this->settingModel->getSettingDataById();
        $edit        = false;
        if(!empty($id)){
            $settingData         = $this->settingModel->getSettingDataById($id);
            $data['settingData'] = $settingData;
            $edit                = true;
        }
        $data['settingData'] = $settingData;
        $data['edit']        = $edit;
        $this->load->view('admin/common/header');
        $this->load->view('admin/settings', $data);
        $this->load->view('admin/common/footer');
    }
    public function addSetting(){
        $insData   = array(
            'id'            => decrypt(post('settingId')),
            'fb_url'        => post('facebook'),
            'twitter_url'   => post('twitter'),
            'linkedIn_url'  => post('linkedIn'),
            'youtube_url'   => post('youtube'),
            'smtp_user_name'=> post('smtpUsername'),
            'smtp_host'     => post('smtpHost'),
            'smtp_password' => post('smtpPassword'),
            'donate'        => post('donate'),
            'find_us'       => post('findUs'),
            'google_ad'     => post('googleAd'),
            'creation_date' => date("Y-m-d"),
            'updation_date' => date("Y-m-d"),
            'created_by'    => $this->session->userdata('user_id'),
            'updated_by'    => $this->session->userdata('user_id'),
        );
        $settingId = $insData['id'];
        if(!empty($settingId)){
            $updateSetting = $this->settingModel->insertUpdateSetting($insData);
            if(!$updateSetting){
                $message = array('type' => 'error', 'message' => 'Could not update setting.');
            }else{
                $message = $this->updateImages($settingId);
            }
        }else{
            $insertSetting = $this->settingModel->insertUpdateSetting($insData);
            if(!$insertSetting){
                $message = array('type' => 'error', 'message' => 'Could not insert setting.');
            }else{
                $message = $this->updateImages($insertSetting);
            }
        }
        setSessionMsg($message['type'],$message['message']);
        echo json_encode($message);
//        $this->session->set_flashdata('message', $message['message']);
    }
    public function updateImages($settingId){
        $imgOffset = array('fb_image', 'twitter_image', 'youtube_image', 'linkedIn_image');
        if(!empty($_FILES['fb_image']['name']) || !empty($_FILES['twitter_image']['name']) || !empty($_FILES['youtube_image']['name']) || !empty($_FILES['linkedIn_image']['name'])){
            for($i = 0; $i < count($_FILES); $i++){
                $tmpFilePath = $_FILES[$imgOffset[$i]]['tmp_name'];
                if($tmpFilePath != ""){
                    $path = SITE_ROOT . "skin/images/settings";
                    if(!is_dir($path)){
                        mkdir($path);
                    }
                    $name = $_FILES[$imgOffset[$i]]['name'];

                    list($tempFileName, $ext) = explode(".", $name);
                    $fileName   = $imgOffset[$i] . "." . $ext;
                    // Get Image Data to check if another one already exists
                    $oldPath = SITE_URL."skin/images/settings/".$imgOffset[$i];
                    if(is_file($oldPath)) {
                        unlink($oldPath);
                    }
                    move_uploaded_file($_FILES[$imgOffset[$i]]['tmp_name'], $path . "/" . $fileName);
                    $col        = $imgOffset[$i];
                    $insImgData = array(
                        "$col" => $fileName
                    );
                    $where      = array(
                        'id' => $settingId
                    );
                    $affRows    = $this->settingModel->updateImage($insImgData, $where);
                }
            }
        }
        return array('type' => 'success', 'message' => 'Setting saved successfully');
    }
}