<?php
class Slider extends MY_Controller{
    public function __construct(){
        parent::__construct(6);
        $this->load->model('admin/SliderModel', 'sliderModel', true);
    }
    public function index(){
        $sliderData  = (object) array(
                'slider_id'    => '',
                'slider_title' => '',
                'slider_desc'  => '',
                'slider_image' => '',
                'btn_title'    => '',
                'btn_link'     => '',
                'publish'      => '',
                'submit'       => 'Add'
        );
        $slider_text = 'Add Slider';
        $edit        = false;
        $sliderId    = decrypt(get('token'));
        if(!empty($sliderId)){
            $sliderData = $this->sliderModel->getSlider($sliderId);
            if(empty($sliderData)){
                $this->session->set_flashdata('Invalid ID');
                redirect(SITE_URL . "admin/dashboard");
            }
            $sliderData->submit = 'Update';
            $slider_text        = 'Edit Slider';
            $edit               = true;
        }
        $data = array(
            'sliderData'  => $sliderData,
            'allSliders'  => $this->sliderModel->getAllSliders(),
            'slider_text' => $slider_text,
            'edit'        => $edit,
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/slider', $data);
        $this->load->view('admin/common/footer');
    }
    public function addUpdateSlider(){
        $publishCheck = post('publish');
        if($publishCheck == 'on'){
            $publish = 'y';
        }else{
            $publish = 'n';
        }
        $insSliderData = array(
            'slider_id'     => post('sliderId'),
            'slider_title'  => post('sliderTitle'),
            'slider_desc'   => post('sliderDesc'),
            'btn_title'     => post('buttonTitle'),
            'btn_link'      => post('buttonLink'),
            'publish'       => $publish,
            'creation_date' => date("Y-m-d"),
            'created_by'    => $this->session->userdata('user_id'),
            'updation_date' => date("Y-m-d"),
            'updated_by'    => $this->session->userdata('user_id'),
        );
        $sliderId      = decrypt(post('sliderId'));
        if(!empty($sliderId)){
            $updateSlider = $this->sliderModel->insertUpdateSlider($insSliderData);
            if(!$updateSlider){
                $message = array('type' => 'error', 'message' => 'Slider already exists.');
            }else{
                $message = $this->saveSliderImage($sliderId, 'update');
            }
        }else{
            $insertSlider = $this->sliderModel->insertUpdateSlider($insSliderData);
            if(!$insertSlider){
                $message = array('type' => 'error', 'message' => 'Slider already exists.');
            }else{
                $message = $this->saveSliderImage($insertSlider, 'insert');
            }
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
//        $this->session->set_flashdata('message', $message['message']);
    }
    public function saveSliderImage($sliderId, $qryType){
        if(!empty($_FILES['sliderImage']['name'][0])){
            // Remove the old slider Image.
            $getSliderData = $this->sliderModel->getSlider($sliderId);
            $sliderImage   = $getSliderData->slider_image;
            $oldImgPath    = SITE_ROOT . "skin/images/sliders/" . $sliderImage;
            if(is_file($oldImgPath)){
                unlink($oldImgPath);
            }
            // Save the new Image for the slider
            $tmpFilePath = $_FILES['sliderImage']['tmp_name'];
            if($tmpFilePath != ""){
                $path = SITE_ROOT . "skin/images/sliders/";
                if(!is_dir($path)){
                    mkdir($path);
                }
                $name = $_FILES['sliderImage']['name'];

                list($tempFileName, $ext) = explode(".", $name);
                $fileName = uniqid() . "." . $ext;
            }
            move_uploaded_file($_FILES['sliderImage']['tmp_name'], $path . $fileName);
            $insImageData = array(
                'slider_image' => $fileName
            );
            $insImage     = $this->sliderModel->insertSliderImage($sliderId, $insImageData);
        }
        if($qryType == 'insert'){
            return array('type' => 'success', 'message' => 'Slider Added successfully.');
        }else{
            return array('type' => 'success', 'message' => 'Slider Updated successfully.');
        }
    }
    public function delSlider(){
        $sId    = decrypt(post('sId'));
        $delImg = $this->deleteSliderImage($sId);
        if($delImg){
            $this->sliderModel->deleteSlider($sId);
            $message = array('type' => 'success', 'message' => 'Slider deleted successfully');
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function deleteSliderImage($sId){
        $sliderData  = $this->sliderModel->getSlider($sId);
        $sliderImage = $sliderData->slider_image;
        $imagePath   = SITE_ROOT . "skin/images/sliders/" . $sliderImage;
        if(is_file($imagePath)){
            unlink($imagePath);
            return true;
        }else{
            return false;
        }
    }
    public function pSlider(){
        $sId     = decrypt(post('sId'));
        $message = $this->sliderModel->publishSlider($sId);
        if($message['type'] == 'success'){
            setSessionMsg($message['type'], $message['message']);
        }
        echo json_encode($message);
    }
}
?>