<?php
class Testimonials extends MY_Controller{
    public function __construct(){
        parent::__construct(10);
        $this->load->model('admin/TestimonialModel', 'testimonialModel', true);
    }
    public function index(){
        $t_id = decrypt(get('token'));
        $form = (object) array(
                'testimonial_id' => '',
                'first_name'     => '',
                'last_name'      => '',
                'email'          => '',
                'testimonial'    => '',
                'photo'          => '',
                'approved'       => '',
                'submit'         => 'Add'
        );
        $edit = false;
        if(!empty($t_id)){
            $form         = $this->testimonialModel->getTestimonialById($t_id);
            $form->submit = 'Update';
            $edit         = true;
        }
        $data = array(
            'form'            => $form,
            'allTestimonials' => $this->testimonialModel->getAllTestimonials(),
            'edit'            => $edit
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/testimonials', $data);
        $this->load->view('admin/common/footer');
    }
    public function saveTestimonial(){
        $approved        = (post('approved') == 'on') ? 'y' : 'n';
        $testimonialData = array(
            'testimonial_id' => decrypt(post('testimonialId')),
            'first_name'     => post('firstName'),
            'last_name'      => post('lastName'),
            'email'          => post('email'),
            'testimonial'    => post('testimonial'),
            'approved'       => $approved,
            'creation_date'  => date("Y-m-d"),
            'updation_date'  => date("Y-m-d"),
            'updated_by'     => $this->session->userdata('user_id')
        );
        $t_id            = $testimonialData['testimonial_id'];
        $message         = $this->testimonialModel->addUpdTestimonial($testimonialData);
        if(empty($t_id)){
            $t_id = $message['t_id'];
        }
        if(!empty($_FILES['photo']['name'])){
            $this->uploadUserPhoto($t_id);
        }
        if($message['type'] == 'error'){
            echo json_encode($message);
            exit;
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function uploadUserPhoto($t_id){
        $tmpFilePath = $_FILES['photo']['tmp_name'];
        if($tmpFilePath != ""){
            $path = SITE_ROOT . "skin/images/testimonialImages/";
            if(!is_dir($path)){
                mkdir($path);
            }
            $name = $_FILES['photo']['name'];

            list($tempFileName, $ext) = explode(".", $name);
            $fileName = uniqid() . "." . $ext;
        }
        move_uploaded_file($_FILES['photo']['tmp_name'], $path . $fileName);
        $insImageData = array(
            'photo' => $fileName
        );
        $insImage     = $this->testimonialModel->insertUserPhoto($t_id, $insImageData);
    }
    public function delTestimonial() {
        $testimonial_id = decrypt(post('testimonial_id'));
        $this->testimonialModel->deleteTestimoinal($testimonial_id);
        $message = array('type' => 'success', 'message' => 'Testimional deleted successfully.');
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function apprTestimonial() {
        $t_id = $this->input->post('t_id');
        $message = $this->testimonialModel->approveTestimonial($t_id);
        if($message['type'] == 'success') {
            setSessionMsg($message['type'], $message['message']);
        }
        echo json_encode($message);
    }
}
?>