<?php
class Users extends MY_Controller{
    public function __construct(){
        parent::__construct(2);
        $this->load->model('admin/UserModel', 'userModel', true);
        $this->load->model('admin/GroupModel', 'groupModel', true);
    }
    public function index(){
        $userData  = (object) array(
                'group_id'   => '',
                'user_name'  => '',
                'first_name' => '',
                'last_name'  => '',
                'group_id'   => '',
                'email_id'   => '',
                'active'     => '',
                'submit'     => 'Add',
                'user_id'    => ''
        );
        $user_text = 'Add User';
        $edit      = false;
        $userId    = decrypt(get('token'));
        if(!empty($userId)){
            $userData = $this->userModel->getUsers($userId);
            if(empty($userData)){
                $this->session->set_flashdata('Invalid ID');
                redirect(SITE_URL . "admin/dashboard");
            }
            $userData->submit = 'update';
            $user_text        = 'Edit User';
            $edit             = true;
        }
        $data = array(
            'groups'    => $this->groupModel->getGroups(),
            'userData'  => $userData,
            'allUsers'  => $this->userModel->getAllUsers(),
            'user_text' => $user_text,
            'edit'      => $edit,
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/addUser', $data);
        $this->load->view('admin/common/footer');
    }
    public function addUser(){
        $userId  = decrypt(post('userId'));
        $insData = array(
            'user_name'     => post('userName'),
            'first_name'    => post('firstName'),
            'last_name'     => post('lastName'),
            'password'      => post('userPasswd'),
            'group_id'      => post('groupAssigned'),
            'email_id'      => post('userEmail'),
            'active'        => post('isActive'),
            'user_type'     => 'sub-admin',
            'creation_date' => date("Y-m-d"),
            'userId'        => post('userId'),
            'created_by'    => $this->session->userdata('user_id'),
            'updated_by'    => $this->session->userdata('user_id'),
        );
        if(!empty($userId)){
            if(!$this->userModel->checkUserExists($userId)){
                $dispMsg = array('type' => 'error', 'message' => 'Invalid user.');
                echo json_encode($dispMsg);
                return false;
            }
        }
        $confPasswd = post('userCPasswd');
        if(empty($userId)){
            if(empty($insData['password']) || empty($confPasswd)){
                $dispMsg = array('type' => 'error', 'message' => 'Please provide password and confirm password.');
                echo json_encode($dispMsg);
                return false;
            }
        }
        if($insData['password'] != $confPasswd){
            $dispMsg = array('type' => 'error', 'message' => 'The password and confirm passwords are not the same.');
            echo json_encode($dispMsg);
            return false;
        }
        if(!empty($insData['password']) && !empty($confPasswd)){
            if(!valid_pass($insData['password'])){
                $dispMsg = array('type' => 'error', 'message' => 'Please provide complex password.');
                echo json_encode($dispMsg);
                return false;
            }
        }
        $message = $this->userModel->insertUpdateUser($insData);
        if($message['type'] == 'error'){
            echo json_encode($message);
            exit;
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);

//        $this->session->set_flashdata('message',$message['message']);
    }
    public function delUser(){
        $delUid  = decrypt(post('delUid'));
        $this->userModel->deleteUser($delUid);
        $message = array('type' => 'success', 'message' => 'User deleted successfully');
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
}
?>