<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
class Widgets extends MY_Controller{
    public function __construct(){
        parent::__construct(15);
        $this->load->model('admin/WidgetsModel', 'widgetsModel', true);
    }
    public function index(){
        $widgetData  = (object) array(
                'widget_id'   => '',
                'title'       => '',
                'description' => '',
                'image'       => '',
                'publish'     => '',
                'submit'      => 'Add'
        );
        $widget_text = 'Add A Widget';
        $edit        = false;
        $widgetId    = decrypt(get('token'));
        if(!empty($widgetId)){
            $widgetData = $this->widgetsModel->getWidgetById($widgetId);
            if(empty($widgetData)){
                $this->session->set_flashdata('Invalid ID');
                redirect(SITE_URL . "admin/dashboard");
            }
            $widgetData->submit = 'Update';
            $widget_text        = 'Edit Widget';
            $edit               = true;
        }
        $data = array(
            'widgetData'    => $widgetData,
            'allWidgets'    => $this->widgetsModel->getAllWidgets(),
            'widget_text'   => $widget_text,
            'approval_flag' => $this->approval_flag[15],
            'edit'          => $edit,
        );
        $this->load->view('admin/common/header');
        $this->load->view('admin/widgets', $data);
        $this->load->view('admin/common/footer');
    }
    public function addUpdateWidget(){
        $publishCheck  = post('publish');
        $publish       = ($publishCheck == 'on') ? 'y' : 'n';
        $insWidgetData = array(
            'widget_id'     => decrypt($this->input->post('widgetId')),
            'title'         => $this->input->post('widgetTitle'),
            'description'   => $this->input->post('widgetDesc'),
            'publish'       => $publish,
            'creation_date' => date("Y-m-d H:i:s"),
            'created_by'    => $this->session->userdata('user_id'),
            'updation_date' => date("Y-m-d H:i:s"),
            'updated_by'    => $this->session->userdata('user_id'),
        );
        $widgetId      = decrypt($this->input->post('widgetId'));
        if(!empty($widgetId)){
            $updateWidget = $this->widgetsModel->insertUpdateWidget($insWidgetData);
            if(!$updateWidget){
                $message = array('type' => 'error', 'message' => 'Widget already exists.');
            }else{
                $message = $this->saveWidgetImage($widgetId, 'update');
            }
        }else{
            $insertWidget = $this->widgetsModel->insertUpdateWidget($insWidgetData);
            if(!$insertWidget){
                $message = array('type' => 'error', 'message' => 'Widget already exists.');
            }else{
                $message = $this->saveWidgetImage($insertWidget, 'insert');
            }
        }
        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function saveWidgetImage($widgetId, $qryType){
        if(!empty($_FILES['widgetImage']['name'][0])){
            // Remove the old widget Image.
            $getWidgetData = $this->widgetsModel->getWidgetById($widgetId);
            if(!empty($getWidgetData)){
                $widgetImage = $getWidgetData->image;
                $oldImgPath  = SITE_ROOT . "skin/images/widgets/" . $widgetImage;
                if(is_file($oldImgPath)){
                    unlink($oldImgPath);
                }
            }
            // Save the new Image for the widget
            $tmpFilePath = $_FILES['widgetImage']['tmp_name'];
            if($tmpFilePath != ""){
                $path = SITE_ROOT . "skin/images/widgets/";
                if(!is_dir($path)){
                    mkdir($path);
                }
                $name = $_FILES['widgetImage']['name'];

                list($tempFileName, $ext) = explode(".", $name);
                $fileName = uniqid() . "." . $ext;
            }
            move_uploaded_file($_FILES['widgetImage']['tmp_name'], $path . $fileName);
            $insImageData = array(
                'image' => $fileName
            );
            $insImage     = $this->widgetsModel->insertWidgetImage($widgetId, $insImageData);
        }
        if($qryType == 'insert'){
            return array('type' => 'success', 'message' => 'Widget Added successfully.');
        }else{
            return array('type' => 'success', 'message' => 'Widget Updated successfully.');
        }
    }
    public function delWidget(){
        $wId     = decrypt(post('wId'));
        $this->deleteWidgetImage($wId);
        $this->widgetsModel->deleteWidget($wId);
        $message = array('type' => 'success', 'message' => 'Widget deleted successfully');

        setSessionMsg($message['type'], $message['message']);
        echo json_encode($message);
    }
    public function deleteWidgetImage($wId){
        $widgetData  = $this->widgetsModel->getWidgetById($wId);
        $widgetImage = $widgetData->image;
        $imagePath   = SITE_ROOT . "skin/images/widgets/" . $widgetImage;
        if(is_file($imagePath)){
            unlink($imagePath);
        }
    }
    // Function to publish Widget
    public function publishWidget(){
        $wId     = decrypt($this->input->post('wId'));
        $message = $this->widgetsModel->publishWidget($wId);
        if($message['type'] == 'success'){
            setSessionMsg($message['type'], $message['message']);
        }
        echo json_encode($message);
    }
}
?>