<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class MY_Controller extends CI_Controller{
    public $a_access;
    public $a_sub_group_id;
    public $approval_flag = array();
    public function __construct($access = array()){
        parent::__construct();
        $access               = (array) $access;
        $this->load->model('admin/LoginModel', 'login');
        $this->checkLogin();
        $this->a_access       = $this->login->allGroupAccess();
        $this->a_sub_group_id = $access;
        if(!empty($access)){
            $this->checkAccess($access);
        }
        $this->load->model('admin/ApprovalModel', 'dashboard');
        $this->setApprovalFlag();
    }
    protected function checkLogin(){
        if($this->session->userdata('user_id') == ''){
            redirect(SITE_URL . "admin/login");
        }
    }
    protected function checkAccess($access){
        $a_access = $this->login->subGroupAccess($access);
        if($a_access->view_rights == 'n'){
            redirect(SITE_URL . "admin/dashboard");
        }
    }
    protected function setApprovalFlag(){
        $subModules = $this->dashboard->getAllSubModules();
        foreach($subModules as $k => $subModule){
            $this->approval_flag[$subModule->sub_module_id] = $subModule->approval_status;
        }
    }
}
class MY_Front_Controller extends CI_Controller{
    public $aboutUs;
    public $events;
    public $allEvents;
    public $causes;
    public $menuList;
    public $menu;
    public $widgets;
    public $approval_flag_home = array();
    public function __construct(){
        parent::__construct();
        $this->load->model('HomeModel', 'homeModel', true);
        $this->aboutUs   = $this->homeModel->getPageByKey('about-us');
        $this->events    = $this->homeModel->getAllEvents();
        $this->allEvents = $this->homeModel->getEventsList();
        $this->causes    = $this->homeModel->getAllCauses();
        $this->menuList  = $this->homeModel->getAllMenus();
        $this->menu      = $this->createMenu(0, $this->menuList);
        $this->widgets   = $this->homeModel->getAllWidgets();
        $this->setApprovalFlagHome();
    }
    public function createMenu($parent, $menu){
        $menuArray['headerMenu'] = "";
        $menuArray['footerMenu'] = "";
        if(!empty($menu['header']['parents'][$parent])){
            $menuArray['headerMenu'] .= "<ul class='d-flex flex-column flex-lg-row justify-content-lg-end align-content-center'>";
            foreach($menu['header']['parents'][$parent] as $itemId){
                if(empty($menu['header']['parents'][$itemId])){
                    $menuArray['headerMenu'] .= "<li><a href='" . $menu['header']['items'][$itemId]->menu_url . "'>" . ucwords($menu['header']['items'][$itemId]->menu_name) . "</a></li>";
                }
                if(!empty($menu['header']['parents'][$itemId])){
                    $menuArray['headerMenu'] .= "<li><a href='" . $menu['header']['items'][$itemId]->menu_url . "'>" . ucwords($menu['header']['items'][$itemId]->menu_name) . "</a>";
                    $menuArray['headerMenu'] .= $this->createMenu($itemId, $menu)['headerMenu'];
                    $menuArray['headerMenu'] .= "</li>";
                }
            }
            $menuArray['headerMenu'] .= "</ul>";
        }
        if(!empty($menu['footer']['items'])){
            $menuArray['footerMenu'] .= "<ul class='links'>";
            foreach($menu['footer']['items'] as $item){
                $menuArray['footerMenu'] .= "<li><a href='" . $item->menu_url . "'>" . ucwords($item->menu_name) . "</a></li>";
            }
            $menuArray['footerMenu'] .= "</ul>";
        }
        return $menuArray;
    }
    protected function setApprovalFlagHome(){
        $subModules = $this->homeModel->getAllSubModules();
        foreach($subModules as $k => $subModule){
            $this->approval_flag_home[$subModule->sub_module_id] = $subModule->approval_status;
        }
    }
}