<?php
/**
 * Description of common_helper
 *
 * @author QASource
 * Here we will have all functions related to system
 */
defined('BASEPATH') OR exit('No direct script access allowed');
function product_array(){
    $a_array = array(
        STAGING . '/mobile-job-microsite',
        STAGING . '/candidate-lead-qualification',
        STAGING . '/sms-communicator-tools',
        STAGING . '/text-to-apply',
        STAGING . '/targeted-media-boosts',
        STAGING . '/ats-integration',
    );
    return $a_array;
}
function about_array(){
    $a_array = array(
        STAGING . '/about-us',
        STAGING . '/partner-program',
    );
    return $a_array;
}
function blog_array(){
    $a_array = array(
        STAGING . '/blog',
    );
    return $a_array;
}
function get_current_uri(){
    $URI = $_SERVER['REQUEST_URI'];
    $URI = preg_replace('/\?.*/', '', $URI);
    return $URI;
}
function sanitize_output($html){
    preg_match_all('!(<(?:code|pre|script).*>[^<]+</(?:code|pre|script)>)!', $html, $pre);
    $html = preg_replace('!<(?:code|pre).*>[^<]+</(?:code|pre)>!', '#pre#', $html);
    $html = preg_replace('#<!–[^\[].+–>#', '', $html);
    $html = preg_replace('/[\r\n\t]+/', ' ', $html);
    $html = preg_replace('/>[\s]+</', '><', $html);
    $html = preg_replace('/\s+/', ' ', $html);
    $html = preg_replace('#\s*<!--(?!\[if\s).*?-->\s*|(?<!\>)\n+(?=\<[^!])#s', ' ', $html);

    if(!empty($pre[0])){
        foreach($pre[0] as $tag){
            $html = preg_replace('!#pre#!', $tag, $html, 1);
        }
    }
    return $html;
}
function post($key){
    return filter_input(INPUT_POST, $key);
}
function get($key){
    return filter_input(INPUT_GET, $key);
}
function post_array($key){
    return filter_input(INPUT_POST, $key, FILTER_DEFAULT, FILTER_REQUIRE_ARRAY);
}
function get_array($key){
    return filter_input(INPUT_GET, $key, FILTER_DEFAULT, FILTER_REQUIRE_ARRAY);
}
function getDbObj(){
    global $connect;
    return $connect->DbConn;
}
function lang($key){
    global $lang;
    return $lang[$key];
}
function getSession($key = ''){
    if($key == ''){
        return $_SESSION;
    }
    if(isset($_SESSION[$key])){
        return $_SESSION[$key];
    }else{
        return '';
    }
}
function unSetSession($key = ''){
    if(isset($_SESSION[$key])){
        unset($_SESSION[$key]);
    }
}
function setSession($key, $value){
    $_SESSION[$key] = $value;
}
function load($path){
    require_once(SITEROOT . $path);
}
function loadLang($path){
    global $lang;
    require_once(SITEROOT . 'language/' . $path);
}
function setUserInfo($userData){
    $_ENV['userData'] = $userData;
}
function getUserInfo(){
    if(isset($_ENV['userData'])){
        return $_ENV['userData'];
    }
    return array();
}
function exist($val, $data){
    if(array_key_exists($val, $data)){
        return $data[$val];
    }
    return '';
}
function setSessionMsg($type, $msg){
    $_SESSION['respMsg']['type']    = $type;
    $_SESSION['respMsg']['message'] = $msg;
}
function dispSessionMsg($unset){
    $error = array(
        'type'    => '',
        'message' => '');
    if(isset($_SESSION['respMsg'])){
        $error['type']    = $_SESSION['respMsg']['type'];
        $error['message'] = $_SESSION['respMsg']['message'];
    }
    if($unset){
        unset($_SESSION['respMsg']);
    }
    echo "<div class='" . $error['type'] . "'>" . $error['message'] . "</div>";
}
function dispMsg($type, $message, $show = true){
    $msg = "<div class='" . $type . "'>" . $message . "</div>";
    if($show == true){
        echo $msg;
    }else{
        return $msg;
    }
}
function number($p){
    $p = explode('.', $p);
    $v = 0;
    if(isset($p[1])){
        $p[1] = substr($p[1], 0, 2);
        $v    = $p[0] . '.' . $p[1];
    }else{
        $v = $p[0];
    }
    return (float) $v;
}
function dateToDb($date){
    if(preg_match("/([0-9]{2})-([0-9]{2})-([0-9]{4})/", $date)){
        $d = explode("-", $date);
        return $d[2] . "-" . $d[1] . "-" . $d[0];
    }else{
        return '';
    }
}
function check($key, $array){
    $array = (array) $array;
    if(array_key_exists($key, (array) $array)){
        return $array[$key];
    }else{
        return '';
    }
}
function setEnv($key, $data){
    $_ENV[$key] = $data;
}
function getEnvironment($key){
    if(array_key_exists($key, $_ENV)){
        return $_ENV[$key];
    }
}
function uiDate($date){
    if($date != ''){
        return date('jS, M Y H:i a', strtotime($date));
    }else{
        return '';
    }
}
function navActive($name){
    $name = str_replace('/', '\/', $name);
    if(preg_match('/(' . $name . ')/', $_SERVER['SCRIPT_NAME'])){
        return 'active';
    }
}
function encrypt($mprhase){
    if($mprhase == ''){
        return '';
    }
    $td            = mcrypt_module_open('tripledes', '', 'ecb', '');
    $iv            = mcrypt_create_iv(mcrypt_enc_get_iv_size($td), MCRYPT_RAND);
    mcrypt_generic_init($td, ENCRYPTION_KEY, $iv);
    $crypted_value = mcrypt_generic($td, $mprhase);
    mcrypt_generic_deinit($td);
    mcrypt_module_close($td);
    return base64url_encode($crypted_value);
}
function decrypt($mprhase){
    if($mprhase == ''){
        return '';
    }
    $mprhase = str_replace(' ', '+', $mprhase);
    $td      = mcrypt_module_open('tripledes', '', 'ecb', '');
    $iv      = mcrypt_create_iv(mcrypt_enc_get_iv_size($td), MCRYPT_RAND);
    mcrypt_generic_init($td, ENCRYPTION_KEY, $iv);
    $mprhase = base64url_decode($mprhase);
    if($mprhase == ''){
        return '';
    }
    $decrypted_value = mdecrypt_generic($td, $mprhase);
    mcrypt_generic_deinit($td);
    mcrypt_module_close($td);
    return trim($decrypted_value);
}
function decrypt_array($encarray){
    $return = array();
    if(!empty($encarray)){
        foreach($encarray as $item){
            $return[] = decrypt($item);
        }
    }
    return $return;
}
function encrypt_array($decarray){
    $return = array();
    if(!empty($decarray)){
        foreach($decarray as $item){
            $return[] = encrypt($item);
        }
    }
    return $return;
}
function base64url_encode($s){
    return str_replace(array('+', '/'), array('-', '_'), base64_encode($s));
}
function base64url_decode($s){
    return base64_decode(str_replace(array('-', '_'), array('+', '/'), $s));
}
function checkObj($v, $d){
    $c = isset($d->$v) ? $d->$v : '';
    return $c;
}
function cleanToken($token){
    $y = array();
    foreach($token as $t){
        $y[] = trim($t);
    }
    return $y;
}
function roundVal($p){
    if(is_float($p)){
        return round($p, 0, PHP_ROUND_HALF_UP);
    }else{
        return $p;
    }
}
function ucwords_ctc($str){
    return ucwords(strtolower($str));
}
function time_diff($start, $end){
    $start    = new DateTime($start);
    $end      = new DateTime($end);
    $interval = $start->diff($end);
    return $interval;
}
function find_diff($from_date, $current_date, $round_val = 0){
    $date1    = new DateTime($from_date);
    $date2    = new DateTime($current_date);
    $interval = date_diff($date1, $date2);
    if($interval->d > 0){
        if($interval->m == 0){
            $interval->m = $interval->m + 1;
        }
    }
    $years = $interval->y . '.' . $interval->m;
    return $years;
}
function find_diff_months($from_date, $current_date){
    $date1    = new DateTime($from_date);
    $date2    = new DateTime($current_date);
    $interval = date_diff($date1, $date2);
    if($interval->d > 0){
        if($interval->m == 0){
            $interval->m = $interval->m + 1;
        }
    }
    $interval->m = $interval->m + $interval->y * 12;
    return $interval->m;
}
function find_diff_days($from_date, $current_date, $round_val = 0){
    $date1    = new DateTime($from_date);
    $date2    = new DateTime($current_date);
    $interval = date_diff($date1, $date2);
    return $interval->days;
}
function months_to_years($month){
    if($month > 0){
        $month  = round($month * 12);
        $years  = (int) ($month / 12);
        $months = $month - (12 * $years);
        $yt     = $years > 1 ? 'Years' : 'Year';
        $mt     = $months > 1 ? 'Months' : 'Month';
        $t      = $years . ' ' . $yt . " " . $months . ' ' . $mt;
        return $t;
    }
    return $month;
}
function redirect_and_close_connection($url){
    $size = ob_get_length();
    header("Content-Encoding: none");
    header("Content-Length: $size");
    header("Location:" . $url);
    header('Connection: close');
    ob_end_flush();
    ob_flush();
    flush();
    if(session_id()){
        session_write_close();
    }
}
function close_connection(){
    $size = ob_get_length();
    header("Content-Encoding: none");
    header("Content-Length: $size");
    header('Connection: close');
    ob_end_flush();
    ob_flush();
    flush();
    if(session_id()){
        session_write_close();
    }
}
function func_sprintf($p){
    return sprintf("%4.2f", $p);
}
function displayDate($date){
    if($date != '' && $date != '0000-00-00'){
        return date('jS, M Y', strtotime($date));
    }else{
        return '';
    }
}
function displayDateTime($date){
    if($date != '' && $date != '0000-00-00 00:00:00'){
        return date('jS, M Y H:i', strtotime($date));
    }else{
        return '';
    }
}
function br2nl($string){
    return preg_replace("/<br[^>]*>\s*\r*\n*/is", "\n", $string);
}
function minify_output($buffer){
    $search  = array(
        '/\>[^\S ]+/s',
        '/[^\S ]+\</s',
        '/(\s)+/s'
    );
    $replace = array(
        '>',
        '<',
        '\\1'
    );
    $buffer  = preg_replace($search, $replace, $buffer);
    return $buffer;
}
function email_css(){
    echo '<style type="text/css">
		p {margin: 0;padding: 3px;}
		.top-head {background: none repeat scroll 0 0 #D7EBFF;white-space: nowrap;font-weight:bold;}
		table {border-collapse: collapse;margin: 5px 0;}
		.grey {background: none repeat scroll 0 0 #eef5f9;font-weight: bold;white-space: nowrap;}
		td {border: 1px solid #A8A8A8;padding: 5px;vertical-align: top;}
		th {border: 1px solid #A8A8A8;padding: 5px;vertical-align: top;}
		p,section,table,body,html{font-family:Garamond,sans-serif;}
	</style>';
}
function email_footer(){
    echo '<br> Thanks, <br>Monthly Meeting Application<br>
		For more details please visit the link <a href="' . SITE_URL . '">' . SITE_URL . '</a><br>
		<p>**This is an automatically generated email, please do not reply**</p>';
}
function email_footer_without_regard(){
    echo '<p>For more details please visit the link <a href="' . SITE_URL . '">' . SITE_URL . '</a></p><br>';
}
function email_footer_without_link(){
    echo '<br> Thanks, <br>Monthly Meeting Application<br>
		<p>**This is an automatically generated email, please do not reply**</p>';
}
function average($a, $n = false){
    $c = count($a);
    $s = 0;
    foreach($a as $v){
        $s += $v;
    }
    $a = $s / $c;
    if($n == true){
        return $a;
    }
    return number($a);
}
function entity_decode($str){
    return html_entity_decode($str, ENT_QUOTES, 'UTF-8');
}
function ordinal($number){
    $ends = array('th', 'st', 'nd', 'rd', 'th', 'th', 'th', 'th', 'th', 'th');
    if((($number % 100) >= 11) && (($number % 100) <= 13))
        return $number . 'th';
    else
        return $number . $ends[$number % 10];
}
function make_query(){
    $q = isset($_SERVER['QUERY_STRING']) ? $_SERVER['QUERY_STRING'] : '';
    $q = str_replace(Load::$url, '', $q);
    if($q != ''){
        $q = preg_replace('/&sort-by=[a-zA-Z_-]+/', '', $q);
        $q = preg_replace('/&order=[a-zA-Z_-]+/', '', $q);
    }else{
        $q = '';
    }
    $q = trim($q, '&');
    return $q;
}
function check_sort($item, $q){
    $i     = get('sort-by');
    $class = array(
        'asc'  => 'fa-sort-asc',
        'desc' => 'fa-sort-desc',
    );
    $c     = "fa-sort";
    $o     = 'asc';
    $order = get('order');
    if($item == $i){
        if(array_key_exists($order, $class)){
            $c = $class[$order];
        }
        if($order == 'asc'){
            $o = 'desc';
        }
    }
    $a = array(
        'link'  => '?' . $q . '&sort-by=' . $item . '&order=' . $o,
        'class' => $c
    );
    return (object) $a;
}
function show_success($type, $message){
    $array = array('type' => $type, 'message' => $message);
    echo json_encode($array);
}
function return_message($type, $message){
    return array('type' => $type, 'message' => $message);
}
function randomId($length = 14){
    // uniqid gives 13 chars, but you could adjust it to your needs.
    if(function_exists("random_bytes")){
        $bytes = random_bytes(ceil($length / 2));
    }elseif(function_exists("openssl_random_pseudo_bytes")){
        $bytes = openssl_random_pseudo_bytes(ceil($length / 2));
    }else{
        throw new Exception("no cryptographically secure random function available");
    }
    return substr(bin2hex($bytes), 0, $length);
}
function update_date($updateby, $date){
    return date('Y-m-d', strtotime($updateby, strtotime($date)));
}
function displayFormTime($time){
    if($time == ''){
        return '';
    }
    list($hours, $min, $second) = explode(':', (string) $time);
    return $hours . ":" . $min;
}
function displayFormDate($date){
    if($date == ''){
        return '';
    }
    list($year, $month, $date) = explode('-', (string) $date);
    return $date . '-' . $month . '-' . $year;
}
/**
 * This function will give Monday as start of week and Sunday as end of week.
 * @param type $date
 * @return type
 */
function first_last_date_week($date){
    list($y, $m, $d) = explode("-", $date);
    $day        = date('w');
    $array      = array(
        1 => 0,
        2 => 1,
        3 => 2,
        4 => 3,
        5 => 4,
        6 => 5,
        0 => 6,
    );
    $dif        = $array[$day];
    $week_start = date("Y-m-d", mktime(0, 0, 0, $m, $d - $dif, $y));
    $array      = array(
        1 => 6,
        2 => 5,
        3 => 4,
        4 => 3,
        5 => 2,
        6 => 1,
        0 => 0,
    );
    $dif        = $array[$day];
    $week_end   = date("Y-m-d", mktime(0, 0, 0, $m, $d + $dif, $y));
    $a          = array($week_start, $week_end);
    return $a;
}
function get_quarters($current_date = ''){
    $joining_date = date('Y-01-01');
    $date         = date('Y-m-d');
    $currentYM    = strtotime(date('Y-m'));
    $y            = date('Y');
    $start        = date($y . '-m-01', strtotime($joining_date));
    $py           = $y - 1;
    $n_start      = date($py . '-m-01', strtotime($joining_date));
    $quarters     = array();
    if($date < $start){
        $y       = $y - 1;
        $py      = $y - 1;
        $start   = date($y . '-m-01', strtotime($joining_date));
        $n_start = date($py . '-m-01', strtotime($joining_date));
    }
    /*
      for($i = 4; $i >= 1; $i--){
      $n_end = date('Y-m-t', strtotime('+2 months', strtotime($n_start)));
      $quarterEnd = strtotime(date('Y-m', strtotime($n_end)));
      $quarters['-'.$i]['start'] = $n_start;
      $quarters['-'.$i]['end'] = $n_end;
      $quarters['-'.$i]['display'] = date('F Y', strtotime($n_start)).' - '.date('F Y', strtotime($n_end));
      $n_start = date('Y-m-01', strtotime('+1 day', strtotime($n_end)));
      }
     * 
     */
    for($i = 1; $i <= 4; $i++){
        $end                     = date('Y-m-t', strtotime('+2 months', strtotime($start)));
        $quarterEnd1             = strtotime(date('Y-m', strtotime($end)));
        $quarters[$i]['start']   = $start;
        $quarters[$i]['end']     = $end;
        $quarters[$i]['display'] = date('F Y', strtotime($start)) . ' - ' . date('F Y', strtotime($end));
        $start                   = date('Y-m-01', strtotime('+1 day', strtotime($end)));
    }
    if(!empty($current_date)){
        foreach($quarters as $k => $v){
            $start = $v['start'];
            $end   = $v['end'];
            if(strtotime($current_date) >= strtotime($start) && strtotime($current_date) <= strtotime($end)){
                return $quarters[$k];
            }
        }
    }
    return $quarters;
}
function momApprovedCSS(){
    echo "<style type=\"text/css\">
    *[class=\"show\"] {
      overflow: visible !important;
      float: none !important;
      display: block !important;
      line-height: 100% !important;
    }

    body {
      background: #f4f2f3;
      font-family: \"garamond\";
    }

    p.MsoNormal,
    li.MsoNormal,
    div.MsoNormal {
      margin: 0in;
      margin-bottom: .0001pt;
      font-size: 11.0pt;
      font-family: \"Calibri\", sans-serif;
    }

    table {
      border-spacing: 0;
    }

    table td {
      border-collapse: collapse;
    }

    .ExternalClass {
      width: 100%;
    }

    .ExternalClass,
    .ExternalClass p,
    .ExternalClass span,
    .ExternalClass font,
    .ExternalClass td,
    .ExternalClass div {
      line-height: 100%;
    }

    .ReadMsgBody {
      width: 100%;
      background-color: #ebebeb;
    }

    table {
      mso-table-lspace: 0pt;
      mso-table-rspace: 0pt;
    }

    img {
      -ms-interpolation-mode: bicubic;
    }

    .yshortcuts a {
      border-bottom: none !important;
    }

    h1 {
      color: #f58220;
      font-size: 45px;
      font-weight: normal;
    }

    .title-bg {
      background: #f58220;
    }

    .side-bg {
      background: #14355d;
      color: #fff;
      font-size: 45px;
    }

    .side-bg label {
      width: 150px;
      word-wrap: break-word;
      font-weight: 400;
      display: block;
      margin: 25px;
      text-align: center;
    }

    .side-bg p {
      width: 150px;
      display: block;
      text-align: center;
    }

    h2 {
      font-size: 25px;
      color: #fff;
      font-weight: 400;
    }

    .dotted-border-top {
      border-bottom: 1px dashed #000000;
    }

    tr {
      border-bottom: 1pt solid black;
    }

    ol {
      min-width: 600px;
    }

    li {
      color: #666;
      font-size: 20px;
      line-height: 44px;
    }

    .dotted-table {
      /*border-bottom: 1px dashed #000000;*/
      color: #666;
      margin-top: 15px;
      border-color: currentcolor #000000 #000000;
    }

    .dotted-table td,
    .dotted-table th {
      border-color: currentcolor #000000 #000000;
      border-style: none dashed dashed none;
      border-width: 0 0px 1px;
      vertical-align: text-top;
    }

    .dotted-table td:first-child,
    .dotted-table td:nth-child(4),
    .dotted-table td:nth-child(5),
    .dotted-table td:nth-child(6) {
      text-align: center;
    }

    .dotted-table tr:last-child {
      border: none;
    }

    .dotted-table tr:last-child td,
    .dotted-table tr:last-child th {
      border-color: currentcolor #000000 #000000;
      border-style: none dashed dashed none;
      border-width: 0;
    }

    .dotted-table th {
      color: #f58220;
      font-size: 18px;
      font-weight: 400;
    }

    .dotted-table th p,
    .dotted-table td p {
      margin: 8px 0;
    }

    @media screen and (max-width: 599px) {
      .force-row,
      .container {
        width: 100% !important;
        max-width: 100% !important;
      }
    }

    @media screen and (max-width: 400px) {
      .container-padding {
        padding-left: 12px !important;
        padding-right: 12px !important;
      }
    }

    .ios-footer a {
      color: #aaaaaa !important;
      text-decoration: underline;
    }

    @media screen and (max-width: 599px) {
      .col {
        width: 100% !important;
        border-top: 1px solid #eee;
        padding-bottom: 0 !important;
      }
      .cols-wrapper {
        padding-top: 18px;
      }
      .img-wrapper {
        float: right;
        max-width: 40% !important;
        height: auto !important;
        margin-left: 12px;
      }
      .subtitle {
        margin-top: 0 !important;
      }
    }

    @media screen and (max-width: 400px) {
      .cols-wrapper {
        padding-left: 0 !important;
        padding-right: 0 !important;
      }
      .content-wrapper {
        padding-left: 12px !important;
        padding-right: 12px !important;
      }
    }

    body,
    td,
    th {
      font-family: garamond;
    }

    .MsoNormal {
      mso-margin-top-alt: auto;
      mso-margin-bottom-alt: auto;
      font-family: 'Garamond', serif;
      font-size: 20px;
      line-height: 22px;
      margin-bottom: 8px;
    }

    .MsoNormal1 {
      mso-margin-top-alt: auto;
      mso-margin-bottom-alt: auto;
      font-family: 'Garamond', serif;
      font-size: 20px;
      line-height: 22px;
      margin-bottom: 8px;
    }
  </style>";
}
function getTimeZoneDateTime($dateTime, $format = ''){
    $info         = getUserInfo();
    $userTimeZone = 'Asia/Kolkata';
    if($info->timezone != ''){
        $userTimeZone = $info->timezone;
    }
    $databaseTimeZone = 'Asia/Kolkata';
    $formatDT         = 'Y-m-d H:i:s';
    if(!empty($format)){
        $formatDT = $format;
    }
    $schedule_date = new DateTime($dateTime, new DateTimeZone($databaseTimeZone));
    $schedule_date->setTimeZone(new DateTimeZone($userTimeZone));
    return $actualTime    = $schedule_date->format($formatDT);
}
function displayDateWithTimeZone($date){
    return displayDate(getTimeZoneDateTime($date));
}
function displayDateTimeWithTimeZone($dateTime){
    return displayDateTime(getTimeZoneDateTime($dateTime));
}
function valid_pass($password){
    $dummy = array();
    if(!preg_match_all('$\S*(?=\S{8,})(?=\S*[a-z])(?=\S*[A-Z])(?=\S*[\d])(?=\S*[\W])\S*$', $password, $dummy))
        return FALSE;
    return TRUE;
}
function timeFormat($time, $f = 24){
    if(gettype($time) == 'string'){
        $time = strtotime($time);
    }
    return ($f == 24) ? date("G:i", $time) : date("g:i A", $time);
}
function dateToDbFromUsDate($date){
    if(preg_match("/([0-9]{2})-([0-9]{2})-([0-9]{4})/", $date)){
        $d = explode("-", $date);
        return $d[2] . "-" . $d[0] . "-" . $d[1];
    }else{
        return '';
    }
}
function displayFormDateUS($date){
    if($date == ''){
        return '';
    }
    list($year, $month, $date) = explode('-', (string) $date);
    return $month . '-' . $date . '-' . $year;
}
function displayDateMOC($date){
    if($date != '' && $date != '0000-00-00'){
        return date('M, jS Y', strtotime($date));
    }else{
        return '';
    }
}
function staticMenuArray($k = ''){
    $menuArray = array(
        'home'         => 'Home',
        'gallery'      => 'Gallery',
        'testimonials' => 'Testimonials'
    );
    if($k == ''){
        return $menuArray;
    }
    return $menuArray[$k];
}
function find_diff_comment($from_date, $current_date, $round_val = 0){
    $date1    = new DateTime($from_date);
    $date2    = new DateTime($current_date);
    $interval = date_diff($date1, $date2);
    if($interval->y > 0){
        $diff = $interval->y . " year(s) ago";
    }elseif($interval->m > 0){
        $diff = $interval->m . " month(s) ago";
    }elseif($interval->d > 0){
        $diff = $interval->d . " day(s) ago";
    }elseif($interval->h > 0){
        $diff = $interval->h . " hour(s) ago";
    }elseif($interval->i > 0){
        $diff = $interval->i . " minute(s) ago";
    }else{
        $diff = "Just Now";
    }
    return $diff;
}
