<?php
class HomeModel extends CI_Model{
    public function __construct(){
        parent::__construct();
    }
    public function getAllSubModules(){
        $subModuleData = array();
        $this->db->select('sub_module_id, approval_status')
            ->from('charity_sub_module_approvals');
        $res           = $this->db->get();
        if($res->num_rows() > 0){
            foreach($res->result() as $row){
                $subModuleData[] = $row;
            }
            return $subModuleData;
        }
        return $subModuleData;
    }
    public function getPages($pageId = ''){
        $pageData = array();
        $where    = '';
        if($pageId != ''){
            $where = ' page_id = ' . $pageId;
        }
        $query  = "SELECT * FROM charity_pages WHERE publish='y' and" . $where;
        $query  = rtrim($query, ' and ');
        $result = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $pageData[] = $row;
            }
            return $pageData;
        }
        return array();
    }
    public function getSettings(){
        $settingsData = array();
        $query        = "SELECT * FROM charity_settings";
        $result       = $this->db->query($query);
        if($result->num_rows() > 0){
            return $result->first_row();
        }
        return array();
    }
    public function getAllSliders(){
        $sliderData = array();
        $query      = "SELECT * FROM charity_sliders where publish='y'";
        $result     = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $sliderData[] = $row;
            }
            return $sliderData;
        }
        return array();
    }
    public function getAllEvents(){
        $eventData = array();
        $this->db->select('e.event_id, e.title, e.description, e.content, e.venue, e.event_image, ed.date_id, ed.event_date, ed.event_from_time, ed.event_to_time')
            ->from(DB_PREFIX . 'events as e')
            ->join(DB_PREFIX . 'event_dates as ed', 'e.event_id=ed.event_id', 'left')
            ->order_by('ed.event_date ASC, ed.event_from_time ASC');
        $res       = $this->db->get();
        if($res->num_rows() > 0){
            foreach($res->result() as $row){
                $eventData[] = $row;
            }
            return $eventData;
        }
        return $eventData;
    }
    public function getLatestEvent(){
        $latestEvent = array();
        $query       = "SELECT event_id, event_date, event_from_time from charity_event_dates order by event_date desc, event_from_time desc";
        $result      = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $latestEvent[] = $row;
            }
            return $latestEvent;
        }
        return $latestEvent;
    }
    public function getAllEventsWithDates(){
        $eventDetails = array();
        $query        = "SELECT me.event_id, me.title ,me.description ,me.event_image, me.publish, med.date_id, med.event_date, med.event_from_time, med.event_to_time "
            . "FROM charity_events AS me "
            . "INNER JOIN charity_event_dates "
            . "AS med ON me.event_id=med.event_id"
            . " WHERE me.publish='y'";
        $result       = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $eventDetails[] = $row;
            }
            return $eventDetails;
        }
        return $eventDetails;
    }
    public function getDatesByEventId($eventId){
        $eventDates = array();
        $sql        = "SELECT event_date,event_from_time,event_to_time FROM charity_event_dates where event_id=" . $eventId;
        $result     = $this->db->query($sql);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $row->event_date      = displayDateMOC($row->event_date);
                $row->event_from_time = timeFormat($row->event_from_time, 12);
                $row->event_to_time   = timeFormat($row->event_to_time, 12);
                $eventDates[]         = $row;
            }
            return $eventDates;
        }
        return $eventDates;
    }
    public function getEventsList(){
        $eventDetails = array();
        $query        = "SELECT me.event_id, me.title, me.description, me.content, me.event_image, med.event_date "
            . "from charity_events as me "
            . "Inner Join charity_event_dates as med "
            . "on me.event_id=med.event_id "
            . "WHERE me.publish='y'"
            . "group by me.event_id order by med.event_date ASC";
        $result       = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $row->event_date = displayDateMOC($row->event_date);
                $eventDetails[]  = $row;
            }
            return $eventDetails;
        }
        return $eventDetails;
    }
    public function getEventById($event_id){
        $event  = array();
        $query  = "SELECT event_id, title, description, content, event_image"
            . " FROM charity_events"
            . " WHERE publish='y' AND event_id=" . $event_id;
        $result = $this->db->query($query);
        if($result->num_rows() > 0){
            $event = $result->first_row();
            return $event;
        }
        return $event;
    }
    public function getAllAlbums(){
        $gallery = array();
        $query   = "SELECT ma.album_id, ma.album_name, ma.album_desc, ma.creation_date as album_creation_date,"
            . " mi.image_id, mi.image_name, mi.creation_date as image_creation_date"
            . " FROM charity_albums as ma"
            . " INNER JOIN charity_images as mi"
            . " ON ma.album_id=mi.album_id"
            . " WHERE ma.publish='y' ORDER BY mi.creation_date";
        $result  = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $gallery[] = $row;
            }
            return $gallery;
        }
        return $gallery;
    }
    public function getAlbumsForGallery(){
        $gallery = array();
        $this->db->select('a.album_id, a.album_name, a.album_desc, a.creation_date as album_creation_date, i.image_id, i.image_name, i.creation_date as image_creation_date')
            ->from(DB_PREFIX . 'albums as a')
            ->join(DB_PREFIX . 'images as i', 'a.album_id=i.album_id', 'inner')
            ->where('a.publish', 'y')
            ->order_by('i.creation_date');
        $result  = $this->db->get();
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $gallery[$row->album_id][] = $row;
            }
            return $gallery;
        }
        return $gallery;
    }
    public function getAllMenus(){
        $menus  = array(
            'header' => array(
                'items'   => array(),
                'parents' => array()
            ),
            'footer' => array(
                'items'   => array(),
                'parents' => array()
            )
        );
        $this->db->select('m.menu_id, m.menu_region, m.menu_name, m.parent, md.menu_url')
            ->from(DB_PREFIX . 'menu as m')
            ->join(DB_PREFIX . 'menu_details as md', 'm.menu_id=md.menu_id', 'inner')
            ->order_by('m.parent, m.menu_order, m.menu_name');
        $result = $this->db->get();
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $menus[$row->menu_region]['items'][$row->menu_id]    = $row;
                $menus[$row->menu_region]['parents'][$row->parent][] = $row->menu_id;
            }
            return $menus;
        }
        return array();
    }
    public function getHomepageBlog(){
        $this->db->select('blog_id, blog_key, title, content');
        $this->db->where(array('is_homepage' => 'y', 'publish' => 'y'));
        $res = $this->db->get(DB_PREFIX . 'blogs');
        if($res->num_rows() > 0){
            return $res->first_row();
        }
        return array();
    }
    public function getPageByKey($page_key = ''){
        $this->db->select('*');
        if($page_key != ''){
            $this->db->where('page_key', $page_key);
        }
        $res = $this->db->get(DB_PREFIX . 'pages');
        if($res->num_rows() > 0){
            return $res->first_row();
        }
        return array();
    }
    public function getAllCauses(){
        $causes = array();
        $this->db->select('cause_id, title, description, image');
        $this->db->where('publish', 'y');
        $res    = $this->db->get(DB_PREFIX . 'causes');
        if($res->num_rows() > 0){
            foreach($res->result() as $row){
                $causes[] = $row;
            }
            return $causes;
        }
        return $causes;
    }
    public function getAlltestimonials(){
        $testimonials = array();
        $this->db->select('testimonial_id, concat_ws(" ", first_name, last_name) as name, email, testimonial, photo');
        $this->db->where('approved', 'y');
        $res          = $this->db->get(DB_PREFIX . 'testimonials');
        if($res->num_rows() > 0){
            foreach($res->result() as $row){
                $testimonials[] = $row;
            }
            return $testimonials;
        }
        return $testimonials;
    }
    public function getAllWidgets(){
        $widgets = array();
        $this->db->select('widget_id, title, description, image, publish');
        $this->db->where('publish', 'y');
        $res     = $this->db->get(DB_PREFIX . 'widgets');
        if($res->num_rows() > 0){
            foreach($res->result() as $row){
                $widgets[] = $row;
            }
            return $widgets;
        }
        return $widgets;
    }
    public function getBlogHomePage() {
        $this->db->select('blog_key, title, content, ');
        $this->db->where(array('publish' => 'y', 'is_homepage' => 'y'));
        $res = $this->db->get(DB_PREFIX.'blogs');
        if($res->num_rows() > 0) {
            return $res->first_row();
        }
        return array();
    }
}
?>