<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
class QuestionsModel extends CI_Model{
    public function __construct(){
        parent::__construct();
    }
    public function getAllQuestions($num = 0, $offset = ''){
        $quesData = array();
        $this->db->select('q.question_id, q.user_id as question_by_id, q.question, q.description, q.is_anonymous as ques_anonymous, q.approved as question_approval, concat_ws(" ", mu.first_name, mu.last_name) as ques_by_name, q.creation_date as asked_on, a.answer_id, a.user_id as ans_by_id, a.answer, a.approved as answer_approval, a.creation_date as answered_on, a.is_anonymous as ans_anonymous, Concat_ws(" ", `mus`.`first_name`, mus.last_name) AS `ans_by_name`')
            ->from(DB_PREFIX.'questions as q')
            ->join(DB_PREFIX.'users as mu', 'q.user_id=mu.user_id', 'left')
            ->join(DB_PREFIX.'answers as a', 'a.question_id=q.question_id', 'left')
            ->join(DB_PREFIX.'users as mus', 'q.user_id=mus.user_id', 'left')
            ->order_by('a.creation_date', 'DESC')
            ->group_by('q.question_id')
            ->where('q.approved', 'y')
            ->limit($num, $offset);
        $res      = $this->db->get();
        if($res->num_rows() > 0){
            foreach($res->result() as $row){
                $row->asked_on = displayDateTime($row->asked_on);
                $quesData[]    = $row;
            }
            return $quesData;
        }
        return $quesData;
    }
    public function getQuestionByUserId($user_id){
        $quesData = array();
        $this->db->select('q.question_id, q.user_id, q.question, q.description, q.is_anonymous, concat_ws(" ", mu.first_name, mu.last_name) as name')
            ->from(DB_PREFIX.'questions as q')
            ->join(DB_PREFIX.'users as mu', 'q.user_id=mu.user_id', 'left');
        $this->db->where('q.user_id', $user_id);
        $res      = $this->db->get();
        if($res->num_rows() > 0){
            foreach($res->result() as $row){
                $quesData[] = $row;
            }
            return $quesData;
        }
        return $quesData;
    }
    public function addUpdateQuestion($quesData){
        if($this->checkExistingQuestions($quesData)){
            return array('type' => 'error', 'message' => 'Question already exists.');
        }
        $question_id = $quesData['question_id'];
        if(empty($question_id)){
            unset($quesData['updation_date']);
            unset($quesData['updated_by']);
            $this->db->insert(DB_PREFIX.'questions', $quesData);
            $insQuesId = $this->db->insert_id();
//            echo $this->db->last_query();
            return array('type' => 'success', 'message' => 'Question added successfully.', 'question_id' => $insQuesId);
        }else{
            unset($quesData['creation_date']);
            $this->db->update(DB_PREFIX.'questions', $quesData, array('question_id' => $quesData['question_id']));
            return array('type' => 'success', 'message' => 'Question updated successfully.', 'question_id' => $quesData['question_id']);
        }
    }
    public function checkExistingQuestions($data){
        $question_id = $data['question_id'];
        $question    = $data['question'];
        $this->db->where("question = '" . $question . "'");
        if(!empty($question_id)){
            $this->db->where('question_id !=', $question_id);
        }
        $result = $this->db->get(DB_PREFIX.'questions');
//        echo $this->db->last_query();
        if($result->num_rows() > 0){
            return true;
        }
        return false;
    }
    public function getQuestionsCount($user_id = ''){
        $this->db->select('question_id');
        if(!empty($user_id)){
            $this->db->where('user_id', $user_id);
        }
        $this->db->where('approved', 'y');
        $res = $this->db->get(DB_PREFIX.'questions');
        if($res->num_rows() > 0){
            return $res->num_rows();
        }
        return 0;
    }
}
?>