<?php
class BlogsModel extends CI_Model{
    public function __construct(){
        parent::__construct();
    }
    public function getBlogs(){
        $blogData = array();
        $query    = "SELECT mb.blog_id, mb.blog_key, mb.title, mb.publish, concat_ws(' ',mu.first_name, mu.last_name) as name, mu.user_type FROM charity_blogs as mb"
            . " LEFT JOIN charity_users as mu ON mb.created_by=mu.user_id ";
        $result   = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $blogData[] = $row;
            }
            return $blogData;
        }
        return $blogData;
    }
    public function getBlogDataById($blog_id){
        $blogData = array();
        $this->db->select('blog_id, blog_key, title, content, seo_title, seo_desc, seo_keywords, publish');
        $this->db->where('blog_id', $blog_id);
        $result   = $this->db->get(DB_PREFIX . 'blogs');
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $blogData = $row;
            }
            return $blogData;
        }
        return array();
    }
    public function insertUpdateBlog($insData){
        if($this->checkExistingBlogs($insData)){
            return array('type' => 'error', 'message' => 'Blog already exists.');
        }
        $blogId = $insData['blog_id'];
        if(empty($blogId)){
            unset($insData['updation_date']);
            unset($insData['updated_by']);
            $this->db->insert('charity_blogs', $insData);
            return array('type' => 'success', 'message' => 'Blog added successfully.');
        }else{
            unset($insData['creation_date']);
            unset($insData['created_by']);
            $this->db->update('charity_blogs', $insData, array('blog_id' => $blogId));
            return array('type' => 'success', 'message' => 'Blog updated successfully.');
        }
    }
    public function deleteBlog($blog_id){
        $this->db->where('blog_id', $blog_id);
        $this->db->delete('charity_blogs');
//        echo $this->db->last_query();
    }
    public function checkExistingBlogs($data){
        $blogId = $data['blog_id'];
        $title  = $data['title'];
        $this->db->where("title = '" . $title . "'");
        if(!empty($blogId)){
            $this->db->where('blog_id !=', $blogId);
        }
        $result = $this->db->get('charity_blogs');
        if($result->num_rows() > 0){
            return true;
        }
        return false;
    }
    public function getAllComments($blog_id = ''){
        $comments = array(
            'items'   => array(),
            'parents' => array()
        );
        $where    = "";
        if(!empty($blog_id)){
            $where = " where mbc.blog_id='" . $blog_id . "'";
        }
        $query = "SELECT mbc.comment_id, mbc.comment, mbc.blog_id, mbc.user_id, mbc.approved, mbc.parent, mbc.comment_date, mbc.deleted, "
            . " concat_ws(' ', mu.first_name, mu.last_name) as name "
            . " from charity_blog_comments as mbc "
            . " LEFT JOIN charity_users as mu on mbc.user_id=mu.user_id " . $where . " order by mbc.comment_date DESC";
        $res   = $this->db->query($query);
        if($res->num_rows() > 0){
            foreach($res->result() as $row){
                $comments['items'][$row->comment_id] = $row;
                $comments['parents'][$row->parent][] = $row->comment_id;
            }
        }
        return $comments;
    }
    public function changeHomepageStatus($blog_id){
        $blogData = $this->getBlogDataById($blog_id);
        if(!empty($blogData)){
            if($blogData->is_homepage == 'n'){
                $this->db->update(DB_PREFIX . 'blogs', array('is_homepage' => 'y'), array('blog_id' => $blog_id));
                $this->resetHomepageStatus($blog_id);
                return array('type' => 'success', 'message' => 'Blog set as home-page successfully.');
            }else{
                $this->db->update(DB_PREFIX . 'blogs', array('is_homepage' => 'n'), array('blog_id' => $blog_id));
                return array('type' => 'success', 'message' => 'Blog home-page status has been reset.');
            }
        }else{
            return array('type' => 'invalid_id');
        }
        $this->db->update('charity_blogs', array('is_homepage' => $is_homepage), array('blog_id' => $blog_id));
    }
    /*
     * Reset the is_homepage ststus of blogs,
     * other than the one whose status was recently set to 'y'
     */
    public function resetHomepageStatus($blog_id){
        $this->db->update('charity_blogs', array('is_homepage' => 'n'), array('blog_id <>' => $blog_id));
    }
    public function publishBlog($blog_id){
        $blogData = $this->getBlogDataById($blog_id);
        if(!empty($blogData)){
            if($blogData->publish == 'y'){
                $this->db->update(BD_PREFIX . 'blogs', array('publish' => 'y'), array('blog_id' => $blog_id));
                return array('type' => 'success', 'message' => 'Blog published successfully.');
            }else{
                $this->db->update(BD_PREFIX . 'blogs', array('publish' => 'n'), array('blog_id' => $blog_id));
                return array('type' => 'success', 'message' => 'Blog Un-published successfully.');
            }
        }else{
            return array('type' => 'invalid_id');
        }
    }
}
?>