<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
class CategoriesModel extends CI_Model{
    public function __construct(){
        parent::__construct();
    }
    public function getAllCategories(){
        $catData = array();
        $this->db->select('category_id, category_name, parent, hierarchy, approved');
        $result  = $this->db->get('charity_categories');
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $catData[] = $row;
            }
            return $catData;
        }
        return $catData;
    }
    public function getCategoryById($category_id){
        $catData = array();
        $this->db->select('category_id, category_name, parent, hierarchy, approved');
        $this->db->where('category_id', $category_id);
        $result  = $this->db->get('charity_categories');
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $catData = $row;
            }
            return $catData;
        }
        return $catData;
    }
    public function getQuestionById($question_id){
        $this->db->select('question_id, question, description, keywords, category_id');
        $this->db->where('question_id', $question_id);
        $result = $this->db->get('questions');
        if($result->num_rows() > 0){
            return $result->first_row();
        }
        return array();
    }
    public function getQuestionByCategoryId($category_id){
        $this->db->select('question_id, question, description, keywords, category_id');
        $this->db->where('category_id', $category_id);
        $result = $this->db->get('questions');
        if($result->num_rows() > 0){
            return $result->first_row();
        }
        return array();
    }
    public function addUpdateCategory($postData){
        $postData['parent']    = (empty($postData['parent'])) ? 0 : $postData['parent'];
        $postData['hierarchy'] = '';
        if($this->checkExistingCategory($postData)){
            return array('type' => 'error', 'message' => 'Category already exists');
        }
        $categoryId = $postData['category_id'];
        if(empty($categoryId)){
            $insCatData  = array(
                'category_name' => $postData['category_name'],
                'parent'        => $postData['parent'],
                'approved'      => $postData['approved'],
                'creation_date' => $postData['creation_date'],
                'created_by'    => $postData['created_by']
            );
            $this->db->insert('charity_categories', $insCatData);
            $category_id = $this->db->insert_id();
            $this->saveHierarchy($postData['parent'], $category_id);
            return array('type' => 'success', 'message' => 'Category added successfully');
        }else{
            $updMenuData = array(
                'category_name' => $postData['category_name'],
                'parent'        => $postData['parent'],
                'approved'      => $postData['approved'],
                'updation_date' => $postData['creation_date'],
                'updated_by'    => $postData['created_by']
            );
            $this->db->update('charity_categories', $updMenuData, array('category_id' => $postData['category_id']));
            $this->saveHierarchy($postData['parent'], $postData['category_id']);
            return array('type' => 'success', 'message' => 'Category updated successfully');
        }
    }
    public function saveHierarchy($parent_id, $category_id){
        if($parent_id == 0){
            $childHierarchy = $category_id;
        }else{
            $getHierachy     = $this->getCategoryById($parent_id);
            $parentHierarchy = $getHierachy->hierarchy;
            $childHierarchy  = $category_id . "," . $parentHierarchy;
        }
        $this->db->update('charity_categories', array('hierarchy' => $childHierarchy), array('category_id' => $category_id));
    }
    public function insertHierarchy($updData, $updWhere){
        return $this->db->update('charity_categories', $updData, $updWhere);
    }
    public function checkExistingCategory($data){
        $category_id   = $data['category_id'];
        $category_name = $data['category_name'];
        $this->db->where(array('category_name' => $category_name));
        if(!empty($category_id)){
            $this->db->where('category_id !=', $category_id);
        }
        $result = $this->db->get('charity_categories');
        if($result->num_rows() > 0){
            return true;
        }
        return false;
    }
    public function getCategoriesForView(){
        $categories = array(
            'items'   => array(),
            'parents' => array()
        );
        $this->db->select('category_id, category_name, parent');
        $this->db->order_by('category_name');
        $result     = $this->db->get('charity_categories');
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $categories['items'][$row->category_id] = $row;
                $categories['parents'][$row->parent][]  = $row->category_id;
            }
            return $categories;
        }
        return $categories;
    }
    public function checkCategoryForChild($category_id){
        $this->db->where("hierarchy LIKE('%," . $category_id . "%')");
        $this->db->select('COUNT(*) as count');
        $result = $this->db->get('charity_categories');
        $row    = $result->first_row();
        if($row->count > 0){
            return true;
        }
        return false;
    }
    public function deleteCategory($category_id){
        $this->db->where('category_id', $category_id);
        $this->db->delete('charity_categories');
    }
    public function approveCategory($category_id){
        $categoryData = $this->getCategoryById($category_id);
        if($categoryData->approved == 'n'){
            $this->db->update('charity_categories', array('approved' => 'y'), array('category_id' => $category_id));
            // Change the "category_id = other" and "other = 0" of the question
            $questionData = $this->getQuestionByOtherId($category_id);
            $this->updateQuesCategoryId($questionData->question_id, $category_id);
        }else{
            $this->db->update('charity_categories', array('approved' => 'n'), array('category_id' => $category_id));
            // Change "category_id = 0" and "other = category_id" of the question
            $questionData = $this->getQuestionByCategoryId($category_id);
            $this->updateQuesOther($questionData->question_id, $questionData->category_id);
        }
    }
    public function updateQuesCategoryId($question_id, $other){
        $this->db->update('questions', array('category_id' => $other, 'other' => 0), array('question_id' => $question_id));
    }
    public function updateQuesOther($question_id, $category_id){
        $this->db->update('questions', array('category_id' => 0, 'other' => $category_id), array('question_id' => $question_id));
    }
    public function getQuestionByOtherId($other){
        $this->db->select('question_id, question, description, keywords');
        $this->db->where('other', $other);
        $res = $this->db->get('questions');
        if($res->num_rows() > 0){
            return $res->first_row();
        }
        return array();
    }
}
?>