<?php
class CommentsModel extends CI_Model{
    public function __construct(){
        parent::__construct();
    }
    public function getAllBlogs(){
        $blogData = array();
        $this->db->select('blog_id, title');
        $res      = $this->db->get('charity_blogs');
        if($res->num_rows() > 0){
            foreach($res->result() as $row){
                $blogData[] = $row;
            }
        }
        return $blogData;
    }
    public function getComments($blog_id = ''){
        $where    = "";
        $comments = array(
            'items'   => array(),
            'parents' => array()
        );
        if(!empty($blog_id)){
            $where = " where mbc.blog_id='" . $blog_id . "'";
        }
        $query = "SELECT mbc.comment_id, mbc.comment, mbc.blog_id, mbc.user_id, mbc.approved, mbc.parent, mbc.comment_date, mbc.deleted, "
            . " concat_ws(' ', mu.first_name, mu.last_name) as name "
            . " from charity_blog_comments as mbc "
            . " LEFT JOIN charity_users as mu on mbc.user_id=mu.user_id " . $where . " order by mbc.comment_date DESC";
        $res   = $this->db->query($query);
        if($res->num_rows() > 0){
            foreach($res->result() as $row){
                $comments['items'][$row->comment_id] = $row;
                $comments['parents'][$row->parent][] = $row->comment_id;
            }
        }
        return $comments;
    }
    public function getBlogById($blog_id){
        $this->db->select('*');
        $this->db->where('blog_id', $blog_id);
        $res = $this->db->get('charity_blogs');
        if($res->num_rows() > 0){
            return $res->first_row();
        }
        return array();
    }
    public function getCommentById($comment_id){
        $this->db->select('*');
        $this->db->where('comment_id', $comment_id);
        $res = $this->db->get('charity_blog_comments');
        if($res->num_rows() > 0){
            return $res->first_row();
        }
        return array();
    }
    public function approveComment($comment_id){
        $commentData = $this->getCommentById($comment_id);
        if(!empty($commentData)){
            if($commentData->approved == 'y'){
                $this->db->update(BD_PREFIX . 'blog_comments', array('approved' => 'y'), array('comment_id' => $comment_id));
                return array('type' => 'success', 'message' => 'Comment Approved successfully.');
            }else{
                $this->db->update(BD_PREFIX . 'blog_comments', array('approved' => 'n'), array('comment_id' => $comment_id));
                return array('type' => 'success', 'message' => 'Comment Un-approved successfully.');
            }
        }else{
            return array('type' => 'invalid_id');
        }
    }
    public function deleteComment($comment_id){
        $commentData = $this->getCommentById($comment_id);
        if(!empty($commentData)){
            if($commentData->approved == 'n'){
                $this->db->update(DB_PREFIX.'blog_comments', array('deleted' => 'y'), array('comment_id' => $comment_id));
                return array('type' => 'success', 'message' => 'Comment marked as deleted.');
            }else{
                $this->db->update(DB_PREFIX.'blog_comments', array('deleted' => 'y'), array('comment_id' => $comment_id));
                return array('type' => 'success', 'message' => 'Comment marked as not-deleted.');
            }
        }else{
            return array('type' => 'invalid_id');
        }
    }
}
?>