<?php
if(!defined('BASEPATH'))
    exit('No direct script access allowed');
class EventsModel extends CI_Model{
    public function __construct(){
        parent::__construct();
    }
    public function getEvents(){
        $eventData = array();
        $query     = "SELECT * FROM charity_events";
        $result    = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $eventData[] = $row;
            }
            return $eventData;
        }
        return array();
    }
    public function getEventById($eventId){
        $query  = "SELECT * FROM charity_events where event_id=" . $eventId;
        $result = $this->db->query($query);
        if($result->num_rows() > 0){
            return $result->first_row();
        }
        return array();
    }
    public function getEventDataById($eventId){
        $eventDetails = array();
        $query        = "SELECT me.*, med.* "
            . "FROM charity_events AS me "
            . "INNER JOIN charity_event_dates "
            . "AS med ON me.event_id=med.event_id "
            . "WHERE med.event_id=" . $eventId . ""
            . " order by med.event_date";
        $result       = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $eventDetails[] = $row;
            }
            return $eventDetails;
        }
        return array();
    }
    public function getDateDataByEventId($eventId){
        $dateData = array();
        $query    = "SELECT * FROM charity_event_dates WHERE event_id = " . $eventId . " ORDER BY date_id";
        $result   = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $dateData[] = $row;
            }
            return $dateData;
        }
        return $dateData;
    }
    public function getDateData($dateId){
        $query  = "SELECT * FROM charity_event_dates WHERE date_id=" . $dateId;
        $result = $this->db->query($query);
        if($result->num_rows() > 0){
            return $result->first_row();
        }else{
            return array();
        }
    }
    public function insertUpdateEvent($insData){
        if($this->checkExistingEvents($insData)){
            return false;
        }
        $eventId = $insData['event_id'];
        if(empty($eventId)){
            unset($insData['updation_date']);
            unset($insData['updated_by']);
            $this->db->insert('charity_events', $insData);
            return $this->db->insert_id();
        }else{
            unset($insData['creation_date']);
            unset($insData['created_by']);
            $this->db->update('charity_events', $insData, array('event_id' => $eventId));
            return $eventId;
        }
    }
    public function checkExistingEvents($data){
//        pre($data);
        $eventId = $data['event_id'];
        $title   = $data['title'];
        $this->db->where("title = '" . $title . "'");
        if(!empty($eventId)){
            $this->db->where('event_id !=', $eventId);
        }
        $result = $this->db->get('charity_events');
        if($result->num_rows() > 0){
            return true;
        }
        return false;
    }
    public function deleteEvent($eventId){
        $this->deleteDatesByEventId($eventId);
        $getImage  = $this->getEventById($eventId);
        $image     = $getImage->event_image;
        $imagePath = SITE_ROOT . "skin/images/eventImages/" . $image;
        if(file_exists($imagePath)){
            unlink($imagePath);
        }
        $this->db->where('event_id', $eventId);
        $this->db->delete('charity_events');
    }
    public function deleteDatesByEventId($eventId){
        $this->db->where('event_id', $eventId);
        $this->db->delete('charity_event_dates');
    }
    public function insertDates($insData){
//        pre($insData);
        $this->db->insert('charity_event_dates', $insData);
        return $this->db->insert_id();
    }
    public function deleteDate($dateId){
        $this->db->where('date_id', $dateId);
        $this->db->delete('charity_event_dates');
    }
    public function updateDates($updData, $dateId){
        $this->db->update('charity_event_dates', $updData, array('date_id' => $dateId));
        return $this->db->affected_rows();
    }
}