<?php
if(!defined('BASEPATH'))
    exit('No direct script access allowed');

class GroupModel extends CI_Model{
    public function __construct(){
        parent::__construct();
    }
    public function getGroups(){
        $groups = array();
        $where = '';
        if(!empty($group_id)){
            $where = " group_id = '".$group_id."' ";
        }
        $sql = "SELECT * FROM charity_groups WHERE active='y'";
        $sql = rtrim($sql, ' and ');
        $result = $this->db->query($sql);
        if($result->num_rows() > 0){
            foreach($result->result_object() as $row){
                $groups[] = $row;
            }
        }
        return $groups;
    }
    public function getSubModules(){
        $getCol = array();
        $sql = "SELECT sub_module_id,module_id FROM charity_sub_modules";
        $query = $this->db->query($sql);
        foreach($query->result() as $row){
            $getCol[] = $row;
        }
        return $getCol;
    }
    public function insertGroup($data){
        if($this->checkExistingGroup($data)){
            return array('type' => 'error','message' => 'Group name already exists.');
        }
        $group_id = decrypt($data['group_id']);
        unset($data['group_id']);
        if(empty($group_id)){
            unset($data['updation_date']);
            unset($data['updated_by']);
            $this->db->insert('charity_groups',$data);
            $id = $this->db->insert_id();
            $a_subModules = $this->getSubmodules();
            if(!empty($a_subModules)){
                $a_dt = array();
                foreach($a_subModules as $k => $detail){
                    $module_id = $detail->module_id;
                    $sub_module_id = $detail->sub_module_id;
                    $permissions[] = array(
                        'group_id'      => $id,
                        'module_id'     => $module_id,
                        'sub_module_id' => $sub_module_id,
                        'add_rights'    => 'n',
                        'delete_rights' => 'n',
                        'edit_rights'   => 'n',
                        'view_rights'   => 'n',
                        'creation_date' => date("Y-m-d"),
                        'created_by'    => $this->session->userdata('user_id'),
                    );
                }
                $this->db->insert_batch('charity_permissions',$permissions);
            }
            return array('type' => 'success','message' => 'Group added successfully.');
        }
        else{
            unset($data['creation_date']);
            unset($data['created_by']);
            $this->db->update('charity_groups',$data,array('group_id' => $group_id));
            return array('type' => 'success','message' => 'Group updated successfully.');
        }
    }
    public function deleteGroup($id){
        $this->db->where('group_id',$id);
        $this->db->delete('charity_permissions');
        $this->db->where('group_id',$id);
        $this->db->delete('charity_groups');
    }
    public function checkExistingGroup($data){
        $group_id = decrypt($data['group_id']);
        $group_name = $data['group_name'];
        if(!empty($group_id)){
            $this->db->where('group_id != ',$group_id);
        }
        $this->db->where('group_name',$group_name);
        $result = $this->db->get('charity_groups');
        if($result->num_rows() > 0){
            return true;
        }
        return false;
    }
    public function checkForGroup($groupId) {
        $this->db->where('group_id', $groupId);
        $result = $this->db->get('charity_users');
        if($result->num_rows() > 0){
            return true;
        }
        return false;
    }
    public function getGroupById($groupId) {
        $query = "SELECT * FROM charity_groups where group_id=".$groupId;
        $result = $this->db->query($query);
        if($result->num_rows() > 0){
            return $result->first_row();
        }
        return array();
    }
}