<?php
class MenuModel extends CI_Model{
    public function __construct(){
        parent::__construct();
    }
    public function getAllPages(){
        $pageData = array();
        $this->db->select('page_id, title');
        $result   = $this->db->get(DB_PREFIX . 'pages');
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $pageData[] = $row;
            }
            return $pageData;
        }
        return $pageData;
    }
    public function getAllMenu($menu_id = ''){
        $where = '';
        if(!empty($menu_id)){
            $where = ' WHERE mm.menu_id=' . $menu_id;
        }
        $menuData = array();
        $query    = "SELECT mm.menu_id, mm.menu_region, mm.menu_order, mm.menu_name, mm.parent, mm.hierarchy, mmd.* "
            . " FROM charity_menu as mm "
            . " INNER JOIN charity_menu_details as mmd "
            . " ON mm.menu_id = mmd.menu_id " . $where;
        $result   = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $menuData[] = $row;
            }
            return $menuData;
        }
        return $menuData;
    }
    public function getParentMenu($menu_id = ''){
        $where = '';
        if(!empty($menu_id)){
            $where = ' and mm.menu_id=' . $menu_id;
        }
        $menuData = array();
        $query    = "SELECT mm.menu_id, mm.menu_region, mm.menu_order, mm.menu_name, mm.parent, mm.hierarchy, mmd.* "
            . " FROM charity_menu as mm "
            . " INNER JOIN charity_menu_details as mmd "
            . " ON mm.menu_id = mmd.menu_id "
            . " WHERE mm.menu_region='header' " . $where;
        $query    = rtrim($query, ' and ');
        $result   = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $menuData[] = $row;
            }
            return $menuData;
        }
        return $menuData;
    }
    public function getMenuById($menu_id){
        $menuData = array();
        $this->db->select('menu_id, menu_region, menu_name, parent, hierarchy');
        $this->db->where('menu_id', $menu_id);
        $result   = $this->db->get(DB_PREFIX . 'menu');
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $menuData = $row;
            }
            return $menuData;
        }
        return $menuData;
    }
    public function addUpdateMenu($postData){
        $postData['page_id']    = (empty($postData['page_id'])) ? 0 : $postData['page_id'];
        $postData['parent']     = (empty($postData['parent'])) ? 0 : $postData['parent'];
        $postData['menu_order'] = (empty($postData['menu_order'])) ? 0 : $postData['menu_order'];
        $postData['hierarchy']  = '';
        if($this->checkExistingMenu($postData)){
            return array('type' => 'error', 'message' => 'Menu already exists');
        }
        $menuId = $postData['menu_id'];
        if(empty($menuId)){
            $insMenuData = array(
                'menu_region'   => $postData['menu_region'],
                'menu_name'     => $postData['menu_name'],
                'parent'        => $postData['parent'],
                'menu_order'    => $postData['menu_order'],
                'creation_date' => $postData['creation_date'],
                'created_by'    => $postData['created_by']
            );
            $this->db->insert('charity_menu', $insMenuData);
            $menu_id     = $this->db->insert_id();
            $this->saveHierarchy(array('parent' => $postData['parent']), $menu_id);
            $this->saveMenuDetails($postData, $menu_id);
            return array('type' => 'success', 'message' => 'Menu added successfully');
        }else{
            $updMenuData = array(
                'menu_region'   => $postData['menu_region'],
                'menu_name'     => $postData['menu_name'],
                'parent'        => $postData['parent'],
                'menu_order'    => $postData['menu_order'],
                'updation_date' => $postData['creation_date'],
                'updated_by'    => $postData['created_by']
            );
            $this->db->update('charity_menu', $updMenuData, array('menu_id' => $postData['menu_id']));
            $this->saveHierarchy(array('parent' => $postData['parent']), $postData['menu_id']);
            $this->saveMenuDetails($postData, $postData['menu_id']);
            return array('type' => 'success', 'message' => 'Menu updated successfully');
        }
    }
    public function saveHierarchy($data, $menu_id){
        if($data['parent'] == 0){
            $childHierarchy = $menu_id;
        }else{
            $getHierachy     = $this->getMenuById($data['parent']);
            $parentHierarchy = $getHierachy->hierarchy;
            $childHierarchy  = $menu_id . "," . $parentHierarchy;
        }
        $this->db->update('charity_menu', array('hierarchy' => $childHierarchy), array('menu_id' => $menu_id));
    }
    public function saveMenuDetails($data, $menu_id){
        if($data['menu_type'] == 'page'){
            $data['menu_url'] = SITE_URL . "home/page?token=" . $data['page_id'];
        }
        $insDetailsData = array(
            'menu_id'   => $menu_id,
            'menu_type' => $data['menu_type'],
            'page_id'   => $data['page_id'],
            'menu_url'  => $data['menu_url']
        );
        if(!empty($data['menu_id'])){
            $this->db->update('charity_menu_details', $insDetailsData, array('menu_id' => $insDetailsData['menu_id']));
        }else{
            $this->db->insert('charity_menu_details', $insDetailsData);
        }
    }
    public function checkExistingMenu($data){
        $menuId     = $data['menu_id'];
        $menuName   = $data['menu_name'];
        $menuRegion = $data['menu_region'];
        $this->db->where(array('menu_name' => $menuName, 'menu_region' => $menuRegion));
        if(!empty($menuId)){
            $this->db->where('menu_id !=', $menuId);
        }
        $result = $this->db->get('charity_menu');
        if($result->num_rows() > 0){
            return true;
        }
        return false;
    }
    public function getAllMenus(){
        $menus  = array(
            'header' => array(
                'items'   => array(),
                'parents' => array()
            ),
            'footer' => array(
                'items'   => array(),
                'parents' => array()
            )
        );
        $query  = "SELECT menu_id, menu_region, menu_name, parent FROM charity_menu ORDER BY parent, menu_order, menu_name";
        $result = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $menus[$row->menu_region]['items'][$row->menu_id]    = $row;
                $menus[$row->menu_region]['parents'][$row->parent][] = $row->menu_id;
            }
            return $menus;
        }
        return array();
    }
    public function getMenuDetailByMenuId($menuId){
        $menuDetails = array();
        $query       = "SELECT * from charity_menu_details where menu_id='" . $menuId . "'";
        $result      = $this->db->query($query);
        if($result->num_rows() > 0){
            foreach($result->result() as $row){
                $menuDetails = $row;
            }
            return $menuDetails;
        }
        return $menuDetails;
    }
    public function checkMenuForChild($menu_id){
        $query  = "SELECT COUNT(*) as count from charity_menu where hierarchy LIKE('%," . $menu_id . "%')";
        $result = $this->db->query($query);
        $row    = $result->first_row();
        if($row->count > 0){
            return true;
        }
        return false;
    }
    public function deleteMenu($menu_id){
        $this->db->where('menu_id', $menu_id);
        $this->db->delete('charity_menu');
        $this->db->where('menu_id', $menu_id);
        $this->db->delete('charity_menu_details');
    }
}
?>