<?php
if(!defined('BASEPATH'))
    exit('No direct script access allowed');

class PermissionModel extends CI_Model{
    public function __construct(){
        parent::__construct();
    }
    public function getPermissions($condition){
        $where = '';
        $permissions = array();
        if(!empty($condition)){
            $where = ' where ';
            foreach($condition as $key => $value){
                $where .= $key.'="'.$value.'" and ';
            }
        }
        $sql = "SELECT * FROM charity_permissions ".$where;
        $sql = trim($sql,' and ');
        $query = $this->db->query($sql);
        foreach($query->result() as $row){
            $permissions[] = $row;
        }
        return $permissions;
    }
    public function getAllPermissions($pId = '',$groupId = ''){
        $where = '';
        $allPermissions = array();
        if($pId != ''){
            $where = 'where mp.permission_id ="'.$pId.'"';
        }
        if($groupId != ''){
            $where = 'where mg.group_id ="'.$groupId.'"';
        }
        $sql = "SELECT mp.permission_id, mp.add_rights, mp.delete_rights, mp.edit_rights, mp.view_rights, mg.group_id, mg.group_name, mm.module_id, mm.module_name, msm.sub_module_id, msm.sub_module_name  "
        ."from charity_permissions as mp "
        ."Inner Join charity_groups as mg on mp.group_id=mg.group_id "
        ."Inner Join charity_modules as mm on mp.module_id=mm.module_id "
        ."Inner Join charity_sub_modules as msm on mp.sub_module_id=msm.sub_module_id ".$where;
        $query = $this->db->query($sql);
        foreach($query->result() as $row){
            $allPermissions[] = $row;
        }
        return $allPermissions;
    }
    public function updatePermissions($data){
        $permission_id = $data['permission_id'];
        $group_id = $data['group_id'];
        $token = encrypt($permission_id.'~'.$group_id);
        unset($data['permission_id'],$data['group_id']);
        $this->db->update('charity_permissions',$data,array('permission_id' => $permission_id));
        return array('type' => 'success','message' => 'Permission saved successfully.','token' => $token);
    }
    public function permissionsByGroup($data){
        $where = '';
        $group_id = $data['group_id'];
        $permission_id = $data['permission_id'];
        $allPermissions = array();
        if(!empty($group_id)){
            $where = ' where mg.group_id ="'.$group_id.'"';
        }
        if(!empty($permission_id)){
            $where = ' where mp.permission_id ="'.$permission_id.'"';
        }

        $sql = "SELECT mp.permission_id, mp.add_rights, mp.delete_rights, mp.edit_rights, mp.view_rights, mg.group_id, "
        ."mg.group_name, mm.module_id, mm.module_name, msm.sub_module_id, msm.sub_module_name  "
        ."from charity_permissions as mp "
        ."Inner Join charity_groups as mg on mp.group_id=mg.group_id "
        ."Inner Join charity_modules as mm on mp.module_id=mm.module_id "
        ."Inner Join charity_sub_modules as msm on mp.sub_module_id=msm.sub_module_id ".$where;
        $query = $this->db->query($sql);
        foreach($query->result() as $row){
            $allPermissions[] = $row;
        }
        return $allPermissions;
    }
}