<script src="<?php echo SITE_URL; ?>js/admin/app/admin.pages.js"></script>
<div class="content-wrapper">
    <section class="content-header">
        <h1><?php echo $text = (!empty($pageData)) ? 'Edit Page' : 'Add Page' ?></h1>
    </section>

    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="box box-info">
                    <div class="box-header with-border">
                        <h3 class="box-title">Editor</h3>
                        <div class="box-tools pull-right">
                            <button type="button" class="btn btn-info" data-toggle="collapse" data-target="#addPages">
                                <span class="fa fa-plus"></span>
                            </button>
                        </div>
                    </div>
                    <form name="addPages" id="addPages" method="POST" class="collapse">
                        <div class="box-body">
                            <div class="col-md-6">
                                <!-- Hidden Field to get the value of id -->
                                <input type="hidden" name="pageId" id="pageId" value="<?php
                                if(!empty($pageData)){
                                    echo $pageData->page_id;
                                }
                                ?>">
                                <div class="form-group">
                                    <label class="mandatory">Page Title</label>
                                    <input type="text" class="form-control" name="pageTitle" id="pageTitle" value="<?php
                                    if(!empty($pageData)){
                                        echo $pageData->title;
                                    }
                                    ?>" data-validation-engine="validate[required]" data-prompt-position="topLeft">
                                </div>
                                <div class="form-group">
                                    <label>Page Content</label>
                                    <textarea class="form-control" name="pageContent" id="pageContent"><?php
                                        if(!empty($pageData)){
                                            echo $pageData->content;
                                        }
                                        ?></textarea>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="mandatory">SEO Titles</label>
                                    <textarea class="form-control" name="seoTitle" id="seoTitle" data-validation-engine="validate[required]" data-prompt-position="topLeft"><?php
                                        if(!empty($pageData)){
                                            echo $pageData->seo_title;
                                        }
                                        ?></textarea>
                                </div>
                                <div class="form-group">
                                    <label class="mandatory">SEO Description</label>
                                    <textarea class="form-control" name="seoDesc" id="seoDesc" data-validation-engine="validate[required]" data-prompt-position="topLeft"><?php
                                        if(!empty($pageData)){
                                            echo $pageData->seo_desc;
                                        }
                                        ?></textarea>
                                </div>
                                <div class="form-group">
                                    <label>SEO Keywords</label>
                                    <textarea class="form-control" name="seoKeywords" id="seoKeywords"><?php
                                        if(!empty($pageData)){
                                            echo $pageData->seo_keywords;
                                        }
                                        ?></textarea>
                                </div>
                                <div class="form-group">
                                    <input type="checkbox" name="publish"
                                    <?php
                                    if(!empty($pageData) && $pageData->publish == 'y'){
                                        echo 'checked';
                                    }
                                    ?>
                                           >
                                    <label>Publish this page</label>
                                </div>
                            </div>
                        </div>
                        <div class="box-footer">
                            <div class="form-group">
                                <?php
                                $subGrp = $this->a_sub_group_id[0];
                                $access = $this->a_access[$subGrp];
                                if($access->add_rights == 'y'){
                                    ?>
                                    <input type="submit" class="btn btn-primary" id="addPageBtn" value="<?php echo $submit = (!empty(get('token'))) ? 'Update' : 'Add'; ?>">
                                    <?php
                                }else{
                                    if($edit){
                                        if($access->edit_rights == 'y'){
                                            ?>
                                            <input type="submit" class="btn btn-primary" id="addPageBtn" value="<?php echo $submit = (!empty(get('token'))) ? 'Update' : 'Add'; ?>">
                                            <?php
                                        }
                                    }
                                }
                                ?>
                                <input type="button" class="btn btn-primary" value="Cancel" onclick="javascript:location.reload();">
                            </div>
                        </div>
                    </form>
                </div>
            </div>
            <div class="col-md-12">
                <div class="box box-warning">
                    <div class="box-header with-border">
                        <h3 class="box-title">Pages</h3>
                    </div>
                    <div class="box body no-padding">
                        <table class="table table-condensed" id="memberTable">
                            <thead>
                                <tr>
                                    <th> # </th>
                                    <th> Page Title </th>
                                    <th> Action </th>                
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $i = 1;
                                $j = 0;
                                foreach($allPages as $key => $data){
                                    ?>
                                    <tr>
                                        <td><?php echo $i; ?></td>
                                        <td><?php echo ucfirst($data->title); ?></td>
                                        <td>
                                            <?php if($access->edit_rights == 'y'){ ?>
                                                <a href="<?php echo SITE_URL; ?>admin/pages/index?token=<?php echo encrypt($data->page_id); ?>" class="btn btn-secondary">Edit</a>
                                            <?php } ?> |
                                            <?php if($access->delete_rights == 'y'){ ?>
                                                <input type="submit" name="page_del_btn" id="page_del_btn" class="btn btn-secondary" value="Delete" token="<?php echo $data->page_id; ?>">
                                            <?php } ?>
                                        </td>
                                    </tr>  
                                    <?php
                                    $i++;
                                    $j++;
                                }
                                ?>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
    </section>
</div>