<script src="<?php echo SITE_URL; ?>js/admin/app/admin.menu.js"></script>
<div class="content-wrapper">
    <section class="content-header">
        <h1>Menu Settings</h1>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-4">
                <div class="box box-primary">
                    <div class="box-header with-border">
                        <h3 class="box-title">Add Menu</h3>
                    </div>                    
                    <div class="box-body">
                        <form name="addMenu" id="addMenu" method="POST">
                            <input type="hidden" name="menuId" id="pageId" value="<?php echo encrypt($form->menu_id); ?>">
                            <div class="form-group">
                                <label>Select Region</label>
                                <select name="menuRegion" id="menuRegion" class="form-control" data-validation-engine="validate[required]" data-prompt-position="topLeft">
                                    <option value="">--- Select ---</option>
                                    <option value="header" <?php echo ($form->menu_region == 'header') ? 'selected' : ''; ?> >Header</option>
                                    <option value="footer" <?php echo ($form->menu_region == 'footer') ? 'selected' : ''; ?> >Footer</option>
                                </select>
                            </div>
                            <div class="form-group">
                                <label>Menu Name</label>
                                <input type="text" name="menuName" class="form-control" value="<?php echo $form->menu_name; ?>" data-validation-engine="validate[required]" data-prompt-position="topLeft">
                            </div>
                            <div class="form-group">
                                <label>Select Menu Type</label>
                                <select name="menuType" id="menuType" class="form-control" data-validation-engine="validate[required]" data-prompt-position="topLeft">
                                    <option value="">--- Select ---</option>
                                    <option value="page" <?php echo ($form->menu_type == 'page') ? 'selected' : ''; ?> >Page</option>
                                    <option value="link" <?php echo ($form->menu_type == 'link') ? 'selected' : ''; ?> >Link</option>
                                </select>
                            </div>
                            <div class="form-group" id="pagesDropDown" style="display: none;">
                                <label>Select Pages</label>
                                <select name="menuPage" class="form-control" data-validation-engine="validate[required]" data-prompt-position="topLeft">
                                    <option value="">--- Select --- </option>
                                    <?php foreach($pages as $k => $page){ ?>
                                        <option value="<?php echo $page->page_id; ?>" <?php echo ($form->page_id == $page->page_id) ? 'selected' : ''; ?> ><?php echo $page->title; ?></option>
                                    <?php } ?>
                                </select>
                            </div>
                            <div class="form-group" id="linkUrl" style="display: none;">
                                <label>Link for the menu item</label>
                                <input type="text" name="menuLink" class="form-control" value="<?php echo $form->menu_url; ?>" data-validation-engine="validate[required]" data-prompt-position="topLeft" />
                            </div>
                            <div class="form-group" id="parentMenuDiv">
                                <label>Select Parent Menu</label>
                                <select name="menuParent" class="form-control">
                                    <option value="">--- Select ---</option>
                                    <?php
                                    foreach($parentMenu as $k => $menu){
                                        if($menu->menu_id != $form->menu_id){
                                            ?>
                                            <option value="<?php echo $menu->menu_id; ?>" <?php echo ($form->parent == $menu->menu_id) ? 'selected' : ''; ?> ><?php echo $menu->menu_name; ?></option>
                                            <?php
                                        }
                                    }
                                    ?>
                                </select>
                            </div>
                            <div class="form-group">
                                <label>Select Menu Order</label>
                                <select name="menuOrder" class="form-control">
                                    <option value="">--- Select ---</option>
                                    <?php foreach($menus as $k => $menu){ ?>
                                        <option value="<?php echo $k + 1 ?>" <?php echo ($form->menu_order == $k + 1) ? 'selected' : ''; ?> ><?php echo $k + 1; ?></option>
                                    <?php } ?>
                                </select>
                            </div>
                            <div class="box-footer">
                                <div class="form-group">
                                    <?php
                                    $subGrp = $this->a_sub_group_id[0];
                                    $access = $this->a_access[$subGrp];
                                    if($access->add_rights == 'y'){
//                                
                                        ?>
                                        <input class="btn btn-primary" type="submit" name="add_menu_btn" id="add_menu_btn" value="<?php echo $form->submit; ?>" >
                                        <?php
                                    }else{
                                        if($edit){
                                            if($access->edit_rights == 'y'){
                                                ?>
                                                <input class="btn btn-primary" type="submit" name="add_menu_btn" id="add_menu_btn" value="<?php echo $form->submit; ?>" >
                                                <?php
                                            }
                                        }
                                    }
//                            
                                    ?>  
                                    <input type="button" class="btn btn-primary" value="Cancel" onclick="redirect('admin/menu');">
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
            <div class="col-md-8">
                <div class="box box-warning">
                    <div class="box-header with-border">
                        <h3 class="box-title">Menus</h3>
                    </div>
                    <div class="box body no-padding">
                        <table class="table table-condensed" id="menuTable">
                            <thead>
                                <tr>
                                    <th>#</th>                                    
                                    <th>Menu Title</th>
                                    <th>Menu Region</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>

                                <?php
                                $i = 1;
                                foreach($menus as $k => $menu){
                                    ?>
                                    <tr>
                                        <td><?php echo $i; ?></td>
                                        <td><?php echo $menu->menu_name; ?></td>
                                        <td><?php echo ucfirst($menu->menu_region); ?></td>
                                        <td>
                                            <?php if($access->edit_rights == 'y'){ ?>
                                                <a href="<?php echo SITE_URL; ?>admin/menu/index?token=<?php echo encrypt($menu->menu_id); ?>" class="btn btn-secondary">Edit</a> |
                                            <?php } ?>
                                            <?php if($access->delete_rights == 'y'){ ?>
                                                <input type="submit" name="menu_del_btn" id="menu_del_btn" class="btn btn-secondary" value="Delete" token="<?php echo encrypt($menu->menu_id); ?>">
                                            <?php } ?>
                                        </td>
                                    </tr>
                                    <?php
                                    $i++;
                                }
                                ?>

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            <div class="col-md-4">
                <div class="box box-warning">
                    <div class="box-header with-border">
                        <h3 class="box-title">Menu Structure</h3>
                    </div>
                    <div class="box body no-padding">
                        <div class="row">
                            <div class="col-md-6">
                                <?php
                                if(!empty($viewMenu['headerMenu'])){
                                    echo '<h4>' . "Header Menu" . '</h4>';
                                    echo $viewMenu['headerMenu'];
                                }else{
                                    echo "No Header Menu(s) Found";
                                }
                                ?>
                            </div>
                            <div class="col-md-6">
                                <?php
                                if(!empty($viewMenu['footerMenu'])){
                                    echo '<h4>' . "Footer Menu" . '</h4>';
                                    echo $viewMenu['footerMenu'];
                                }else{
                                    echo "No Footer Menu(s) Found";
                                }
                                ?>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</div>