<script src="<?php echo SITE_URL; ?>js/admin/app/admin.questions.js"></script>
<div class="content-wrapper">
    <section class="content-header">
        <h1>Questions</h1>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-6">
                <div class="col-md-12">
                    <div class="box box-primary">
                        <div class="box-header with-border">
                            <h3 class="box-title">Add A Question</h3>
                            <div class="box-tools pull-right">
                                <button type="button" class="btn btn-info" id="toggleForm" data-toggle="collapse" data-target="#addQuestion">
                                    <span class="fa fa-plus"></span>
                                </button>
                            </div>
                        </div>                    
                        <div class="box-body">
                            <form name="addQuestion" id="addQuestion" method="POST">
                                <input type="hidden" name="questionId" id="questionId" value="<?php echo encrypt($form->question_id); ?>">
                                <div class="form-group">
                                    <label>Question</label>
                                    <input type="text" name="question" id="question" class="form-control" placeholder="Write your question" value="<?php echo $form->question; ?>" data-validation-engine="validate[required]" data-prompt-position="topLeft">
                                </div>
                                <div class="form-group">
                                    <label>Description</label>
                                    <textarea class="form-control" name="description" id="description" placeholder="Explain your question"><?php echo $form->description; ?></textarea>
                                </div>
                                <div class="form-group">
                                    <input type="checkbox" name="anonymous" id="approval" <?php echo ($form->is_anonymous == '1') ? 'checked' : ''; ?> >
                                    <label>Post as Anonymous</label>
                                </div>
                                <div class="form-group">
                                    <input type="checkbox" name="approval" id="approval" <?php echo ($form->approved == 'y') ? 'checked' : ''; ?>>
                                    <label>Approve this question</label>
                                </div>
                                <div class="box-footer">
                                    <div class="form-group">
                                        <?php
                                        $subGrp = $this->a_sub_group_id[0];
                                        $access = $this->a_access[$subGrp];
                                        if($access->add_rights == 'y'){
                                            ?>
                                            <input class="btn btn-primary" type="submit" name="addCatBtn" id="addCatBtn" value="<?php echo $form->submit; ?>" >
                                            <?php
                                        }else{
                                            if($edit){
                                                if($access->edit_rights == 'y'){
                                                    ?>
                                                    <input class="btn btn-primary" type="submit" name="addCatBtn" id="addCatBtn" value="<?php echo $form->submit; ?>" >
                                                    <?php
                                                }
                                            }
                                        }
                                        ?>  
                                        <input type="button" class="btn btn-primary" value="Cancel" onclick="javascript:location.reload();">
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
                <div class="col-md-12">
                    <div class="box box-warning">
                        <div class="box-header with-border">
                            <h3 class="box-title">Questions</h3>
                        </div>
                        <div class="box body no-padding">
                            <table class="table table-condensed" id="questionsTable">
                                <thead>
                                    <tr>
                                        <th id="filterQuestionId">#</th>                                    
                                        <th id="filterQuesName">Question</th>
                                        <th id="filterQuesApprovalStatus">Approval Status</th>
                                        <th id="filterQuesAskedBy">Asked By</th>
                                        <th id="filterAnonymous">Asked As Anonymous</th>
                                        <th id="filterQuesAskedOn">Asked On</th>
                                        <th id="filterQuesAction">Action</th>
                                    </tr>
                                </thead>
                                <tbody>

                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                <div id="questionText"></div>
                <div id="answersDiv"></div>
            </div>
        </div>
    </section>
</div>
<script type="text/html" id="answersTemplate">
    <div class="row">
        <div class="col-md-12">
            <div class="box box-widget">
                <div class="box-header with-border">
                    <div class="user-block">
                        <img class="img-circle" src="<?php echo SITE_URL; ?>skin/images/user2.png" alt="User Image">
                        <span class="username">${answered_by}</span>
                        <span class="description">${answered_on}</span>
                        <span class="description ">
                            Answer Approval Status:
                            {%if approved=='y'%}
                            <a href="javascript:void(0);" q_data="${question_id}" a_data="${answer_id}" class="approveAnswer"><span class="label label-success">Approved</span></a>
                            {%else%}
                            <a href="javascript:void(0);" q_data="${question_id}" a_data="${answer_id}" class="approveAnswer"><span class="label label-danger">Not Approved</span></a>
                            {%/if%}
                        </span>
                        <span class="description pull-right">{%if is_anonymous=='1'%}<b>Answered as Anonymous</b>{%/if%}</span>
                    </div>
                    <div class="box-tools">
                        <button type="button" class="btn btn-box-tool" data-toggle="collapse" data-target="#user${user_id}"><i class="fa fa-caret-square-o-down"></i>
                        </button>
                    </div>
                </div>
                <div class="box-body collapse" id="user${user_id}">{%html answer%}</div>
            </div>
        </div>
    </div>
</script>