<script src="<?php echo SITE_URL; ?>js/admin/app/admin.testimonials.js"></script>
<div class="content-wrapper">
    <section class="content-header">
        <h1>Testimonials</h1>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-7">
                <div class="box box-primary">
                    <div class="box-header with-border">
                        <h3 class="box-title">Edit Testimonials</h3>
                    </div>                    
                    <div class="box-body">
                        <form name="addTestimonial" id="addTestimonial" method="POST" enctype="multipart/form-data">
                            <input type="hidden" name="testimonialId" id="testimonialId" value="<?php echo encrypt($form->testimonial_id); ?>">
                            <div class="row">
                                <div class="col-md-8">
                                    <div class="form-group">
                                        <label>First Name</label>
                                        <input class="form-control" name="firstName" id="firstName" value="<?php echo $form->first_name; ?>" />
                                    </div>
                                    <div class="form-group">
                                        <label>Last Name</label>
                                        <input class="form-control" name="lastName" id="lastName" value="<?php echo $form->last_name; ?>" />
                                    </div>
                                    <div class="form-group">
                                        <label>Email</label>
                                        <input class="form-control" name="email" id="email" value="<?php echo $form->email; ?>" />
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="form-group" id="photoPreview">
                                        <?php if(!empty($form->photo)){ ?>
                                            <img src="<?php echo SITE_URL; ?>skin/images/testimonialImages/<?php echo $form->photo; ?>" height="200px" width="100%"/>
                                        <?php } ?>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="form-group col-md-12">
                                    <label>User Photo</label>
                                    <input type="file" name="photo" id="photo" />
                                </div>
                            </div>
                            <div class="row">
                                <div class="form-group col-md-12">
                                    <label>Testimonial</label>
                                    <textarea class="form-control" rows="6" name="testimonial" id="remarks"><?php echo $form->testimonial; ?></textarea>
                                </div>
                            </div>
                            <div class="row">
                                <div class="form-group col-md-12">
                                    <input type="checkbox" name="approved" id="approved" <?php echo ($form->approved == 'y') ? 'checked' : ''; ?>/>
                                    <label>Approve this testimonial</label>
                                </div>
                            </div>
                            <div class="box-footer">
                                <div class="form-group">
                                    <?php
                                    $subGrp = $this->a_sub_group_id[0];
                                    $access = $this->a_access[$subGrp];
                                    if($access->add_rights == 'y'){
//                                
                                        ?>
                                        <input class="btn btn-primary" type="submit" name="add_testimonial_btn" id="add_testimonial_btn" value="<?php echo $form->submit; ?>" >
                                        <?php
                                    }else{
                                        if($edit){
                                            if($access->edit_rights == 'y'){
                                                ?>
                                                <input class="btn btn-primary" type="submit" name="add_testimonial_btn" id="add_testimonial_btn" value="<?php echo $form->submit; ?>" >
                                                <?php
                                            }
                                        }
                                    }
//                            
                                    ?>
                                    <input type="button" class="btn btn-primary" value="Cancel" onclick="javascript:location.reload();">
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
            <div class="col-md-5">
                <div class="box box-warning">
                    <div class="box-header with-border">
                        <h3 class="box-title">Testimonials</h3>
                    </div>
                    <div class="box body no-padding">
                        <table class="table table-condensed" id="menuTable">
                            <thead>
                                <tr>
                                    <th>#</th>                                    
                                    <th>Name</th>
                                    <th>Status</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $i = 1;
                                foreach($allTestimonials as $k => $testimonial){
                                    ?>
                                    <tr>
                                        <td><?php echo $i; ?></td>
                                        <td><?php echo ucwords($testimonial->first_name.' '.$testimonial->last_name); ?></td>
                                        <td>
                                            <?php 
                                            $t_data = "";
                                            if($access->edit_rights == 'y') {
                                                $t_data = encrypt($testimonial->testimonial_id);
                                            }
                                            echo ($testimonial->approved == 'y') ? 
                                                '<a href="javascript:void(0);" class="approveTestimonial" t_data="'.$t_data.'"><span class="label label-success">Approved</span></a>' : 
                                                '<a href="javascript:void(0);" class="approveTestimonial" t_data="'.$t_data.'"><span class="label label-danger">Not Approved</span></a>'; 
                                            ?>
                                        </td>
                                        <td>
                                            <?php if($access->edit_rights == 'y'){ ?>
                                                <a href="<?php echo SITE_URL; ?>admin/testimonials/index?token=<?php echo encrypt($testimonial->testimonial_id); ?>" class="btn btn-secondary">Edit</a> |
                                            <?php } ?>
                                            <?php if($access->delete_rights == 'y'){ ?>
                                                <input type="submit" name="testimonial_del_btn" id="testimonial_del_btn" class="btn btn-secondary" value="Delete" token="<?php echo encrypt($testimonial->testimonial_id); ?>">
                                            <?php } ?>
                                        </td>
                                    </tr>
                                    <?php
                                    $i++;
                                }
                                ?>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </section>
</div>