/* charityalbums table */
CREATE TABLE `charityalbums` (
  `album_id` int(20) NOT NULL,
  `album_name` text NOT NULL,
  `album_desc` text NOT NULL,
  `creation_date` date NOT NULL,
  `created_by` int(20) NOT NULL,
  `updation_date` date NOT NULL,
  `updated_by` int(20) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `charityalbums`
  ADD PRIMARY KEY (`album_id`);

ALTER TABLE `charityalbums` CHANGE `album_id` `album_id` INT(20) NOT NULL AUTO_INCREMENT;

/* charityimages table */
CREATE TABLE `charityimages` (
  `image_id` int(20) NOT NULL,
  `album_id` int(20) NOT NULL,
  `image_name` varchar(250) NOT NULL,
  `creation_date` date NOT NULL,
  `created_by` int(20) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `charityimages`
  ADD PRIMARY KEY (`image_id`);

ALTER TABLE `charityimages` CHANGE `image_id` `image_id` INT(20) NOT NULL AUTO_INCREMENT;

/* charitysliders table */
CREATE TABLE `charitysliders` (
  `slider_id` int(20) NOT NULL,
  `slider_title` text NOT NULL,
  `slider_desc` varchar(250) NOT NULL,
  `btn_title` text NOT NULL,
  `btn_link` varchar(250) NOT NULL,
  `slider_image` varchar(200) NOT NULL,
  `creation_date` date NOT NULL,
  `created_by` int(11) NOT NULL,
  `updation_date` date NOT NULL,
  `updated_by` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `charitysliders`
  ADD PRIMARY KEY (`slider_id`);

ALTER TABLE `charitysliders` CHANGE `slider_id` `slider_id` INT(20) NOT NULL AUTO_INCREMENT;

/* Add "publish" column in charitypages table */
ALTER TABLE `charitypages` ADD `publish` ENUM('y','n') NOT NULL AFTER `seo_keywords`;

/* Add "publish" column in charitysliders table  */
ALTER TABLE `charitysliders` ADD `publish` ENUM('y','n') NOT NULL AFTER `slider_image`;

/* Add "publish" column in charityalbums table  */
ALTER TABLE `charityalbums` ADD `publish` ENUM('y','n') NOT NULL AFTER `album_desc`;

/* Add "publish" column in charityblogs table  */
ALTER TABLE `charityblogs` ADD `publish` ENUM('y','n') NOT NULL AFTER `seo_keywords`;
ALTER TABLE `charityblogs` ADD `description` TEXT NOT NULL AFTER `title`;
ALTER TABLE `charityblogs` ADD `event_date` DATE NOT NULL AFTER `description`, ADD `event_time` TIME NOT NULL AFTER `event_date`;
ALTER TABLE `charityblogs` ADD `publish` ENUM('y','n') NOT NULL AFTER `seo_keywords`;

/* Add columns in charitysettings */
ALTER TABLE `charitysettings` ADD `smtp_user_name` TEXT NOT NULL AFTER `youtube_url`, ADD `smtp_host` TEXT NOT NULL AFTER `smtp_user_name`, ADD `smtp_password` TEXT NOT NULL AFTER `smtp_host`;

/* Add the following columns to charitysettings */
ALTER TABLE `charitysettings` ADD `fb_image` VARCHAR(250) NOT NULL AFTER `fb_url`;
ALTER TABLE `charitysettings` ADD `twitter_image` VARCHAR(250) NOT NULL AFTER `twitter_url`;
ALTER TABLE `charitysettings` ADD `linkedin_image` VARCHAR(250) NOT NULL AFTER `linkedIn_url`;
ALTER TABLE `charitysettings` ADD `youtube_image` VARCHAR(250) NOT NULL AFTER `youtube_url`;
ALTER TABLE `charitysettings` ADD `donate` TEXT NOT NULL AFTER `youtube_image`, ADD `find_us` TEXT NOT NULL AFTER `donate`, ADD `google_ad` TEXT NOT NULL AFTER `find_us`;

/* Make the following changes in charitysub_modules */
UPDATE `charitysub_modules` SET `sub_module_name` = 'Events' WHERE `charitysub_modules`.`sub_module_id` = 8;
UPDATE `charitysub_modules` SET `controller` = 'events' WHERE `charitysub_modules`.`sub_module_id` = 8;

/* Create new table charityevent_dates */
CREATE TABLE `charityevent_dates` (
  `date_id` int(20) NOT NULL,
  `event_id` int(20) NOT NULL,
  `event_date` date NOT NULL,
  `event_from_time` time NOT NULL,
  `event_to_time` time NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `charityevent_dates`
  ADD PRIMARY KEY (`date_id`);

ALTER TABLE `charityevent_dates` CHANGE `date_id` `date_id` INT(20) NOT NULL AUTO_INCREMENT;

/* Changes in charityevents */
RENAME TABLE `mattersofcommunity`.`charityblogs` TO `mattersofcommunity`.`charityevents`;
ALTER TABLE `charityevents` CHANGE `blog_id` `event_id` BIGINT(20) NOT NULL AUTO_INCREMENT;
ALTER TABLE `charityevents` ADD `event_image` VARCHAR(250) NOT NULL AFTER `content`;
ALTER TABLE `charityevents` DROP `event_date`, DROP `event_time`;
ALTER TABLE `charityevent_dates` ADD `creation_date` DATE NOT NULL AFTER `event_to_time`, 
    ADD `created_by` INT(20) NOT NULL AFTER `creation_date`, 
    ADD `updation_date` DATE NOT NULL AFTER `created_by`, 
    ADD `updated_by` INT(20) NOT NULL AFTER `updation_date`;


ALTER TABLE `charitypages` ADD `page_key` VARCHAR(100) NOT NULL AFTER `page_id`;


/* charitymenu */
CREATE TABLE `mattersofcommunity`.`charitymenu` ( 
    `menu_id` INT NOT NULL AUTO_INCREMENT , 
    `page_id` INT NOT NULL , 
    `dispInHeader` ENUM('y','n') NOT NULL , 
    `dispInFooter` ENUM('y','n') NOT NULL , 
    `updated_by` INT NOT NULL , 
    `updation_date` DATE NOT NULL , 
    PRIMARY KEY (`menu_id`)) ENGINE = InnoDB;

/* Add New sub module "Menu" */
INSERT INTO `charitysub_modules` (`sub_module_id`, `module_id`, `sub_module_name`, `controller`, `order`) VALUES ('9', '1', 'Menu', 'menu', '9');


ALTER TABLE `charitymenu` CHANGE `page_id` `page_key` TEXT NOT NULL;
ALTER TABLE `charitymenu` ADD `creation_date` DATE NOT NULL AFTER `dispInFooter`, ADD `created_by` INT NOT NULL AFTER `creation_date`;
ALTER TABLE `charitymenu` ADD `header_order` INT NOT NULL AFTER `dispInFooter`, ADD `footer_order` INT NOT NULL AFTER `header_order`

DROP TABLE `charitymenu`

ALTER TABLE `charityusers` ADD `user_type` ENUM('','sub-admin','user') NOT NULL AFTER `active`;

ALTER TABLE `charityblog_comments` ADD `approved` ENUM('','y','n') NOT NULL AFTER `user_id`;

