CATEGORY = {
    saveCategory: function (that) {
        $(that).validationEngine(ValidationOption);
        var result = $(that).validationEngine('validate');
        if (!result) {
            return false;
        }
        var formData = $(that).serialize();
        Loader.show();
        $.ajax({
            url: SITE_URL_ADMIN + "categories/saveCategory",
            dataType: "json",
            type: 'POST',
            data: formData,
            success: function (response) {
                Loader.hide();
                if (response.type == 'success') {
//                    AlertMessage.success(response.message);
                    redirect('admin/categories');
                } else {
                    AlertMessage.error(response.message);
                }
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    },
    deleteCategory: function (that) {
        var token = $(that).attr('token');
        $.ajax({
            url: SITE_URL_ADMIN + "categories/delCategory",
            dataType: "json",
            type: 'POST',
            data: {
                token: token
            },
            success: function (response) {
                Loader.hide();
                if (response.type == 'success') {
                    redirect('admin/categories');
                } else {
                    AlertMessage.error(response.message);
                }
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    },
    approveCategory: function (that) {
        var category_id = $(that).attr('c_data');
        $.ajax({
            url: SITE_URL_ADMIN + "categories/approveCategory",
            dataType: "json",
            type: "POST",
            data: {
                category_id: category_id
            },
            success: function (response) {
                Loader.hide();
                if (response.type == 'success') {
                    redirect('admin/categories');
                } else {
                    AlertMessage.error(response.message);
                }
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    }
}
$(document).on('submit', '#addCategory', function (e) {
    e.preventDefault();
    CATEGORY.saveCategory(this);
});
$(document).on('click', '.approveCat', function (e) {
    e.preventDefault();
    CATEGORY.approveCategory(this);
});
$(document).on('click', '#catDelBtn', function (e) {
    e.preventDefault();
    CATEGORY.deleteCategory(this);
});