SAVE_CAUSE = true;
CAUSE = {
    previewImage: function (that) {
        var fileList = that.files;
        var anyWindow = window.URL || window.webkitURL;
        $('#viewCauseImage').html('');
        for (var i = 0; i < fileList.length; i++) {
            var objectUrl = anyWindow.createObjectURL(fileList[i]);
            $('#viewCauseImage').append('<div class="col-md-2 img-container">\n\
                                        <img class="myImgClass" id="vewImg" src="' + objectUrl + '" height="200px" width="400px" /></div>');
            window.URL.revokeObjectURL(fileList[i]);
        }
    },
    saveUpdateCause: function (that) {
        var submit_btn = $('#add_cause_btn').val();
        if (submit_btn == 'Add') {
            $('#causeImage').attr('data-validation-engine="validate[required]" data-prompt-position="topLeft"');
        }
        var causeImg = $('#causeImage').val();
        var currentCauseImg = $('#currentCauseImage').val();
        if (causeImg != '' && submit_btn == 'Update') {
            alert('You have selected a new image for the cause.');
        }
        if (currentCauseImg != '') {
            $('#causeImage').removeAttr('data-validation-engine');
        }
        $(that).validationEngine(ValidationOption);
        var result = $(that).validationEngine('validate');
        if (!result) {
            return false;
        }
        var formData = new FormData(that);
        Loader.show();
        $.ajax({
            url: SITE_URL_ADMIN + "causes/addUpdateCause",
            type: 'POST',
            cache: false,
            processData: false,
            contentType: false,
            data: formData,
            dataType: 'json',
            success: function (response) {
                Loader.hide();
                if (response.type == 'success') {
//                    AlertMessage.success(response.message);
                    redirect('admin/causes');
                } else {
                    AlertMessage.error(response.message);
                    return false;
                }
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    },
    deleteCause: function (that) {
        var cId = $(that).attr('id_attr');
        if (confirm('Are you sure you want to delete this cause ? ')) {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "causes/delCause",
                type: "POST",
                dataType: "json",
                data: {
                    cId: cId
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
                        redirect('admin/causes');
                    }
                }
            });
        }
    },
    publishCause: function (that) {
        var cId = $(that).attr('id_attr');
        if (cId != '') {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "causes/publishCause",
                type: "POST",
                dataType: "json",
                data: {
                    cId: cId
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
                        redirect('admin/causes');
                    } else if(response.type == 'invalid_id') {
                        redirect('admin/dashboard');
                    } else {
                        AlertMessage.error(response.mmessage);
                        return false;
                    }
                }
            });
        }
    }
}
$(document).on('change', '#causeImage', function () {
    var img = $(this).prop('files')[0];
    var iSize = (img.size) / 1024;
    var size = Math.round(iSize * 100) / 100;
    if (size < 500) {
        SAVE_CAUSE = true;
        CAUSE.previewImage(this);
    } else {
        AlertMessage.error('The maximum size for an image is 500 kb. Please select a another image.');
        SAVE_CAUSE = false;
    }
});
$(document).on('submit', '#addCause', function (e) {
    e.preventDefault();
    if (SAVE_CAUSE) {
        CAUSE.saveUpdateCause(this);
    } else {
        AlertMessage.error('Could not save cause.');
    }
});
$(document).on('click', '#del_cause_btn', function (e) {
    e.preventDefault();
    CAUSE.deleteCause(this);
});
$(document).on('change', '#publishCheck', function (e) {
    e.preventDefault();
    CAUSE.publishCause(this);
});