COMMENTS = {
    getComments: function (blog_id) {
        Loader.show();
        $('#commentsDiv').show();
        $.ajax({
            url: SITE_URL_ADMIN + "comments/getComments",
            type: 'POST',
            data: {
                blog_id: blog_id
            },
            dataType: 'json',
            success: function (response) {
                Loader.hide();
                $('#commentsView').html(response.comments);
                $('#blogTitle').html(response.blog_title);
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    },
    approveComment: function (comment_id, blog_id) {
        if (comment_id != '') {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "comments/approveCmnt",
                type: 'POST',
                data: {
                    comment_id: comment_id
                },
                dataType: 'json',
                success: function (response) {
                    if (response.type == 'success') {
                        COMMENTS.getComments(blog_id);
                    } else if (response.type == 'invalid_id') {
                        redirect(SITE_URL_ADMIN + 'dashboard');
                    } else {
                        AlertMessage.error(response.message);
                        return false;
                    }
                },
                error: function (error) {
                    Loader.hide();
                    ajaxError(error);
                }
            });
        }
    },
    deleteComment: function (comment_id, blog_id) {
        if (comment_id != '') {
            if (confirm('Are you sure?')) {
                Loader.show();
                $.ajax({
                    url: SITE_URL_ADMIN + "comments/deleteCmnt",
                    type: 'POST',
                    data: {
                        comment_id: comment_id
                    },
                    dataType: 'json',
                    success: function (response) {
                        if (response.type == 'success') {
                            COMMENTS.getComments(blog_id);
                        } else if (response.type == 'invalid_id') {
                            redirect(SITE_URL_ADMIN + 'dashboard');
                        } else {
                            AlertMessage.error(response.message);
                            return false;
                        }
                    },
                    error: function (error) {
                        Loader.hide();
                        ajaxError(error);
                    }
                });
            }
        }
    }
}
$(document).on('click', '.viewComments', function (e) {
    e.preventDefault();
    var blog_id = $(this).attr('b_id');
    COMMENTS.getComments(blog_id);
});
$(document).on('click', '.approveCmnt', function (e) {
    e.preventDefault();
    var comment_id = $(this).attr('c_data');
    var blog_id = $(this).attr('b_id');
    COMMENTS.approveComment(comment_id, blog_id);
});
$(document).on('click', '.deleteCmnt', function (e) {
    e.preventDefault();
    var comment_id = $(this).attr('c_data');
    var blog_id = $(this).attr('b_id');
    COMMENTS.deleteComment(comment_id, blog_id);
});