MyFiles = [];
GALLERY = {
    filesToUpload: [],
    previewImages: function (that) {
        var fileList = that.files;
        for (var i = 0; i < fileList.length; i++) {
            this.filesToUpload.push(fileList[i]);
        }
//        console.log(this.filesToUpload);
        $('#viewImages').html('');
        var anyWindow = window.URL || window.webkitURL;
        for (var i = 0; i < this.filesToUpload.length; i++) {
            var objectUrl = anyWindow.createObjectURL(this.filesToUpload[i]);
            $('#viewImages').append('<div class="col-md-2 img-container">\n\
                                        <img class="myImgClass" id="vewImg' + i + '" src="' + objectUrl + '" height="200px" width="400px" data-name="' + this.filesToUpload[i].name + '" data-index/>\n\
                                        <a href="javascript:void(0);" data-index="' + i + '" class="removeUploadImg">\n\
                                            <img class="myCrossImg" imgName="' + this.filesToUpload[i].name + '" src="' + SITE_URL + 'skin/admin/images/close.png">\n\
                                        </a></div>'
                    );
            window.URL.revokeObjectURL(fileList[i]);
        }
    },
    addAlbum: function (that) {
        len = this.filesToUpload.length;
        var formData = new FormData(that);
        for (var i = 0; i < len; i++) {
            if (this.filesToUpload[i] != null) {
                formData.append("files[]", this.filesToUpload[i]);
            }
        }
        $(that).validationEngine(ValidationOption);
        var result = $(that).validationEngine('validate');
        if (!result) {
            return false;
        }
        if (GALLERY.checkImagesForSize()) {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "Gallery/addAlbum",
                type: 'POST',
                cache: false,
                processData: false,
                contentType: false,
                data: formData,
                dataType: 'json',
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
//                    AlertMessage.success(response.message);
                        redirect('admin/gallery');
                    } else {
                        AlertMessage.error(response.message);
                    }
                },
                error: function (error) {
                    Loader.hide();
                    ajaxError(error);
                }
            });
        }
    },
    removeImage: function (that) {
        var imageId = $(that).attr('imgid');
        if (imageId != '') {
            if (confirm('Are you sure you want to permanently delete this image from the album?')) {
                // Get album Id token from Query String
                var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1);
                var token = hashes.substr(hashes.indexOf("=") + 1);
                Loader.show();
                $.ajax({
                    url: SITE_URL_ADMIN + "Gallery/delImage",
                    type: "POST",
                    dataType: "json",
                    data: {
                        imageId: imageId
                    },
                    success: function (response) {
                        Loader.hide();
                        if (response.type == 'success') {
//                        AlertMessage.success(response.message);
                            window.location.replace(SITE_URL_ADMIN + "gallery?token=" + token);
                        }
                    }
                });
            }
        } else {
            $(that).prev().remove();
            $(that).remove();
        }
    },
    removeAlbum: function (that) {
        var album_id = $(that).attr('id_attr');
        if (confirm('All the image(s) in this album will be removed. Are you sure you want to delete this album?')) {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "gallery/deleteAlbum",
                type: "POST",
                dataType: "json",
                data: {
                    album_id: album_id
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
//                        AlertMessage.success(response.message);
                        redirect('admin/gallery');
                    }
                }
            });
        }
    },
    removeUploadImage: function (that) {
        var removeItem = $(that).attr('data-index');
        this.filesToUpload[removeItem] = null;
        $(that).prev().remove();
        $(that).remove();
    },
    checkImagesForSize: function () {
        var sizeFlag = true;
        $.each(this.filesToUpload, function (index, value) {
            if (value != null) {
                var iSize = (value.size) / 1024;
                var size = Math.round(iSize * 100) / 100;
                if (size > 5000) {
                    AlertMessage.error('Some images exceed the maximum limit of 500 kb.');
                    $('img[data-name="' + value.name + '"]').addClass('imageSizeExceeded');
                    sizeFlag = false;
                }
            }
        });
        return sizeFlag;
    }
}

$(document).on('submit', '#addAlbum', function (e) {
    e.preventDefault();
    GALLERY.addAlbum(this);
});
// On change applied to preview the images
$(document).on('change', '#albumImg', function () {
    GALLERY.previewImages(this);
});
$(document).on('click', '#removeImg', function () {
    GALLERY.removeImage(this);
});
$(document).on('click', '#del_album_btn', function () {
    GALLERY.removeAlbum(this);
});
$(document).on('click', '.removeUploadImg', function () {
    GALLERY.removeUploadImage(this);
});
$(function ()
{
    var t = $('#galleryTable').DataTable({
        "serverSide": true,
        "aaSorting": [],
        "ajax": {
            'url': SITE_URL_ADMIN + "gallery_server_script/index",
            'type': 'GET',
        },
        "columns": [
            {"name": "filterAlbumId", "orderable": true},
            {"name": "filterAlbumName", "orderable": true},
            {"name": "filterDescription", "orderable": true},
            {"name": "filterAlbumAction", "orderable": false},
        ],
    });
});