GROUP = {
    saveUpdateGroup: function (that) {
        $(that).validationEngine(ValidationOption);
        var result = $(that).validationEngine('validate');
        if (!result) {
            return false;
        }
        var formData = $(that).serialize();
        Loader.show();
        $.ajax({
            url: SITE_URL_ADMIN + "groups/addGroup",
            dataType: "json",
            type: 'POST',
            data: formData,
            success: function (response) {
                Loader.hide();
                if (response.type == 'success') {
//                    AlertMessage.success(response.message);
                    redirect('admin/groups');
                } else {
//                    AlertMessage.error(response.message);
                }
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    },
    deleteGroup: function (that) {
        var gId = $(that).attr('id_attr');
        if (confirm('Are you sure you want to delete this group ? ')) {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "groups/delGroup",
                type: "POST",
                dataType: "json",
                data: {
                    delGid: gId
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
//                        AlertMessage.success(response.message);
                        redirect('admin/groups');
                    } else {
                        AlertMessage.error(response.message);
                    }
                }
            });
        }
    }
}
$(document).on('submit', '#addGroup', function (e) {
    e.preventDefault();
    GROUP.saveUpdateGroup(this);
});
$(document).on('click', '#del_group_btn', function (e) {
    e.preventDefault();
    GROUP.deleteGroup(this);
});
$(function ()
{
    var t = $('#groupTable').DataTable({
        "serverSide": true,
        "aaSorting": [],
        "ajax": {
            'url': SITE_URL_ADMIN + "group_server_script/index",
            'type': 'GET',
        },
        "columns": [
            {"name": "filterGroupId", "orderable": true},
            {"name": "filterGroupName", "orderable": true},
            {"name": "filterGroupActive", "orderable": true},
            {"name": "filterGroupAction", "orderable": false},
        ],
    });
});