MENU = {
    getPagesLinks: function (that) {
        var val = that.value;
        if (val == 'link') {
            $('#linkUrl').show();
            $('#pagesDropDown').hide();
        } else if (val == 'page') {
            $('#pagesDropDown').show();
            $('#linkUrl').hide();
        } else {
            $('#linkUrl').hide();
            $('#pagesDropDown').hide();
        }
    },
    saveMenu: function (that) {
        $(that).validationEngine(ValidationOption);
        var result = $(that).validationEngine('validate');
        if (!result) {
            return false;
        }
        var formData = $(that).serialize();
        Loader.show();
        $.ajax({
            url: SITE_URL_ADMIN + "menu/saveMenu",
            dataType: "json",
            type: 'POST',
            data: formData,
            success: function (response) {
                Loader.hide();
                if (response.type == 'success') {
//                    AlertMessage.success(response.message);
                    redirect('admin/menu');
                } else {
                    AlertMessage.error(response.message);
                }
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    },
    deleteMenu: function (that) {
        var token = $(that).attr('token');
        if (confirm('Are you sure?')) {
            $.ajax({
                url: SITE_URL_ADMIN + "menu/delMenu",
                dataType: "json",
                type: 'POST',
                data: {
                    token: token
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
//                    AlertMessage.success(response.message);
                        redirect('admin/menu');
                    } else {
                        AlertMessage.error(response.message);
                    }
                },
                error: function (error) {
                    Loader.hide();
                    ajaxError(error);
                }
            });
        }
    },
    getParentMenuDiv: function (that) {
        var menuRegion = $(that).val();
        if (menuRegion == 'header') {
            $('#parentMenuDiv').show();
        } else if (menuRegion == 'footer') {
            $('#parentMenuDiv').hide();
        }
    }
}
$(document).on('change', '#menuType', function (e) {
    MENU.getPagesLinks(this);
});
$(document).on('change', '#menuRegion', function (e) {
    MENU.getParentMenuDiv(this);
});
$(document).on('submit', '#addMenu', function (e) {
    e.preventDefault();
    MENU.saveMenu(this);
});
$(document).on('click', '#menu_del_btn', function (e) {
    e.preventDefault();
    MENU.deleteMenu(this);
});
$(function () {
    var menuType = $('#menuType').val();
    if (menuType == 'link') {
        $('#linkUrl').show();
    } else if (menuType == 'page') {
        $('#pagesDropDown').show();
    }
    var menuRegion = $('#menuRegion').val();
    if (menuRegion == 'header') {
        $('#parentMenuDiv').show();
    } else if (menuRegion == 'footer') {
        $('#parentMenuDiv').hide();
    }
});
