/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
QUESTION = {
    saveQuestion: function (that) {
        var formData = $(that).serialize();
        Loader.show();
        $.ajax({
            url: SITE_URL_ADMIN + "questions/saveQuestion",
            dataType: "json",
            type: 'POST',
            data: formData,
            success: function (response) {
                Loader.hide();
                if (response.type == 'success') {
                    redirect('admin/questions');
                } else {
                    AlertMessage.error(response.message);
                    return false;
                }
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    },
    deleteQuestion: function (question_id) {
        if (confirm('Are you sure you want to delete this question?')) {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "questions/delQuestion",
                dataType: "json",
                type: 'POST',
                data: {
                    question_id: question_id
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
                        redirect('admin/questions');
                    } else {
                        AlertMessage.error(response.message);
                        return false;
                    }
                },
                error: function (error) {
                    Loader.hide();
                    ajaxError(error);
                }
            });
        }
    },
    approveQuestion: function (question_id) {
        if (question_id != '') {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "questions/apprQuestion",
                dataType: "json",
                type: 'POST',
                data: {
                    question_id: question_id
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
                        redirect('admin/questions');
                    } else {
                        AlertMessage.error(response.message);
                        return false;
                    }
                },
                error: function (error) {
                    Loader.hide();
                    ajaxError(error);
                }
            });
        }
    },
    getAllAnswers: function (question_id) {
        $.ajax({
            url: SITE_URL_ADMIN + "questions/getAllAnswers",
            dataType: "json",
            type: 'POST',
            data: {
                question_id: question_id
            },
            success: function (response) {
                Loader.hide();
                if (response.type == 'success') {
                    $('#answersDiv').html('');
                    $('#questionText').html('<h2>Q. ' + response.question + '</h2>');
                    $.each(response.answerData, function (i, item) {
                        $('#answersTemplate').tmpl(item).appendTo('#answersDiv');
                    });
                } else {
                    AlertMessage.error(response.message);
                    return false;
                }
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    },
    approveAnswer: function (question_id, answer_id) {
        if (answer_id != '') {
            $.ajax({
                url: SITE_URL_ADMIN + "questions/apprAnswer",
                dataType: "json",
                type: 'POST',
                data: {
                    answer_id: answer_id
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
                        QUESTION.getAllAnswers(question_id);
                    } else {
                        AlertMessage.error(response.message);
                        return false;
                    }
                },
                error: function (error) {
                    Loader.hide();
                    ajaxError(error);
                }
            });
        }
    }
}
$(document).on('submit', '#addQuestion', function (e) {
    e.preventDefault();
    QUESTION.saveQuestion(this);
});
$(document).on('change', '#pCategory', function (e) {
    e.preventDefault();
    var parent = $(this).val();
    QUESTION.getSubCategoriesLOne(parent);
});
$(document).on('change', '#subCategory', function (e) {
    e.preventDefault();
    QUESTION.getSubCategoriesLTwo(this);
});
$(document).on('click', '#quesDelBtn', function (e) {
    e.preventDefault();
    var question_id = $(this).attr('q_data');
    QUESTION.deleteQuestion(question_id);
});
$(document).on('click', '.approveQuestion', function (e) {
    e.preventDefault();
    var question_id = $(this).attr('q_data');
    QUESTION.approveQuestion(question_id);
});
$(document).on('click', '.getAllAnswers', function (e) {
    e.preventDefault();
    var question_id = $(this).attr('q_data');
    QUESTION.getAllAnswers(question_id);
});
$(document).on('click', '.approveAnswer', function (e) {
    e.preventDefault();
    var question_id = $(this).attr('q_data');
    var answer_id = $(this).attr('a_data');
    QUESTION.approveAnswer(question_id, answer_id);
});


$(function () {
    $('#newCategory').hide();
    $('#subCategoriesDiv').hide();
    // While editing a question
    // Check for the existence of query string
    var qryString = window.location.search;
    if (qryString != '') {
        $('#addQuestion').removeClass('collapse');
        var pCategory = $('#pCategory').val();
        var cCategory = $().val();
        if (pCategory == 'other') {
            $('#newCategory').show();
        } else {
            QUESTION.renderSubCategories(pCategory);
            $('#subCategoriesDiv').show();
        }
    } else {
        $('#addQuestion').addClass('collapse');
    }
    var t = $('#questionsTable').DataTable({
        "serverSide": true,
        "aaSorting": [],
        "ajax": {
            'url': SITE_URL_ADMIN + "questions_server_script/index",
            'type': 'GET',
        },
        "columns": [
            {"name": "filterQuestionId", "orderable": true},
            {"name": "filterQuesName", "orderable": true},
            {"name": "filterQuesApprovalStatus", "orderable": true},
            {"name": "filterQuesAskedBy", "orderable": false},
            {"name": "filterAnonymous", "orderable": true},
            {"name": "filterQuesAskedOn", "orderable": true},
            {"name": "filterQuesAction", "orderable": false},
        ],
    });
});