SAVE_SLIDER = true;
SLIDER = {
    previewImage: function (that) {
        var fileList = that.files;
        var anyWindow = window.URL || window.webkitURL;
        $('#viewSliderImage').html('');
        for (var i = 0; i < fileList.length; i++) {
            var objectUrl = anyWindow.createObjectURL(fileList[i]);
            $('#viewSliderImage').append('<div class="col-md-2 img-container">\n\
                                        <img class="myImgClass" id="vewImg" src="' + objectUrl + '" height="200px" width="400px" /></div>');
            window.URL.revokeObjectURL(fileList[i]);
        }
    },
    saveUpdateSlider: function (that) {
        var submit_btn = $('#add_slider_btn').val();
        if (submit_btn == 'Add') {
            $('#sliderImage').attr('data-validation-engine="validate[required]" data-prompt-position="topLeft"');
        }
        var sliderImg = $('#sliderImage').val();
        var currentSliderImg = $('#currentSliderImage').val();
        if (sliderImg != '' && submit_btn == 'Update') {
            alert('You have selected a new image for the slider.');
        }
        if (currentSliderImg != '') {
            $('#sliderImage').removeAttr('data-validation-engine');
        }
        $(that).validationEngine(ValidationOption);
        var result = $(that).validationEngine('validate');
        if (!result) {
            return false;
        }
        var formData = new FormData(that);
        Loader.show();
        $.ajax({
            url: SITE_URL_ADMIN + "slider/addUpdateSlider",
            type: 'POST',
            cache: false,
            processData: false,
            contentType: false,
            data: formData,
            dataType: 'json',
            success: function (response) {
                Loader.hide();
                if (response.type == 'success') {
//                    AlertMessage.success(response.message);
                    redirect('admin/slider');
                } else {
                    AlertMessage.error(response.message);
                }
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    },
    deleteSlider: function (that) {
        var sId = $(that).attr('id_attr');
        if (confirm('Are you sure you want to delete this slider ? ')) {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "slider/delSlider",
                type: "POST",
                dataType: "json",
                data: {
                    sId: sId
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
//                        AlertMessage.success(response.message);
                        redirect('admin/slider');
                    }
                }
            });
        }
    },
    buttonRequest: function () {
        var checked = $('#buttonRequest').prop('checked');
        if (checked) {
            $('#getButtonDetails').show();
            $('#buttonRequest').validationEngine(ValidationOption);
            var result = $('#buttonRequest').validationEngine('validate');
            if (!result) {
                return false;
            }
        } else {
            $('#buttonTitle').val('');
            $('#buttonLink').val('');
            $('#getButtonDetails').hide();
        }
    },
    publishSlider: function (that) {
        var sId = $(that).attr('id_attr');
        if (sId != '') {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "slider/pSlider",
                type: "POST",
                dataType: "json",
                data: {
                    sId: sId
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
                        redirect('admin/slider');
                    } else if (response.type == 'invalid_id') {
                        redirect('admin/dashboard');
                    } else {
                        AlertMessage.error(response.message);
                    }
                }
            });
        }
    }
}
$(document).on('change', '#sliderImage', function () {
    var img = $(this).prop('files')[0];
    var iSize = (img.size) / 1024;
    var size = Math.round(iSize * 100) / 100;
    if (size < 500) {
        SAVE_SLIDER = true;
        SLIDER.previewImage(this);
    } else {
        AlertMessage.error('The maximum size for an image is 500 kb. Please select a another image.');
        SAVE_SLIDER = false;
    }
});
$(document).on('submit', '#addSlider', function (e) {
    e.preventDefault();
    if (SAVE_SLIDER) {
        SLIDER.saveUpdateSlider(this);
    } else {
        AlertMessage.error('Could not save slider.');
    }
});
$(document).on('click', '#del_slider_btn', function (e) {
    e.preventDefault();
    SLIDER.deleteSlider(this);
});
$(document).on('change', '#buttonRequest', function (e) {
    e.preventDefault();
    SLIDER.buttonRequest();
});
$(function () {
    SLIDER.buttonRequest();
//    SLIDER.publishSlider();
});
$(document).on('change', '#publishCheck', function (e) {
    e.preventDefault();
    SLIDER.publishSlider(this);
});