TESTIMONIAL = {
    previewImage: function (that) {
        if (that.files && that.files[0]) {
            var reader = new FileReader();
            reader.onload = function (e) {
                $('#photoPreview').html('');
                $('#photoPreview').after('<img src="' + e.target.result + '" width="100%" height="200"/>');
            }
            reader.readAsDataURL(that.files[0]);
        }
    },
    saveTestimonial: function (that) {
        var formData = new FormData(that);
        Loader.show();
        $.ajax({
            url: SITE_URL_ADMIN + "testimonials/saveTestimonial",
            dataType: "json",
            type: 'POST',
            data: formData,
            processData: false,
            contentType: false,
            success: function (response) {
                Loader.hide();
                if (response.type == 'success') {
                    redirect('admin/testimonials');
                } else {
                    AlertMessage.error(response.message);
                }
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    },
    delTestimonial: function (that) {
        var testimonial_id = $(that).attr('token');
        if (confirm('Are you sure?')) {
            $.ajax({
                url: SITE_URL_ADMIN + "testimonials/delTestimonial",
                dataType: "json",
                type: 'POST',
                data: {
                    testimonial_id: testimonial_id
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
                        redirect('admin/testimonials');
                    } else {
                        AlertMessage.error(response.message);
                    }
                },
                error: function (error) {
                    Loader.hide();
                    ajaxError(error);
                }
            });
        }
    },
    approveTestimonial: function (that) {
        var t_id = $(that).attr('t_data');
        if (t_id != '') {
            $.ajax({
                url: SITE_URL_ADMIN + "testimonials/apprTestimonial",
                dataType: "json",
                type: 'POST',
                data: {
                    t_id: t_id
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
                        redirect('admin/testimonials');
                    } else if (response.type == 'invalid_id') {
                        redirect('admin/dashboard');
                    } else {
                        AlertMessage.error(response.message);
                    }
                },
                error: function (error) {
                    Loader.hide();
                    ajaxError(error);
                }
            });
        }
    }
}

$(document).on('submit', '#addTestimonial', function (e) {
    e.preventDefault();
    TESTIMONIAL.saveTestimonial(this);
});
$(document).on('change', '#photo', function () {
    TESTIMONIAL.previewImage(this);
});
$(document).on('click', '#testimonial_del_btn', function (e) {
    e.preventDefault();
    TESTIMONIAL.delTestimonial(this);
});
$(document).on('click', '.approveTestimonial', function (e) {
    e.preventDefault();
    TESTIMONIAL.approveTestimonial(this);
});