USER = {
    saveUpdateUser: function (that) {
        $(that).validationEngine(ValidationOption);
        var result = $(that).validationEngine('validate');
        if (!result) {
            return false;
        }
        var formData = $(that).serialize();
        Loader.show();
        $.ajax({
            url: SITE_URL_ADMIN + "users/addUser",
            dataType: "json",
            type: 'POST',
            data: formData,
            success: function (response) {
                Loader.hide();
                if (response.type == 'success') {
//                    AlertMessage.success(response.message);
                    redirect('admin/users');
                } else {
                    AlertMessage.error(response.message);
                }
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    },
    deleteUser: function (that) {
        var uId = $(that).attr('id_attr');
        if (confirm('Are you sure you want to delete this user ? ')) {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "users/delUser",
                type: "POST",
                dataType: "json",
                data: {
                    delUid: uId
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
//                        AlertMessage.success(response.message);
                        redirect('admin/users');
                    }
                }
            });
        }
    }
}
$(document).on('submit', '#addUser', function (e) {
    e.preventDefault();
    USER.saveUpdateUser(this);
});
$(document).on('click', '#del_user_btn', function (e) {
    e.preventDefault();
    USER.deleteUser(this);
});
$(function ()
{
    var t = $('#userTable').DataTable({
        "serverSide": true,
        "aaSorting": [],
        "ajax": {
            'url': SITE_URL_ADMIN + "users_server_script/index",
            'type': 'GET',
        },
        "columns": [
            {"name": "filterUserId", "orderable": true},
            {"name": "filterUserName", "orderable": true},
            {"name": "filterName", "orderable": true},
            {"name": "filterGroupAssigned", "orderable": true},
            {"name": "filterEmail", "orderable": true},
            {"name": "filterActive", "orderable": true},
            {"name": "filterAction", "orderable": false},
        ],
    });
    var t = $('#siteUserTable').DataTable({
        "serverSide": true,
        "aaSorting": [],
        "ajax": {
            'url': SITE_URL_ADMIN + "site_users_server_script/index",
            'type': 'GET',
        },
        "columns": [
            {"name": "filterOtherUserId", "orderable": true},
            {"name": "filterOtherUserName", "orderable": true},
            {"name": "filterOtherName", "orderable": true},
            {"name": "filterOtherEmail", "orderable": true},
        ],
    });
});