SAVE_WIDGET = true;
WIDGET = {
    previewImage: function (that) {
        var fileList = that.files;
        var anyWindow = window.URL || window.webkitURL;
        $('#viewWidgetImage').html('');
        for (var i = 0; i < fileList.length; i++) {
            var objectUrl = anyWindow.createObjectURL(fileList[i]);
            $('#viewWidgetImage').append('<div class="col-md-2 img-container">\n\
                                        <img class="myImgClass" id="vewImg" src="' + objectUrl + '" height="200px" width="400px" /></div>');
            window.URL.revokeObjectURL(fileList[i]);
        }
    },
    saveUpdateWidget: function (that) {
        var submit_btn = $('#add_widget_btn').val();
        if (submit_btn == 'Add') {
            $('#widgetImage').attr('data-validation-engine="validate[required]" data-prompt-position="topLeft"');
        }
        var widgetImg = $('#widgetImage').val();
        var currentWidgetImg = $('#currentWidgetImage').val();
        if (widgetImg != '' && submit_btn == 'Update') {
            alert('You have selected a new image for the widget.');
        }
        if (currentWidgetImg != '') {
            $('#widgetImage').removeAttr('data-validation-engine');
        }
        $(that).validationEngine(ValidationOption);
        var result = $(that).validationEngine('validate');
        if (!result) {
            return false;
        }
        var formData = new FormData(that);
        Loader.show();
        $.ajax({
            url: SITE_URL_ADMIN + "widgets/addUpdateWidget",
            type: 'POST',
            cache: false,
            processData: false,
            contentType: false,
            data: formData,
            dataType: 'json',
            success: function (response) {
                Loader.hide();
                if (response.type == 'success') {
                    redirect('admin/widgets');
                } else {
                    AlertMessage.error(response.message);
                }
            },
            error: function (error) {
                Loader.hide();
                ajaxError(error);
            }
        });
    },
    deleteWidget: function (that) {
        var wId = $(that).attr('id_attr');
        if (confirm('Are you sure you want to delete this widget ? ')) {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "widgets/delWidget",
                type: "POST",
                dataType: "json",
                data: {
                    wId: wId
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
                        redirect('admin/widgets');
                    }
                }
            });
        }
    },
    publishWidget: function (that) {
        var wId = $(that).attr('id_attr');
        if (wId != '') {
            Loader.show();
            $.ajax({
                url: SITE_URL_ADMIN + "widgets/publishWidget",
                type: "POST",
                dataType: "json",
                data: {
                    wId: wId
                },
                success: function (response) {
                    Loader.hide();
                    if (response.type == 'success') {
                        redirect('admin/widgets');
                    }
                }
            });
        }
    }
}
$(document).on('change', '#widgetImage', function () {
    var img = $(this).prop('files')[0];
    var iSize = (img.size) / 1024;
    var size = Math.round(iSize * 100) / 100;
    if (size < 500) {
        SAVE_WIDGET = true;
        WIDGET.previewImage(this);
    } else {
        AlertMessage.error('The maximum size for an image is 500 kb. Please select a another image.');
        SAVE_WIDGET = false;
    }
});
$(document).on('submit', '#addWidget', function (e) {
    e.preventDefault();
    if (SAVE_WIDGET) {
        WIDGET.saveUpdateWidget(this);
    } else {
        AlertMessage.error('Could not save widget.');
    }
});
$(document).on('click', '#del_widget_btn', function (e) {
    e.preventDefault();
    WIDGET.deleteWidget(this);
});
$(document).on('change', '#publishCheck', function (e) {
    e.preventDefault();
    WIDGET.publishWidget(this);
});