var SelectOption = {minimumResultsForSearch: -1};
var SelectOption = {minimumResultsForSearch: -1};
var ValidationOption = {
	maxErrorsPerField: 1,
	inlineValidation: true,
	autoHidePrompt: true,
	autoHideDelay: 5000,	
};
var ScrollBarOptions = {advanced: {updateOnContentResize: true}};
var ViewEllipsis = {
	init: function (container) {
		var that = this;
		container.find('.text-ellipsis').each(function () {
			var ellipsis = $(this);
			ellipsis.append('<a class="link-view-all" href="#"><span class="open-ellipsis">  View All</span><span class="close-ellipsis">  Close</span></a>');
			that.createDots(ellipsis);
			ellipsis.on('click', 'a.link-view-all', function () {
				ellipsis.toggleClass('ellipsis-removed');
				if (ellipsis.hasClass('ellipsis-removed')) {
					that.destroyDots(ellipsis);
				} else {
					that.createDots(ellipsis);
				}
				return false;
			});
		});
	},
	createDots: function (ellipsis) {
		ellipsis.dotdotdot({
			after: 'a.link-view-all',
			watch: true
		});
	},
	destroyDots: function (ellipsis) {
		ellipsis.trigger('destroy');
	}
};
var pre = function (item) {
	console.log(item);
}
var Loader = {};
$(function () {
	Loader = {
		loaddiv: $('.loader'),
		show: function () {
			this.overlay();
			this.loaderHTML();
		},
		hide: function () {
			$('.overlay-sub,.form-processing').remove();
		},
		fullShow: function () {
			var valid = $("form").validationEngine('validate');
			if (valid === true) {
				this.overlay();
				this.loaderHTML();
			}
		},
		fullShowNoValid: function () {
			this.overlay();
			this.loaderHTML();
		},
		fullHide: function () {
			$('.overlay-sub,.form-processing').remove();
		},
		overlay: function () {
			$('.overlay-sub').remove();
			var subDiv = $('<div class="overlay-sub"></div>');
			$('body').append(subDiv);
			$('.overlay-sub').height($(document).height());
		},
		loaderHTML: function () {
			$('.form-processing').remove();
			var html = '';
			html += '<div class="form-processing">';
			html += '<div class="loader-image"></div>'
			html += '</div>';
			$('body').append(html);
		},
		setMinHeight: function () {
			var t = $('.main-header').height() + $('.main-footer').height();
			var d = $(document).height();
			$('.content-wrapper').css({'min-height': (d - t - 31) + 'px'});
		}
	};
	Loader.setMinHeight();
});
var numbers = function (key) {
	var elem;
	if (key.srcElement)
		elem = key.srcElement;
	else if (key.target)
		elem = key.target;
	//getting key code of pressed key
	var keycode = (key.which) ? key.which : key.keyCode;
	if (keycode == 46) {
		return true;
	}
	if (keycode == 13) {
		return false;
	}
	//comparing pressed keycodes
	if (keycode > 31 && (keycode < 48 || keycode > 57) && keycode != 46) {
		return false;
	} else {
		elem = elem.value.toString();
		if (elem.match(/[\.]/) && keycode == 46) {
			return false;
		} else {
			return true;
		}
	}
};
function genGoalId(g) {
	if (typeof (g) != 'undefined') {
		return g.replace('=', '');
	}
	return g;
}
var numbersOnly = function (key) {
	var elem;
	if (key.srcElement)
		elem = key.srcElement;
	else if (key.target)
		elem = key.target;
	//getting key code of pressed key
	var keycode = (key.which) ? key.which : key.keyCode;
	if (keycode == 46) {
		//return true;
	}
	if (keycode > 31 && (keycode < 48 || keycode > 57)) {
		return false;
	}
	return true;
};
var ajaxError = function (error) {
	Loader.hide();
	Loader.fullHide();
	console.info(error);
	if (error.statusText == 'Unauthorized') {
		var json = JSON.parse(error.responseText);
		AlertMessage.error(json.message);
	} else {
		AlertMessage.error(error.responseText);
	}
}
var AlertMessage = {
	timeout: '',
	container: $('#info-messages'),
	init: function (type, text) {
		this.container = $('#info-messages');
		$('.alert').remove();
		var html = '\
			<div class="alert alert-' + type + '">\
				<a href="javascript:void(0);" class="close" aria-label="close">&times;</a>\
				' + text + '\
			</div>';
		this.container.append(html);
		this.container.fadeIn("slow");
		this.container.addClass('display-message');
	},
	success: function (text) {
		this.init('success', text);
		AlertMessage.autoClose();
	},
	warning: function (text) {
		this.init('warning', text);
		AlertMessage.autoClose();
	},
	error: function (text) {
		this.init('danger', text);
		AlertMessage.autoClose();
	},
	info: function (text) {
		this.init('info', text);
		AlertMessage.autoClose();
	},
	close: function () {
		this.container.removeClass('display-message');
		clearTimeout(this.timeout);
		this.timeout = setTimeout(function () {
			$('.alert').remove();
		}, 12000);
	},
	autoClose: function () {
		clearTimeout(this.timeout);
		setTimeout(function () {
			AlertMessage.close();
		}, 12000);
	}
}
var CountCircles = ['label-green', 'label-blue', 'label-violet', 'label-pink', 'label-coral', 'label-seegreen', 'label-hotpink', 'label-purple', 'label-aquamarine', 'label-brown', 'label-chocolate', 'label-darkorange', 'label-deeppink'];
var CountCirclesOriginal = ['label-green', 'label-blue', 'label-violet', 'label-pink', 'label-coral', 'label-seegreen', 'label-hotpink', 'label-purple', 'label-aquamarine', 'label-brown', 'label-chocolate', 'label-darkorange', 'label-deeppink'];
var AppliedCircles = [];
var pick_circle = function () {
	var l = AppliedCircles.length;
	var c = '';
	if (l <= 0 || l >= 13) {
		CountCircles = CountCirclesOriginal;
		AppliedCircles = [];
		c = CountCircles[0];
		AppliedCircles.push(c);
	} else if (l > 0 && l <= 13) {
		l = l + 1;
		c = CountCircles[0];
		AppliedCircles.push(c);
	}
	CountCircles = delAr(CountCircles, 0);
	return c;
};
var delAr = function (arr, index) {
	var newAr = [];
	for (var i = 0; i < arr.length; i++) {
		if (i != index) {
			newAr.push(arr[i]);
		}
	}
	return newAr;
}
function uniqId() {
	return Math.round(new Date().getTime() + (Math.random() * 100));
}
var cval = function (v) {
	return v == '' ? 0 : rval(v);
}
function rand() {
	return Math.random() * 1000000000000000;
}
function redirect(url) {
	window.location.href = SITE_URL + url;
}
function redirect_main(url) {
	window.location.href = url;
}
function nl2br(text) {
	return text.replace(/\r?\n/g, '<br />');
}
$(document).on('click', '#info-messages .close', function () {
	AlertMessage.close();
});
/** display session message */

$(function () {
	var text = $('#sessionMessage>div').html();
	var cla = $('#sessionMessage>div').attr('class');
	if (text != '') {
		if (cla == 'success') {
			AlertMessage.success(text);
		} else if (cla == 'error') {
			AlertMessage.error(text);
		}
	}
});

function rval(v) {
	return isNaN(v) ? 0 : around(v);
}
function gval(v) {
	return isNaN(v) ? 0 : around(v);
}
function around(v) {
	res = '';
	v = parseFloat(v).toPrecision(12);
	v = v.toString();
	u = v.split('.');
	if (typeof (u[1]) != 'undefined') {
		res = u[1].substring(0, 2);
		res = u[0] + '.' + res;
	} else {
		res = u[0];
	}
	return parseFloat(res);
}
var validateRating = function (v) {
	if (!v.match(/^\d{0,2}[.]?\d{0,2}$/) || v.match(/^[0]\d+\.*$/)) {
		v = parseFloat(v);
		v = around(v);
	}
	else if (isNaN(parseFloat(v))) {
		return 0
	}
	if (v > 5) {
		v = 5.0;
	} else if (v == '') {
		v = '';
	}
	return v;
}
var validateGoal = function (v) {
	if (!v.match(/^\d{0,2}[.]?\d{0,2}$/) || v.match(/^[0]\d+\.*$/)) {
		v = parseFloat(v);
		v = around(v);
	}
	else if (isNaN(parseFloat(v))) {
		return 0;
	}
	if (v > 100) {
		v = 100;
	} else if (v == '') {
		v = '';
	}
	return v;
}
function decodeEntities(input) {
	return $("<textarea/>").html(input).val();
}
$("#select option").mouseup(function () {
	$(this).parent().val($(this).attr("value"));
});
var SetActive = function (that) {
	that.closest('ul').find('li').removeClass('active');
	that.closest('li').addClass('active');
}
var setFocusOnAccordion = function (that) {
	var offset = that.offset();
	if (offset) {
		$('html,body').animate({scrollTop: offset.top}, 500);
	}
}


