<?php
/*
 * Name:
 * Author:
 * Date:
 */
include "../application/libraries/jsmin.php";
$path = "";
if(!isset($_GET['js'])){
	return '';
}
$files = explode(",", $_GET['js']);
$missing = array();
$cache = '';
foreach($files as $index => $file){
	if(strtolower(substr($file, -2)) != 'js'){
		unset($files[$index]);
	}
	else if(file_exists($path.$file)){
		$cache .= $file;
		$cache .= filemtime($path.$file);
	}
	else{
		$missing[] = $file;
		unset($files[$index]);
	}
}
$cache = 'cache/'.md5($cache);
if(count($missing)){
	header("Content-type: text/javascript");
	header("Pragma: no-cache");
	header("Cache-Control: no-cache");
	echo "alert('Could not load the following javascript source files:\\n\\n- ".implode("\\n- ", $missing)."\\n\\nJavascript not loaded / running!');";
	exit;
}
if(count($files)){
	// create cached version if not present
	if(!file_exists($cache)){
		$js = '';
		foreach($files as $file){
			$js .= JSMin::minify(file_get_contents($path.$file));
		}
		chmod('cache',0777);
		file_put_contents($cache, $js);
	}
	// calculate last-modified & etag send caching headers
	$last_modified_time = filemtime($cache);
	$etag = md5_file($cache);
	header("Content-type: text/javascript");
	header("Pragma: public");
	header("Cache-Control: public");
	header("Last-Modified: ".gmdate("D, d M Y H:i:s", $last_modified_time)." GMT");
	header("Etag: ".$etag);

	$HTTP_IF_MODIFIED_SINCE = isset($_SERVER['HTTP_IF_MODIFIED_SINCE']) ? $_SERVER['HTTP_IF_MODIFIED_SINCE'] : '';
	$HTTP_IF_NONE_MATCH = isset($_SERVER['HTTP_IF_NONE_MATCH']) ? $_SERVER['HTTP_IF_NONE_MATCH'] : '';
	if(@strtotime($HTTP_IF_MODIFIED_SINCE) == $last_modified_time || trim($HTTP_IF_NONE_MATCH) == $etag){
		header("HTTP/1.1 304 Not Modified");
		exit;
	}
	readfile($cache);
}